/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 /*
			EMIL
                   MODULE: BACKVIEW.C                                  
                                                                       
    Gestion de la fonction Scroll-Back dans la session.                
*/

/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur ala...
#endif
/*--------------------------------------------------------*/




#include <sys/stat.h>
#include <fcntl.h>
#include <ncurses.h>

#include "emil.h"

#include "touches.h"
#include "couleurs.h"
#include "config.h"
#include "clavecra.h"
#include "backview.h"
#include <string.h>

byte *BackBuff;


unsigned  StartData,
          EndData,
          BackCount;

unsigned  SizeBackBuff=20000; /* taille du buffer backlog */

#ifndef LINUX
struct LigneType
           {
            byte Texte[82];
            struct LigneType far *Avant;
            struct LigneType far *Apres;
           };

struct LigneType far *LigneDeb,*LigneFin,*LignePred;

#endif
extern  byte MinX,MinY,MaxX,MaxY,CurX,CurY,NumPort,Printing;


/*
         Bon, en gros...
         Les modules terminal_machin remplissent un tampon circulaire
         avec  peu prs ce qui arrive a l'cran.

         Pour visualiser facilement ce tampon,je cre une liste chaine
         de lignes,ces lignes tant extraites du tampon en considrant
         comme fin de ligne: un CR/LF, un CR tout seul ou un LF tout
         seul. Une ligne plus longue que l'ecran est aussi coupe en
         deux.

         Ca bouffe peut tre de la mmoire mais pour faire le viewer
         c'etait bien plus simple.

         Par contre pour la sauvegarde sur disque, c'est le tampon
         lui mme qui est utilis.
         Le fichier est ouvert en mode append; ca peut rendre service.

         La taille max du tampon est un int, meme si c'est des unsigneds
         qui sont utiliss, c'est plus simple a cause du write et de
         toutes faons  hein...
*/



/*--------------------------------------------------------------------------*/
/*          Initialisation du buffer de backlog.                            */

int AllocBackBuff(void)
{
#ifndef LINUX
   if(SizeBackBuff >32700) SizeBackBuff=32700;
                                                     /* Tout de meme, on ne */
                                                     /* va pas se crr des */
                                                     /* ennuis non...?      */
   BackBuff=(byte far *)farmalloc(SizeBackBuff +1 );
     if(BackBuff==NULL) return(0);

   memset((byte far *)BackBuff,0,SizeBackBuff +1 );
   StartData = 0;
   EndData   = 0;
   BackCount = 0;
#endif
   return(1);
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*  Mise en place d'un caractere dans le tampon de backlog.                 */

void BackPutc(byte *ch)
{
#ifndef LINUX
   if(BackCount < SizeBackBuff)
     {
       BackBuff[EndData]=*ch;
       EndData++;
       BackCount++;
     }
   else
     {
      BackCount=SizeBackBuff;       /* pour etre peinard */
      StartData++;
      if(StartData >SizeBackBuff)
        {
          StartData=0;
        }

      EndData++;
      if(EndData >SizeBackBuff)
        {
          EndData=0;
        }
      BackBuff[EndData]=*ch;
     }
     #endif
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*  Suppression du dernier caractere (del) dans le tampon de backlog.       */

void BackDelc(void)
{
#ifndef LINUX
if(EndData<1) EndData=SizeBackBuff;
else EndData--;

if(BackCount < SizeBackBuff) BackCount--;
#endif
}
/*--------------------------------------------------------------------------*/

#ifndef LINUX

/*--------------------------------------------------------------------------*/
/* Pour simplifier,incrementation dans le tampon.                           */

unsigned SuccBuff(unsigned position)
{
  if(position==SizeBackBuff)return(0);
  return(position+1);
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*            Rcupre une ligne,normalement de gauche  droite.            */
/*--------------------------------------------------------------------------*/
/*
        La Fin de ligne est soit un toujours le 0x0D,soit un 0x0A.
        Si il y a les deux,c'est le 0x0A qui est pris en compte.

        Un 0x0D seul compte aussi comme nouvelle ligne, et une ligne
        trop longue sera wrappee a la position MaxX.

        La fonction renvoie le nouveau dplacement correspondant au
        premier caractre de la prochaine ligne dans le buffer.
*/
unsigned GetLine(byte far *tampon,unsigned CurPos)
{
unsigned int i,j;

i=CurPos;
j=0;

memset(tampon,0,MaxX+1);               /* nettoie la place... */
while(1)
     {
     if(i==EndData)break;
     if(BackBuff[i]==0x0A)             /* LF seul */
         return(SuccBuff(i));
     if(BackBuff[i]==0x0D)             /* CR LF ou CR SEUL */
       {
         i=SuccBuff(i);
         if(i==EndData)break;
         if(BackBuff[i]==0x0A)
           return(SuccBuff(i));
         else return(i);
       }
     tampon[j]=BackBuff[i];
     j++;
     if(j > MaxX)break;                /* trop long... nouvelle ligne.*/
     i=SuccBuff(i);
     }
return(i);
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*           Ecriture du tampon sur disque                                  */
/*--------------------------------------------------------------------------*/

void SauveTampon(void)
{
 int SaveFile;
 byte SaveName[64];

      box(5,10,70,13,blanc_bleu);
      mwrite(10,10," Sauver ce Tampon dans le fichier: ",Inverse);
      if((saisie(6,12,SaveName,blanc_bleu,63,NEW)==ESC)||(!*SaveName))
         {
           return;  /* pas de nom ou saisie abandonne */
         }

     SaveFile=open(SaveName,O_RDWR|O_BINARY|O_CREAT|O_APPEND,S_IREAD|S_IWRITE);
     if(SaveFile==-1)
      {
        beep(2);
        mwrite(10,11,"Impossible d'ouvrir ce fichier!",Blanc_bleu + BLINK);
        delay(1500);
        return;
      }

      box(10,9,30,14,Jaune_vert);
      mwrite(15,11,"Ecriture...",Blanc_vert);

     if(StartData==0)      /* La, c'est simple... */
       {
         write(SaveFile,BackBuff,EndData);
       }
     else                  /* Moins vident...    */
       {
         write(SaveFile,&BackBuff[StartData],SizeBackBuff-StartData);
           if(EndData)   /* Pourrait etre nul...*/
         write(SaveFile,BackBuff,EndData);
       }

    close(SaveFile);
}
/*--------------------------------------------------------------------------*/





/*--------------------------------------------------------------------------*/
/*                        libration mmoire de la liste.                   */
/*--------------------------------------------------------------------------*/

void FreeListe(int nombre)
{
 struct LigneType far *Ptr;
 int nb=nombre;

if(nb<1)return;
Ptr=LigneDeb;
while(nb)
     {
       Ptr=Ptr->Apres;
       farfree(Ptr->Avant);
       nb--;
     }
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*             Cree une liste chainee des lignes du tampon                  */
/*
                   Retourne le nombre de lignes trouves, ou -2 si
                   l'allocation mmoire n'a pu tre ralise.
*/
int CreListe(void)
{
unsigned Deb;
register int i;
struct LigneType far *Ptr;

Deb=StartData;
i=0;

LigneDeb=(struct LigneType *)farmalloc(sizeof( *LigneDeb));
if(LigneDeb==NULL) return(-2);
LignePred=LigneFin=LigneDeb;

while(1)
     {
        if(Deb==EndData)break;
        Ptr=LigneFin;
        Deb=GetLine(Ptr->Texte,Deb);
        i++;

        LigneFin=(struct LigneType *)farmalloc(sizeof( *LigneFin));
        if(LigneFin==NULL)
          {
            if(i>1) FreeListe(i-1);
            return(-2);
          }

        Ptr->Avant=LignePred;
        Ptr->Apres=LigneFin;
        LignePred=Ptr;
    }
return(i-1);
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*             Visualisation du contenu du buffer BackBuff...               */
/*--------------------------------------------------------------------------*/
/*
                Ceci est le 'lister' proprement dit.
*/

void BackView(void)
{
static byte Fleches[]={24,25,0};
static byte DebTxt[] ="* Dbut du Tampon *";
static byte FinTxt[] ="* Fin  du  Tampon *";
static byte Gomme[]  ="                   ";
 byte Attribut= cyan;     /* couleur d'criture */
 int NbLignes,
     PosCur,
     i,j;
 struct LigneType far *Ptr,
       *Last,
       *DebEcran,
       *FinEcran;

                       /* Ecriture ligne de statut */
   sauvecran();
   curseur(0);
   cls_win(Attribut);
   for(i=MinX;i<=MaxX;i++)mwrite(i,MaxY," ",Blanc_bleu);
   mwrite(MinX,   MaxY,   " BbtH:Replay...",Jaune_bleu);
   mwrite(MinX+16,MaxY,   "PgUp,PgDn,"      ,Blanc_bleu);
   mwrite(MinX+26,MaxY,    Fleches          ,Blanc_bleu);
   mwrite(MinX+29,MaxY,   ",Home,End"      ,Blanc_bleu);
   mwrite(MinX+58,MaxY,   "S:Sauve en fichier",Blanc_bleu);

   mwrite(15,15," Ca vient,a vient, je mouline... ",Normal);

NbLignes=CreListe();
if(NbLignes==-2)
   {
    mwrite(10,10,"Manque de mmoire ",Inverse);
    getch();
    rendecran();
    return;
   }

Ptr=LigneDeb;                            /* va au bout de la liste */
for(i=0;i < NbLignes;i++)Ptr=Ptr->Apres;
Last=Ptr;

cls_win(Attribut);
for(i=0;i< MaxY-1;i++)                  /* Premier affichage       */
   {
     if(i > NbLignes)break;
     mwrite(0,MaxY-1-i,Ptr->Texte,Attribut);
     Ptr=Ptr->Avant;
   }
FinEcran=Last;
DebEcran=Ptr;
PosCur=NbLignes;


while(1)
       {
       switch(touche())
             {
                case ESC:
                   FreeListe(NbLignes);
                   rendecran();
                   curseur(1);
                   if(Printing) Printing=0; /* Pas me casser avec sauvecran...*/
                return;

                case 'S':
                case 's':
                   SauveTampon();
                   FreeListe(NbLignes);
                   rendecran();
                   curseur(1);
                return;


                case HAUT:
                  if(PosCur-(MaxY-1) <= 0 )
                     {
                       mwrite(39,MaxY,DebTxt,Inverse);
                     }
                   else
                     {
                       mwrite(39,MaxY,Gomme,Blanc_bleu);
                       DebEcran=DebEcran->Avant;
                       FinEcran=FinEcran->Avant;
                       Scroll_down(1,MinX,MinY,MaxX,MaxY-1);
                       mwrite(MinX,MinY,DebEcran->Texte,Attribut);
                       PosCur--;
                     }
                break;

                case BAS:
                   if(PosCur >=NbLignes)
                     {
                       mwrite(39,MaxY,FinTxt,Inverse);
                     }
                   else
                     {
                       mwrite(39,MaxY,Gomme,Blanc_bleu);
                       DebEcran=DebEcran->Apres;
                       FinEcran=FinEcran->Apres;
                       Scroll_up(1,MinX,MinY,MaxX,MaxY-1);
                       mwrite(MinX,MaxY-1,FinEcran->Texte,Attribut);
                       PosCur++;
                     }
                break;

                case HOME:
                  cls_win(Attribut);
                  Ptr=LigneDeb;
                  for(i=0;i< MaxY-1;i++)
                     {
                       if(i > NbLignes)break;
                        mwrite(0,i,Ptr->Texte,Attribut);
                       Ptr=Ptr->Apres;
                     }
                  FinEcran=Ptr;
                  DebEcran=LigneDeb;
                  PosCur=i;
                  mwrite(39,MaxY,DebTxt,Inverse);
                break;


                case END:  /* Meme cas que le premier affichage.*/
                  cls_win(Attribut);
                  Ptr=Last;
                  for(i=0;i< MaxY-1;i++)
                     {
                       if(i > NbLignes)break;
                        mwrite(0,MaxY-1-i,Ptr->Texte,Attribut);
                       Ptr=Ptr->Avant;
                     }
                  FinEcran=Last;
                  DebEcran=Ptr;
                  PosCur=NbLignes;
                  mwrite(39,MaxY,FinTxt,Inverse);
                break;


                case PGUP:  /* Je fais autant de fois "HAUT" */
                 for(j=0;j<MaxY-2;j++)
                     {
                      if(PosCur-(MaxY-1) <= 0 )
                         {
                           mwrite(39,MaxY,DebTxt,Inverse);
                         }
                       else
                         {
                           mwrite(39,MaxY,Gomme,Blanc_bleu);
                           DebEcran=DebEcran->Avant;
                           FinEcran=FinEcran->Avant;
                           Scroll_down(1,MinX,MinY,MaxX,MaxY-1);
                           mwrite(MinX,MinY,DebEcran->Texte,Attribut);
                           PosCur--;
                         }
                     }
                break;

                case PGDN: /* Je fais autant de fois "BAS" */
                  for(j=0;j< MaxY-2;j++)
                     {
                       if(PosCur >=NbLignes)
                         {
                           mwrite(39,MaxY,FinTxt,Inverse);
                         }
                       else
                         {
                           mwrite(39,MaxY,Gomme,Blanc_bleu);
                           DebEcran=DebEcran->Apres;
                           FinEcran=FinEcran->Apres;
                           Scroll_up(1,MinX,MinY,MaxX,MaxY-1);
                           mwrite(MinX,MaxY-1,FinEcran->Texte,Attribut);
                           PosCur++;
                         }
                     }
                break;

             }
       }
}
/*--------------------------------------------------------------------------*/


#endif