/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
			EMIL                                                                      
                MODULE: CLAVECRAN                                     
                 -----------------                                     
                                                                      
   Diverses fonctions de controle ECRAN et CLAVIER         
                                                                        
                                                                           
*/

/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur la...
#endif
/*--------------------------------------------------------*/


#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <ncurses.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <term.h>





#include "emil.h"
#include "clavecra.h"
#include "touches.h"
#include "couleurs.h"
#include "config.h"
#include "system.h"
#include "backview.h"
#include "fonction.h"


byte FlagCouleur;              /* presence d'une carte couleur        */
byte CurX    = 0;              /* Position courante du curseur,colonne*/
byte CurY    = 0;              /* Position courante du curseur,ligne  */
byte CurAttr = 7;              /* Attribut courant d'ecriture         */
byte MaxX    = 79;             /* Nombre de colonnes max sur l'ecran  */
byte MaxY    = 24 ;            /* Nombre de lignes max sur l'ecran    */
byte MinX    = 0;              /* Coordonnee minimum horizontale      */
byte MinY    = 0;              /* Coordonnee minimum verticale        */



byte tabul[]={0,8,16,24,32,40,48,56,64,72,80,88,96,104,112,120,128,136,144};
/* les tabulations de 8... une methode originale...evitant calculs... */


extern byte MinVtX,MinVtY,MaxVtX,MaxVtY;

extern byte *__Version__;

/* a remettre extern	*/

byte AnsiInsChar;


extern byte logtrace,CrLfTrans;
extern struct ConfigType Config;
byte Savex,Savey,EGA_43=0;
byte FlagDel=1;


char *mytty, *ttyname(), *term, *getenv(), *sys_name;
WINDOW *Win;
/* pour ncurses */
extern WINDOW *initscr(void);
extern int savetty(void);
extern int raw(void);
extern int noecho(void);
extern int nl(void);
extern int clearok();

#define DELAY_TIME	10 

extern WINDOW *win_std;
extern WINDOW *win_stat;
extern WINDOW *win1;
extern WINDOW *win2;
extern WINDOW *win_vtx;

extern int videotex_term;


int xmc;	/* magic_cookie_glitch de term.h */

/*--------------------------------------------------------------------------*/
/*              FONCTIONS DE CONTROLE DE L'ECRAN                            */
/*--------------------------------------------------------------------------*/

/* Fonction Locate(ligne,colonne) en mode texte  */

void locate(WINDOW *window,byte Xpos,byte Ypos)
{
   wmove(window,Ypos,Xpos);   
   wrefresh(window);
   CurX=Xpos;
   CurY=Ypos;
 }

/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* scrolls due nombre de lignes voulues dans la fenetre voulue               */
/*---------------------------------------------------------------------------*/

void Scroll_up(WINDOW *window,byte nombre,byte X1,byte Y1,byte X2,byte Y2)
{
	debug("Scroll_up()");
	wscrl(window,nombre);
	wattrset(window,FlagCouleur ? COLOR_PAIR(blanc_bleu) | A_BOLD : Normal );
        wrefresh(window);
 	curseur(1);
 }


void Scroll_down(WINDOW *window,byte nombre,byte X1,byte Y1,byte X2,byte Y2)
{
	debug("Scroll_down()");
	wscrl(window,-nombre);
	wattrset(window,FlagCouleur ? COLOR_PAIR(blanc_bleu) | A_BOLD : Normal );
        wrefresh(window);
	curseur(1);
}
/*---------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*  Gestion nombre de lignes pour carte EGA                                 */
/*--------------------------------------------------------------------------*/
void ega_43(void)                         /* passe la carte ega en 43 lignes*/
{
   curseur(1);
}

                     /*----------------------------------*/

void ega_25(void)                       /* Repasse la carte ega en 25 lignes*/
{
  curseur(1);
}
/*--------------------------------------------------------------------------*/

/*	sortie du programme avec un code errorlevel 	*/
void cleanup(int val)
{
touchwin(win_std);
wclear(win_std);
wrefresh(win_std);

endwin();
exit(val);

}


void quit()
{
void cleanup();
cleanup(1);
}


/*---------------------------------------------------------------------------*/
/*           identification de l'ecran et mise en place du pointeur ad hoc   */
/*---------------------------------------------------------------------------*/
void test_video(void)
{

	int i;
	debug("test_video()");
        term = getenv("TERM");
        if (term == NULL || *term == '\0') {
           fprintf(stderr, "Emil %s\nFenetrage non supporte (TERM non defini)\n",__Version__);
           exit(1); }
        setupterm(term, 1, &i);
	debug(term);
        if (i != 1) {
           fprintf(stderr, "Emil %s\nFenetrage non supporte (Pas de donnees sur \"%s\")\n",__Version__,term);
           exit(1);  }
        if (COLS < 80 || LINES < 24) {
           fprintf(stderr, "Emil %s\nFenetrage non supporte (minimum 80x24)\n",__Version__);
           exit(1);}
           
        MaxX = COLS - 1;
        MaxY = LINES - 1;   
	if (cursor_address == NULL) {
		fprintf(stderr, "Emil Fenetrage non Supporte (terminal trop reduit)\n");
		exit(1);
	}

        xmc = magic_cookie_glitch;
        
        signal(SIGINT,quit);
        signal(SIGQUIT,quit);
        signal(SIGTERM,quit);
        signal(SIGHUP,quit);
        def_shell_mode();
        initscr();
#ifdef COULEUR        
        if (! has_colors())	{
           debug("test_video() Couleur FALSE");
            FlagCouleur=FALSE ;
            }
        else
           {
           debug("test_video() Couleur TRUE");
           start_color();
           FlagCouleur=TRUE;    
           for (i = 1; i < COLOR_PAIRS; i++)
                init_pair(i, i % COLORS, i / COLORS);
	   }
#else
	FlagCouleur=FALSE;
#endif	      
	        
	savetty();
	nonl();
        noecho();
        cbreak();
/*
        raw();
        keypad(stdscr,TRUE);
        clearok(stdscr,OK);
        scrollok(stdscr,TRUE);
        refresh();
*/
	refresh();
        fflush(stdin);
        fflush(stdout);
	         

}
/*---------------------------------------------------------------------------*/

/* Fonction cls:effacement de tout l'cran texte .Je ne prends pas la        */
/* fonction scroll du bios habituelle,elle pose des problmes au bout de 2   */
/* ou 3 appels sur la carte de mon micral portable...                        */


void cls(WINDOW *w,int attrib)
{
   int att=attrib;
   debug("cls()");
   if ( att >= 100 ) 	{
	   att -=100;
	   wattrset(w,FlagCouleur ? COLOR_PAIR(att) | A_BOLD: att);
	   }
   else
 	   wattrset(w,FlagCouleur ? COLOR_PAIR(att) : att );
  		   
   wclear(w); 
   
   locate(w,0,0);
   curseur(1); /* au cas ou il ait disparu... */
}
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/

void curseur(int presence)           /* syntaxe:curseur(0)=eteint|(1)=allume */
{
   curs_set(presence);
}
/*--------------------------------------------------------------------------*/





/*--------------------------------------------------------------------------*/
/*      ECRITURE DANS LA VIDEO            */
/*--------------------------------------------------------------------------*/
/*
      Ecrit une chaine directement,avec l'attribut precis,sans modifier
      la position x et y courantes.
*/
void mwrite(WINDOW *window,byte colonne,byte ligne,byte *chaine,int attrib)
{
int att=attrib;
	if (FlagCouleur)	{
		if (att < 100 )	
			wattrset(window,COLOR_PAIR(att));
		else	{
			att -=100;
			wattrset(window,COLOR_PAIR(att) | A_BOLD);
			}							
	}			
	mvwaddstr(window,ligne,colonne,chaine); 
	/*
	att=attrib;
	if (FlagCouleur)	{
		if (att < 100 )	
			wattroff(window,COLOR_PAIR(att));
		else	{
			att -=100;
			wattroff(window,COLOR_PAIR(att) | A_BOLD);
			}							
	}			
	*/
/*	wattron(window,A_NORMAL);	*/
        wmove(window,ligne,colonne);           
        wrefresh(window);
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*     Positionne un chr                                                    */
/*--------------------------------------------------------------------------*/
/*
     Ecrit un caractere en memoire video a la position courante et e
     l'attribut courant.
     Incremente la position courante d'une unite,scrolle l'ecran en
     haut a partir de la derniere ligne.
     Conserve la derniere ligne du bas pour le statut,d'ou les MaxY-1
*/
void mputc(WINDOW *window,byte ch)
{
   mvwaddch(window,CurY,CurX,ch);  /* ncurses      */
   wrefresh(window);
   CurX++;
   if(CurX >MaxX)
      {
        CurX=0;
        CurY++;
        if(CurY > MaxY-1)
           {
             Scroll_up(window,1,MinX,MinY,MaxX,MaxY-1);
             CurY=MaxY-1;
           }

      }
   wmove(window,CurY,CurX);
   wrefresh(window);
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*     Lit un caractere                                    */
/*--------------------------------------------------------------------------*/
/*
     Retourne le caractere situe en Xpos,Ypos.
*/
byte mgetc(WINDOW *window,byte Xpos,byte Ypos)
{
    return  mvwgetch(window,Ypos,Xpos);  /* ncurses      */
}



/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*        saisie d'un caractere au clavier; test si fonction        */
/*--------------------------------------------------------------------------*/
int touche(WINDOW *w,int etat)
{
   int ch;
   keypad(w,TRUE);
   nodelay(w,etat);
   ch=wgetch(w);
   if (ch==0x0a) ch=0xd; /* ???? */
   if (ch !=-1)    debugxc(ch,"touche() ch");
   return(ch);
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*            Simulation d'un ecran de terminal TTY                         */
/*--------------------------------------------------------------------------*/
void tty(WINDOW *window,byte ch)
{
   register int i;
/*	   int Start,Stop;	*/
   switch(ch)
      {
        case 0x0d: /* Retour CHariot */
         {
 	        
           BackPutc(&ch);
           CurX=MinX;
           locate(window,CurX,CurY);
           /*if(CrLfTrans) tty(0x0A);*/ /* rajoute un lf si trans */
         }
         break;


        case 0x0A: /* Line-feed */
         {
         BackPutc(&ch);
         CurY++;
         if(CurY > MaxY-1) /* A cause status line... */
            {
              Scroll_up(window,1,MinX,MinY,MaxX,MaxY-1);
              CurY=MaxY-1;
            }
         locate(window,CurX,CurY);
         }
         break;


         case 8:      /* Backspace */
         {
         if(CurX > MinX)
            {
            CurX--;
            if(FlagDel)      /* Retour destructif,sauf pour */
               {             /* 1 coup, pour la fleche pave */
                 mputc(window,ESPACE);  /* numerique en ANSI-BBS       */
                 BackDelc();
                 CurX--;
               }
            FlagDel=1;
            locate(window,CurX,CurY);
            }
         }
         break;

         case 9: /* tabulation de merde */
          for(i=0; *(tabul+i) < MaxX; i++)
              if (*(tabul+i) > CurX) break;
          if (*(tabul+i) > MaxX)  i = 0;

          while (CurX != *(tabul+i))
                {
                   mputc(window,ESPACE);
                   BackPutc(&ch);
                }
        break;  /* marrant,non ?*/

        case 7:     /* La cloche j'avais oubli ca !!! */
         beep();	/* ncurses	*/
        break;


        case 32:
         BackPutc(&ch);
          if(FlagDel)               /* cas normal */
          {
             mputc(window,ch);
             /* if(logtrace==1)LogPutc(ch);*/ /* Fichier log actif */
             return;
          }
          CurX++;                /* cas pour pave numerique ansi */
          if(CurX > MaxX)CurX=MaxX;
          FlagDel=1;
          locate(window,CurX,CurY);
       break;

       default:
         {
          mputc(window,ch);
          BackPutc(&ch);
         }
      }
 /*if(logtrace==1)LogPutc(ch);*/ /* Fichier log actif */
}
/*---------------------------------------------------------------------------*/





/*---------------------------------------------------------------------------*/
/*           Saisie d'une chaine avec touches de fonctions.                  */
/*---------------------------------------------------------------------------*/

int saisie(WINDOW *w,int x,int y,byte *buffer,int attribut,int Maximum,int KeepOld)
{
   int indice=0;
   int max=0;
   int ch;
   int fin=0;
   byte saveX,saveY;
   
   curseur(1);
   saveX=CurX;
   saveY=CurY;
   debug2ic(CurX,CurY,"saisie() CurX,CurY");
   debug2ic(x,y,"saisie() x,y");
   
   wmove(w,y,x);

   /* on marque la zone de saisie       */
   for (indice=0; indice < Maximum ; indice ++ )
        mwrite(w,x+indice,y," ",attribut);
   indice=0;
                 

   if(KeepOld) { /* On edite ce qu'il y a dans le buffer quand on arrive */
         indice=strlen(buffer);
         max=indice;
         mwrite(w,x,y,buffer,attribut);
         debug2ic(x+indice,y,"saisie() x+indice,y");
         locate(w,x+indice,y);
      }
      else {
          for (indice=0; indice < Maximum ; indice ++ )
             mwrite(w,x+indice,y," ",attribut);
          indice=0;       
          locate(w,x,y);     
      }
      
      

   while(!fin)  {
      ch=touche(w,FALSE);
      debugcc(ch,"saisie() ch");
      switch(ch)
         {
          case ESC:	     /*------------------- abandon par Escape    */
             *buffer=0;
             debug2ic(saveX,saveY,"saisie() Escape savex,savey");
             locate(w,saveX,saveY);
             return(ESC);    

          case RETOUR:           /*--------------------fin normale de saisie */
             debug2ic(saveX,saveY,"saisie() Retour savex,savey");
             locate(w,saveX,saveY);
             return(RETOUR); 
          
          case BAS :
              debug2ic(saveX,saveY,"saisie() Bas savex,savey");
              locate(w,saveX,saveY);
              return(BAS);
          case HAUT :
              debug2ic(saveX,saveY,"saisie() Haut savex,savey");
              locate(w,saveX,saveY);
              return(HAUT);

          case BACK :             /*------------------- touche correction     */
               if(!indice)continue;        /* autorisee en fin de chaine */
               if(indice != max )continue; /* seulement !                */
               indice--;
               max--;
               buffer[indice]=0;
               debug2ic(x+indice,y,"saisie() Baskspace espace x+indice,y");
               mwrite(w,x+indice,y," ",attribut); 
               debug2ic(x+indice-1,y,"saisie() Baskspace Pos x+indice-1,y");
               locate(w,x+indice-1,y);
               break;

          case GAUCHE :  
               if(!indice)continue;
               indice--;
               debug2ic(x+indice,y,"saisie() Gauche x+indice,y");
               locate(w,x+indice,y);
               break;

          case DROITE:   
               if(max==indice)continue;
               indice++;
               debug2ic(x+indice,y,"saisie() Droite x+indice,y");
               locate(w,x+indice,y);
               break;


          case HOME:           
               indice=0;
               debug2ic(x,y,"saisie() Home x,y");
               locate(w,x,y);
               break;

          case END:            
               indice=max;
               debug2ic(x+indice,y,"saisie() End x+indice,y");
               locate(w,x+indice,y);
               break;

          case DELETE:          /*-----------------------touche "Delete"     */
              if(max==0)continue;
              /*mwrite(x,y,buffer,0);*/ /* efface la chaine */
              if(indice==max)
               {
                  indice--;
                  max--;
                  buffer[indice]=0;
               }
             else
               {
                  memmove(buffer+indice,buffer+indice+1,1+max - indice );
                  max--;
               }
              debug2ic(x,y,"saisie() Delete buffer x,y");
              mwrite(w,x,y,buffer,attribut);
              debug2ic(x+max,y,"saisie() Delete espace x+max,y");
              mwrite(w,x+max,y," ",attribut);
              debug2ic(x+indice,y,"saisie() Delete pos x+indice,y");
              locate(w,x+indice,y);
              break;


          default:                           /* caractere normal ,rajout */
             debug("saisie() default"); 
             if(ch >1000)continue;           /* touches fct non traites */
             if(max==Maximum)                /* depassement taille maxi  */
               {
	          beep();	/* ncurses	*/
		  mwrite(w,x+max,y," ",attribut);
                  if (indice==max)indice=max-1;
                  buffer[indice]=(char) ch;
                  buffer[max+1]=0;
                  mwrite(w,y,x,buffer,attribut);
                  locate(w,x+max-1,y);
                  continue;
               }
             if(indice==max)
               {
                   buffer[indice]=(char) ch;
                   buffer[indice+1]=0;
                   debugsc(buffer,"saisie() 1 buffer");
                   indice++;
                   max++;
                   debug2ic(x,y,"saisie() 1 default x,y");
                   mwrite(w,x,y,buffer,attribut);
               }
             else                   /* on sera en insertion tout le temps */
               { 
                   debug("saisie() memmove");
                   memmove(buffer+indice+1,buffer+indice,1+max - indice );
                   buffer[indice]=(char) ch;
                   indice++;
                   max++;
                   debugsc(buffer,"saisie() 2 buffer");
                   debug2ic(x,y,"saisie() 2 default x,y");
                   mwrite(w,x,y,buffer,attribut);
                   
               }
            debug2ic(x+indice,y,"saisie() wmove x+indice,y");
            wmove(w,y,x+indice);
         }/* du swich */

      }/* du while */
  debug2ic(saveX,saveY,"saisie() loacte final savex,savey");
 locate(w,saveX,saveY);
 return(0);
}
/*---------------------------------------------------------------------------*/






/*---------------------------------------------------------------------------*/
/* sauvegarde & restitution de tout l'cran texte dans le buffer (global)    */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
void sauvecran(void)
{
fixterm();

}

void rendecran(void)
{
}
/*--------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Efface la fenetre de travail en gardant la ligne de status en bas         */

void cls_win(WINDOW *window,int attrib)
{
   if ( attrib >= 100 ) 	{
	   attrib -=100;
	   wattrset(window,FlagCouleur ? COLOR_PAIR(attrib) | A_BOLD: attrib);
	   }
   else
 	   wattrset(window,FlagCouleur ? COLOR_PAIR(attrib) : attrib );
   werase(window);    /* ncurses      */
   wrefresh(window);
   locate(window,MinX,MinY);
   curseur(1); /* au cas ou il ait disparu... */
}
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* efface du curseur a la fin de la ligne                                    */

void DelEol(WINDOW *window, int	 couleur)
{
        wclrtoeol(window);     /* ncurses      */
}

/*---------------------------------------------------------------------------*/
/* efface du debut de la ligne au curseur                                    */

void DelSol(WINDOW *window,int couleur)
{
        wclrtobot(window);		/* ncurses	*/
}


/*---------------------------------------------------------------------------*/
/* efface du debut de la ligne au curseur                                    */

void DelLine(WINDOW *window,int couleur)
{
        wdeleteln(window); /* ncurses     */
}

/*---------------------------------------------------------------------------*/
/* Efface la fin de l'ecran     en gardant la ligne de status en bas         */

void DelEos(WINDOW *window,int attribut)
{
        werase(window);    /* ncurses      */
   curseur(1); /* au cas ou il ait disparu... */
}
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Efface le debut de l'ecran                                                */

void DelSos(WINDOW *window,int attribut)
{
        wclrtobot(window); /* ncurses      */

   curseur(1); /* au cas ou il ait disparu... */
}
/*---------------------------------------------------------------------------*/


void
error_win(code, line_one, line_two)
int code;
char *line_one, *line_two;
{
	WINDOW *e_win;
	void cleanup(), st_line();

        debugsc(line_one,"error_win()");					/* make sure we're in curses mode */
	curseur(1);
	e_win = Creer_Win(7, 70, 9, 5,TRUE,FlagCouleur? Jaune_rouge : Inverse);
	
					/* display the nasty note */
     
	mwrite(e_win, 4,2, line_one,FlagCouleur? Jaune_rouge : Inverse);
	mwrite(e_win, 4,3, line_two,FlagCouleur? Jaune_rouge : Inverse);

	if (code) {
		mwrite(e_win, 4, 0, " Erreur ",FlagCouleur? Jaune_rouge : Inverse);
		mwrite(e_win, 24,5,  "Presser sur une touche pour quitter",FlagCouleur ? noir_blanc : Inverse);
		locate(e_win, 46,5);
	}
	else {
		mwrite(e_win, 4, 0, " Attention ",FlagCouleur? Jaune_rouge : Inverse);
		mwrite(e_win, 22, 5,"Presser sur une touche pour continuer",FlagCouleur ? Noir_blanc : Inverse);
		locate(e_win, 48, 5);
	}
	beep();
	touche(e_win,FALSE);
	Effacer_Win(e_win,TRUE);
	reinit_win();
	if (code) cleanup(code);
	return;
}


WINDOW *Creer_Win(int ligne, int colonne, int beginy, int beginx ,int boite,int attrib)
{
WINDOW *w;
int att=attrib;
	debug("Creer_Win()");

	w = newwin(ligne, colonne, beginy, beginx);
	if (has_colors())	{
	 	if (att < 100 )wattrset(w,COLOR_PAIR(att));
	 	else { att -=100; wattrset(w,COLOR_PAIR(att)|A_BOLD);}
         	}
        else
         	wattrset(w,att);
        werase(w);	
	if (boite) box(w, 0, 0);
	wrefresh(w);
	return(w);
}

	
WINDOW *Creer_SubWin(int ligne, int colonne, int beginy, int beginx , int boite,int attrib,WINDOW *w_parent)
{
WINDOW *w;
int att=attrib;
	debug("Creer_SubWin()");

	w = subwin(w_parent,ligne, colonne, beginy, beginx);
	if (has_colors())	{
	 	if (att < 100 )wattrset(w,COLOR_PAIR(att));
	 	else { att -=100; wattrset(w,COLOR_PAIR(att)|A_BOLD);}
         	}
        else
         	wattrset(w,att);
        werase(w);
	if (boite) box(w, 0, 0);
	wrefresh(w);
	return(w);
}	
	

void Effacer_Win(WINDOW *w,int efface)
{
	debug("Effacer_Win()");
	if (efface) werase(w);
	wrefresh(w);
	delwin(w);
	if (xmc) fix_xmc();
}

static void fix_xmc()
{
	WINDOW *cl_win, *newwin();

	/*
	 * Since the cookie got shifted off the window, we have to
	 * create a new window to cover where the cookie ended up.
	 */
	cl_win = newwin(1, 2, 4, 78);
					/* have to touch, otherwise nothing! */
	touchwin(cl_win);
	wrefresh(cl_win);
	delwin(cl_win);

	return;
}
