/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
                                                                        
			EMIL

                   MODULE: COMMPKG.C                                     
                   -----------------                                     
                                                                         
      Gestion des Ports Serie.       ATTENTION !                         
      Ce module a ete modifie pour les besoins de Emil                
      en pompant allegrement dans minicom !                                                                  
                                                                         
*/

#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur la...
#endif

#include <stdio.h>
#include <stdlib.h>
#include <termio.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <varargs.h>
#include <ctype.h>
#include <utmp.h>
#include <getopt.h>
#include <memory.h>
#include <setjmp.h> 
#include <ncurses.h>
#include <strings.h>
#include <unistd.h>
#include <pwd.h>

#include "emil.h"
#include "config.h"
#include "commpkg.h"


extern char *Program_Name;
extern char *__Version__;

char Lockfile[256];		/* nom du fichier de lock	*/

char Lockdir[128]=LOCK_DIR;

int real_uid;
int real_gid;

char username[32];		/* nom de l'utilisateur	*/

int portuid, portgid;

short portfd;

static jmp_buf albuf;

#define EMPTY '\0'
static char cbuf=EMPTY;

void error_win();

/*--------------------------------------*/
/* fonction specifique pour unix	*/
/*--------------------------------------*/

/* initialise le user name	*/

void init_user()
{
struct passwd *pwd;
real_uid=getuid();
real_gid=getgid();
if ((pwd = getpwuid(real_uid))== (struct passwd *)0 )	{
	error_win(1,"Vous n'avez pas d'acces sur cette machine !"," ");
	exit(1);
	}
   strcpy(username,pwd->pw_name);
   debugsc(username,"init_user()");
}


#ifndef BASENAME
/* recupere la base du nom du device	*/
char *basename(char *s)
{
char *p;
if ((p=strrchr(s,'/'))==(char *) NULL)
    p=s;
else
    p++;
return(p);    
}
#endif

/* pour les alarmes	*/
static void get_alrm(int dummy)
{
(void)dummy;

longjmp(albuf,1);
}


/* Positionne RTS ON. Specifique a linux ??? */
void m_setrts(int fd)
{
  int mcs;
  debug("m_setrts()");
  ioctl(fd, TIOCMGET, &mcs);
  mcs |= TIOCM_RTS;
  ioctl(fd, TIOCMSET, &mcs);
}



/* config du device de comm	*/
void m_setparms(int fd,char *baudr,char *par, char *bits, int hwf,int swf)
{
  int spd = -1;	/* la vitesse en bauds	*/
  int newbaud;
  struct termios tty;

  debug("m_setparms()");

  tcgetattr(fd, &tty);
  /* Check if 'baudr' is really a number */
  if ((newbaud = atoi(baudr)) == 0 && baudr[0] != '0') newbaud = -1;
  switch(newbaud) {
  	case 0:
#ifdef B0
			spd = B0;	break;
#else
			spd = 0;	break;
#endif
  	case 300:	spd = B300;	break;
  	case 600:	spd = B600;	break;
  	case 1200:	spd = B1200;	break;
  	case 2400:	spd = B2400;	break;
  	case 4800:	spd = B4800;	break;
  	case 9600:	spd = B9600;	break;
#ifdef B19200
  	case 19200:	spd = B19200;	break;
#else
#ifdef EXTA
	case 19200:	spd = EXTA;	break;
#else
	case 19200:	spd = B9600;	break;
#endif	
#endif	
#ifdef B38400
  	case 38400:	spd = B38400;	break;
#else
#ifdef EXTA
	case 38400:	spd = EXTA;	break;
#else
	case 38400:	spd = B9600;	break;
#endif
#endif	

  }
  debugic(spd,"m_setparms() speed");
  
  if (spd != -1) {
	cfsetospeed(&tty, (speed_t)spd);
	cfsetispeed(&tty, (speed_t)spd);
  }

  debugcc(bits[0],"m_setparms() bits");

  switch (bits[0]) {
  	case '5':
  		tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS5;
  		break;
  	case '6':
  		tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS6;
  		break;
  	case '7':
  		tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS7;
  		break;
  	case '8':
	default:
  		tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS8;
  		break;
  }		
  /* Set into raw, no echo mode */
  tty.c_iflag &= ~(IGNBRK | IGNCR | INLCR | ICRNL | IUCLC | 
  	IXANY | IXON | IXOFF | INPCK | ISTRIP);
  tty.c_iflag |= (BRKINT | IGNPAR);
  tty.c_oflag &= ~OPOST;
  tty.c_lflag = ~(ICANON | ISIG | ECHO | ECHONL | ECHOE | ECHOK);
  tty.c_cflag |= CREAD | CRTSCTS;
  tty.c_cc[VMIN] = 1;
  tty.c_cc[VTIME] = 5;

  /* Flow control. */
  if (!hwf) tty.c_cflag &= ~CRTSCTS;
  if (swf) tty.c_iflag |= IXON;

  tty.c_cflag &= ~(PARENB | PARODD);
  
  debugcc(par[0],"m_setparms() parite");

  if (par[0] == 'E')  	{
	tty.c_cflag |= PARENB;
	}
  else if (par[0] =='O') {
	tty.c_cflag |= PARODD;
	}
  tcsetattr(fd, TCSANOW, &tty);
  m_setrts(fd);
}




/*
 * Tombe le signal DTR.
*/
void m_dtrtoggle(int fd) 
{
  struct termios tty, old;
  debug("m_dtrtoggle()");
  tcgetattr(fd, &tty);
  tcgetattr(fd, &old);
  cfsetospeed(&tty, B0);
  cfsetispeed(&tty, B0);
  tcsetattr(fd, TCSANOW, &tty);
  sleep(1);
  tcsetattr(fd, TCSANOW, &old);
}

/*
 * Envoi un break en ligne
 */
void m_break(int fd)
{ 
  debug("m_break()");
  ioctl(fd, TCSBRK, 0);
}

/*
 * Get the dcd status
 */
int m_getdcd(int fd)
{
  int mcs;
/*  debug("m_getdcd()");	*/
  ioctl(fd, TIOCMGET, &mcs);
  return(mcs & TIOCM_CAR ? 1 : 0);
}

/*
 * Set the DCD status
 */
/*ARGSUSED*/
void m_setdcd(int fd,int what)
{
  /* Shut up compilers. */
  
  debug("m_setdcd()");
  (void)fd;
  (void)what;
}



static struct termios Savetty;

/*
 * Save the state of a port
 */
void m_savestate(int fd)
{
  debug("m_savestate()");
  tcgetattr(fd, &Savetty);
}

/*
 * Restore the state of a port
 */
void m_restorestate(int fd)
{
  debug("m_restorestate()");
  tcsetattr(fd, TCSANOW, &Savetty);
}

/*
 * Set the line status so that it will not kill our process
 * if the line hangs up.
 */
/*ARGSUSED*/ 
void m_nohang(int fd)
{
  struct termios sgg;
  
  debug("m_nohang()");
  tcgetattr(fd, &sgg);
  sgg.c_cflag |= CLOCAL;
  tcsetattr(fd, TCSANOW, &sgg);
}


/*
 * Set hangup on close on/off.
 */
void m_hupcl(int fd,int on)
{
  /* Eh, I don't know how to do this under BSD (yet..) */
  struct termios sgg;
  
  debug("m_hupcl()");
  tcgetattr(fd, &sgg);
  if (on)
  	sgg.c_cflag |= HUPCL;
  else
	sgg.c_cflag &= ~HUPCL;
  tcsetattr(fd, TCSANOW, &sgg);
}

/*
 * Flush the buffers
 */
void m_flush(int fd)
{
/* Should I Posixify this, or not? */
debug("m_flush()");
#ifdef TCFLSH
  ioctl(fd, TCFLSH, 2);
#endif
#ifdef TIOCFLUSH
  ioctl(fd, TIOCFLUSH, (void *)0);
#endif
}


void setblock(int fd,bool on)
{
static int blockf, nonblockf;
static bool first = TRUE;
int flags;
debug("setblock()");
if (first) {
	first=FALSE;
	if ((flags=fcntl(fd,F_GETFL,0))==-1)
		fprintf(stderr,"\nErreur sur fcntl 1");
	blockf= flags &~ O_NDELAY;
	nonblockf=flags | O_NDELAY;
	}
if (fcntl(fd,F_SETFL,on ? blockf :nonblockf)==-1)
	fprintf(stderr,"\nErreur sur fcntl 2");
}





/*
                     Open a given communication port                         
                     pompe dans minicom 
*/
bool         OpenCom (char *PortNumber,
int BaudRate,       
char Parity,
char Data,
char Stop,
int CtrlFlux_Hard,
int CtrlFlux_Soft)
   {
   struct stat stt;
   char buf[128];
   char baud[12];
   char data[5];
   char par[5];
   int fd, n =0 ;
   int pid;
   int doinit=0;

   debugsp(BaudRate,Parity,Data,Stop,CtrlFlux_Hard,CtrlFlux_Soft,"OpenCom()");
   
   if(!BaudRate)BaudRate=1200;
   if(!Data)Data=8;
   if(!Stop)Stop=1;
   
   init_user();
   
   /* test l'existence du repertoire de lock   */
   if (Lockdir[0]&& stat(Lockdir, &stt )==0)
   	sprintf(Lockfile, "%s/LCK..%s",Lockdir,basename(PortNumber));
   else
        Lockfile[0]=0;
  if (Lockfile[0] && (fd = open(Lockfile, O_RDONLY)) >= 0) {
	n = read(fd, buf, 127);
	close(fd);
	if (n > 0) {
		pid = -1;
		if (n == 4)
			/* Kermit-style lockfile. */
			pid = *(int *)buf;
		else {
			/* Ascii lockfile. */
			buf[n] = 0;
			sscanf(buf, "%d", &pid);
		}
		if (pid > 0 && kill(pid, 0) < 0 &&
			errno == ESRCH) {
		    error_win(0,"Le fichier de Lock n'est plus utilise !"," Effacement ...");
		    sleep(1);
		    unlink(Lockfile);
		} else
		    n = 0;
	}
	if (n == 0) {
  		error_win(1, "Le port est deja utilise !", PortNumber);
	}
  }

  /* Now open the tty device. */
  if (setjmp(albuf) == 0) {
	portfd = -1;
	signal(SIGALRM, get_alrm);
	alarm(2);
	portfd = open(PortNumber, O_RDWR|O_NDELAY,0);
	if (portfd > 0) {
		m_savestate(portfd);
		sprintf(baud,"%d",BaudRate);
		sprintf(data,"%d",Data);	
		sprintf(par,"%c",Parity);
	        m_setparms(portfd,baud,par,data,CtrlFlux_Hard,CtrlFlux_Soft);
	        fd=portfd;
	        portfd=open(PortNumber,O_RDWR);
	        if (portfd <0 ) m_restorestate(fd);
	        close (fd);
	        }
  }
  alarm(0);
  signal(SIGALRM, SIG_IGN);
  if (portfd < 0) {
	error_win(1, "Impossible d'utiliser le port. Desole !",PortNumber);
  }
  /* Remember owner of port */
  stat(PortNumber, &stt);
  portuid = stt.st_uid;
  portgid = stt.st_gid;

  /* Give it to us! */
  if (real_uid != 0) chown(PortNumber, real_uid, real_gid);

  if (doinit >= 0 && Lockfile[0]) {
  	if ((fd = open(Lockfile, O_WRONLY | O_CREAT | O_EXCL, 0666)) < 0) {
  		error_win(1, "Impossible de creer le fichier de Lock."," Desole !");
  	}
	sprintf(buf, "%05d    Bbth  V.%s %s", getpid(),__Version__,username);
  	write(fd, buf, strlen(buf));
  	close(fd);
  }
  /* Set CLOCAL mode */
  m_nohang(portfd);
  /* Set Hangup on Close if program crashes. (Hehe) */
  m_hupcl(portfd, 1);	
  if (doinit > 0) m_flush(portfd);
  return(0);
}


/*
                        Close a communication port                           
*/

void         CloseCom (char *PortNumber)
   {
  debug("CloseCom()");
  if (portfd > 0) {
	m_restorestate(portfd);
	m_setrts(portfd);
	close(portfd);
  }
  if (Lockfile[0]) unlink(Lockfile);
  if (real_uid) chown(PortNumber, portuid, portgid);
  }

/*
                         Verify port installation                            
*/

bool         PortOpen (char *PortNumber)
   {
   debug("PortOpen()");
   return TRUE;
   }

/*
                           Turn Echo ON or OFF                              
*/

void         SetEcho (char *PortNumber, bool TypeEcho)
   {
  struct termios tty;
  debug("SetEcho()");
  tcgetattr(portfd, &tty);
  tty.c_lflag = ~(ECHO);
  tcsetattr(portfd, TCSANOW, &tty);
   
   }

/*
    Turn DTR ON or OFF to tell modem that the terminal is ready or           
                       has gone away and to hang up the phone                
*/

void         SetDTR (char *PortNumber, bool TermReady)
   {
   
    m_dtrtoggle(portfd); 
   
   }


/*
                     Send a character                                
*/

void         Send (char *PortNumber, char CharToSend)
   {
   int r;
   debugcc(CharToSend,"Send() ");
	r=write(portfd,&CharToSend,1);
   }
void non_bloquant(int d)
{

	fcntl(d,F_SETFL,O_NONBLOCK | fcntl(d,F_GETFL,0));	
}	

void bloquant(int d)
{
	fcntl(d,F_SETFL,~O_NONBLOCK & fcntl(d,F_GETFL,0));	
}	


/*
         Return the first character in the input buffer and remove it       
*/

char         Receive (char *PortNumber)
   {
   int c;
   if ( cbuf != EMPTY) {
        c=cbuf;
        cbuf=EMPTY;
        return( c & 0377);
   }
  non_bloquant(portfd);		
   switch(read(portfd,&c,1)) {
   case -1 :
   	bloquant(portfd);
   	debug("Receive () erreur read");
   	return(-1);
   case 0 :
   	bloquant(portfd);	
   	debug("Receive() rien");
   	return(-1);
   default :
   	bloquant(portfd);
   	return(c & 0377 );   		
   }	
 }

/*
      Push a character in the input buffer (put at beginning of queue)      
*/

void         UnReceive (char *PortNumber, char CharToPush)
   {
   
   if ( cbuf == EMPTY) 
          cbuf=CharToPush;
       
   }

/*
      Write a character to the input buffer (at the end of the queue)     
*/

void         SendLocal (char *PortNumber, char CharToSend)
   {
   Send(PortNumber,CharToSend);
   }

/*
          Causes a break to be sent out on the line               
*/

void         SendBreak (char *PortNumber)
   {
    m_break(portfd);
   }

/*
                Replies TRUE if there are characters to receive             
*/

bool         PortReady (char *PortNumber)
   {
   char c;
   int r;
   non_bloquant(portfd);
   r=read(portfd,&c,1);
   bloquant(portfd);
   switch (r) {
   	case -1 :
   	case 0  :
           return 0;
   	default :
  	   cbuf=c; 	
   	   return 1;
   }
}


/*
                Repond  TRUE si Carrier Detect est la...                     
*/

bool         CarrierDetect(char *PortNumber)
   {
   return m_getdcd(portfd);

   }

