/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef _COMMPKG_H_
#define _COMMPKG_H_


#ifndef LINUX
#define FALSE          0
#define TRUE           1
#endif
#define ON             TRUE
#define OFF            FALSE
#define MODEMPNB       0
#define MODEMHAYES     1
#define MODEMKXTEL     2
#define NONE           0
#define ODD            1
#define EVEN           2


/* Function prototypes */


bool	     CarrierDetect(char *PortNumber);
bool         OpenCom (char *PortNumber,
                      int BaudRate,       /*  19200 max                      */
                      char Parity,        /*  EVEN,NONE or ODD               */
                      char Data,          /*  5->8 bits data                 */
                      char Stop,          /* 0,1,2 Stop bits                 */
                      int CtrlFlux_Hard,
                      int CtrlFlux_Soft);
void         CloseCom (char *PortNumber);
void         SendString (char *PortNumber, char *StringToSend);
bool         PortOpen (char *PortNumber);
void         Send (char *PortNumber, char CharToSend);
char         Receive (char *PortNumber);
word         XFree (char *PortNumber);
word         XCount (char *PortNumber);
word         RCount (char *PortNumber);
bool         PortReady (char *PortNumber);
void         Sendi (char *PortNumber, char CharToSend);
void         SendLocal (char *PortNumber, char CharToSend);
void         SendBreak (char *PortNumber);
void         UnReceive (char *PortNumber, char CharToPush);
void         XSynchro (char *PortNumber);
void         XFlush (char *PortNumber);
void         RFlush (char *PortNumber);
void         SetDTR (char *PortNumber, bool TermReady);
void         SetConnection (char *PortNumber, char ConnectionType);
void         SetEcho (char *PortNumber, bool TypeEcho);
void         SetXon(char *PortNumber, char ControleFlux);
void         SetAddr(char *PortNumber, word AddrPort, char NumIrq);


#endif