/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
			EMIL
			
                    MODULE: CONFIG.C                                      
                    ----------------                                      
                                                                          
      Configuration generale des parametres par defaut du programme.      
                                                                          
*/
/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur le...
#endif
/*--------------------------------------------------------*/
#include <memory.h>
#include <sys/types.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <ncurses.h>
#include <stdlib.h>

#include "emil.h"
#include "touches.h"
#include "config.h"
#include "couleurs.h"
#include "clavecra.h"
#include "commpkg.h"

#define NUM_PARAM	18

#define TAM 1300     /* Tampon utilise pour la 1ere recherche config apres  */
                     /* compil;(recherche imparfaite peut rater;->modifier  */


struct ConfigType    /* J'initialise la structure pour avoir des la compil  */
Config=              /* une initialisation par defaut sans avoir a installer*/
   {
   "Structure de Configuration",
   0L,         /* Offset 0 voir Write_Config*/
   1,          /* Numero du Port       */
   1200,       /* Vitesse              */
   2,          /* Parite Paire         */
   7,          /* Nombre de bits       */
   1,          /* Bits d'arret         */
   1,          /* Numero du terminal   */
   1,          /* Type de modem        */
   "",         /* Download Directory   */
   "",         /* Upload   Directory   */
   "ATZ^M",    /* Initialisation Modem */
   "ATDT",     /* Dialing Prefix       */
   "~~~+++~~~ATH0^M", /* HangUp string */
   "AT@m10^M",   /* Passage en V23 normal*/
   "AT@m11^M",   /* Passage V23 Inverse  */
   "AT@m10^M",   /* Mode Normal du Modem */
   "ATZ^M",   /* Mode Reset du Modem  */
   25,         /* Nb lignes ecran      */
   1,          /* Video EGA (2=VGA ,0  */
   "T01^M",    /* Ident Qbbs:ANsiterm  */

  /*--------------------- Le port de comm --------*/
   "/dev/modem",
   /*--------------------- Les 10 Macros Clavier----*/

   "195150485*BBS^SA",
   "mon_login^Mmon_passe",
   "Cher ami,",
   "Monsieur le Directeur,",
   "Mon amour,",
   "Pauvre Imbecile,",
   "Veuillez croire a l'expression de ma sincere consideration^M",
   "Allez salut,et bonne bourre !^M",
   "Tu payes ta tournee?^M",
   "+-----------+^M| BONJOUR ! |^M+-----------+^M",

   /*-------------------- Les 16 lignes d'annuaire--*/

   "TELETEL 2"     ,"3614"          ,"",1200,2,7,1,1,2,
   "TELETEL 1"     ,"3613"          ,"",1200,2,7,1,1,2,
   "Annuaire PTT"  ,"11"            ,"",1200,2,7,1,1,2,
   "TELETEL 3"     ,"3615"          ,"",1200,2,7,1,1,2,
   "TELETEL "      ,"3616"          ,"",1200,2,7,1,1,2,
   "ANPE 07"       ,"75 64 16 45"   ,"",1200,2,7,1,1,2,
   "TeleTel"       ,"3617"          ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   ""              ,""              ,"",1200,2,7,1,1,2,
   DEFAULT_DIR,
   CFILE,
   DFILE,
   MFILE,
   };

   byte *ParTxt[]= {"Aucune","Impaire","Paire"};
   byte *TermTxt[]={"Teletype","ANSI","Minitel" };
   byte *ProtoTxt[]={"Aucun","Xon/Xoff", "Cts/Rts"};
   byte *VideoTxt[]={"Ordinaire","EGA","VGA"};
   byte ParChar[]={'N','O','E'};
   byte *Terms[]={"TTY","ANSI","VTX"};
   byte *Parities[]={"N","O","E"};
   byte *FluxCntr[]={"Non","Oui"};


extern char username[];
extern int Speeds[];
extern int console;

extern byte tty_term,
ansi_term,
videotex_term,

NumPort,
Parity,
Data,
Stop,
ModemType,

logtrace,
fd_echo;

extern int  BaudRate;

extern byte CurX,CurY,MinX,MinY,MaxX,MaxY,MaxVtX,MaxVtY,
            ModePage,Mode_V23,__Version__;
extern byte Program_Name[];
extern byte EGA_43,FlagCouleur;

extern char DevPort[];




/*--------------------------------------------------------------------------*/
/*      Configuration generale: main procedure                              */
/*--------------------------------------------------------------------------*/
void Configuration(void)
{
   WINDOW *c_win;
   void error_win();
   debug("Configuration()");

   c_win=Creer_Win(24,67,0,0,TRUE, Normal );
   curseur(0);
   masque_config(c_win);
   ShowConfig(c_win);
   Modif_Options(c_win);
   if(WriteConfig()) error_win(0,"La configuration n'a pas pu etre sauvegardee !","");
   ReadConfig(); 
   Effacer_Win(c_win,TRUE);
   curseur(1);
 }
/*---------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/*      Configuration des macros clavier: main procedure                    */
/*--------------------------------------------------------------------------*/
void ConfigMacros(void)
{
   WINDOW *win_cmac;
   void error_win();

   debug("ConfigMacros()");
   win_cmac=Creer_Win(21,79,0,0,TRUE,Normal );
   curseur(0);
   masque_macros(win_cmac);
   ShowMacros(win_cmac);
   Modif_Macros(win_cmac);
   if(WriteMacro()) error_win(0,"Les macros n'ont pas pu etre sauvegardees !","");
   curseur(1);
   Effacer_Win(win_cmac,TRUE);


}
/*---------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/*      Configuration du repertoire telephonique:main procedure             */
/*--------------------------------------------------------------------------*/
void ConfigDial(int ligne)
   {
WINDOW *win_cdial;
      
   void error_win();
      debug("ConfigDial()");

   win_cdial=Creer_Win(console ? 25: 24,80,0,0,TRUE,Normal ); 
   curseur(0);
   masque_dialconf(win_cdial);
   ShowDialDir(win_cdial);
   Modif_DialDir(win_cdial,ligne);
   if(WriteDialDir()) error_win(0,"Le repertoire n'a pas pu etre sauvegarde !","");
   Effacer_Win(win_cdial,TRUE);
   curseur(1);
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*     Initialisation des parametres selon la configuration                  */
/*---------------------------------------------------------------------------*/

void ReadConfig(void)
   {

   FILE *fp;
   void init_user(),error_win();
   int i, line, oops;
   char *workbuf;
   char *str_dup(), buf[200], message[80], *str_tok(), *str;
   char *temp_token, *findfile(), *m_path;
   static char *token[NUM_PARAM] = {
   "BAUD","PARITE","DATA","STOP","TERM","PROTO","DOWNDIR","UPDIR",
   "INITMDM","DIALPRE","HANGSTR","NORMAL_V23","INVERT_V23","MODENORMAL",
   "MODEMRESET","VIDEOCARD","QBBSIDENT","DEVICE" };
   
   
   debug("ReadConfig()");
   
   /* recherche des droits utilisateurs ! */
   init_user();
   if ((m_path = findfile(DEFAULT_DIR, UFILE)) == NULL) {
   	   sprintf(buf,"Le fichier %s/%s est absent !",DEFAULT_DIR,UFILE);
	   error_win(1,buf," ");
           }
   if (!(fp = fopen(m_path, "r"))) {
       sprintf(buf, "\"%s\" en lecture", m_path);
       error_win(1, "Impossible d'ouvrir", buf);
       }
    oops=0;                                            
   while (fgets(buf, 200, fp) != NULL) {
         if( buf[0]!='#') {
              if (!strncmp(username,buf,strlen(username))) {
     		oops++;
     		break;
     		}
     	}	
     }
     fclose(fp); 
     if ( ! oops )
     	error_win(1,"Vous n'etes pas autoriser a utiliser Emil",username);

/* mise a jour des parametres	*/

   if ((m_path = findfile(DEFAULT_DIR, CFILE)) == NULL) {
   	   sprintf(buf,"Le fichier %s/%s est absent !",DEFAULT_DIR,CFILE);
	   error_win(1,buf," ");
           }
   if (!(fp = fopen(m_path, "r"))) {
       sprintf(buf, "\"%s\" en lecture", m_path);
       error_win(1, "Impossible d'ouvrir", buf);
       }
     	                                                                                    	            
    oops = 0;
    line = 0;
    for (i=0; i<NUM_PARAM; i++) {
       line++;
       if (fgets(buf, 200, fp) == NULL) {
           sprintf(message, "est tronque a la ligne %d", line);
           oops++;
           break;
       }
       if (!(temp_token = str_tok(buf, '='))) {
          sprintf(message, "il manque un mot cle a la ligne %d", line);
          oops++;
          break;
       }
       if (!(str = str_tok((char *) NULL, '\n'))) { 
          sprintf(message, "il manque un parametre a la ligne %d", line);
          oops++;
          break;
       }
                                                                  
       if (strcmp(temp_token, token[i])) {
           sprintf(message, "est errone a la ligne %d", line);
           oops++;
           break;
       }
                                                                                                                                                                                                                                                                                                                                                                                                                 
       switch (i) {
                case 0:
                    BaudRate = atoi(str);
                    Config.Baud=BaudRate;
                    break;
                case 1:
                    Parity = *str;
                    Config.Parite=Parity;
                    break;
		case 2:
		    Data = atoi(str);    
		    Config.Data=Data;                
		    break;
		case 3:
		    Stop = atoi(str);
		    Config.Stop=Stop;
		    break;
		case 4:	
		    workbuf= str_dup(str);
		    /* ANSI	*/
		    if (! strncmp(workbuf,Terms[1],strlen(Terms[1]))) {
		         ansi_term=1;
		         tty_term=0;
                         Config.Term=1;
		         videotex_term=0;
		         }
		    else {
		    /* TTY	*/
		    if (! strncmp(workbuf,Terms[0],strlen(Terms[0]))) {
		         ansi_term=0;
                         Config.Term=0;
			 tty_term=1;
		         videotex_term=0;
      		         }
      		    else {     
      		    /* VTX	*/
		    if (! strncmp(workbuf,Terms[2],strlen(Terms[2]))) {
		         ansi_term=0;
		         tty_term=0;
                         Config.Term=2;
		         videotex_term=1;
		         }
		      }   
		    }     
		debug(Terms[Config.Term]);    
		    
		    break;
		case 5:
		    workbuf =str_dup(str);
		    if (! strncmp(workbuf,"XON/XOFF",8)) ModemType=1;
		    else {
		    if (! strncmp(workbuf,"CTS/RTS",7))  ModemType=2;
		    else {
		    if (! strncmp(workbuf,"AUCUN",5)) ModemType=0;
		    }
		    }
		    Config.Modem=ModemType;
		    break;
		case 6:
	             strcpy(Config.DownDir,str_dup(str));
		    break;
		case 7:
		    strcpy(Config.UpDir,str_dup(str));
		    break;
		case 8:
	            strcpy(Config.InitMdm,str_dup(str));	
		    break;        	    
		case 9:
		    strcpy(Config.DialPre,str_dup(str));	    
		    break;
		case 10:
		    strcpy(Config.HangStr,str_dup(str));
		    break;
		case 11:
		    strcpy(Config.Normal_V23,str_dup(str));
		    break;
                case 12:	    
                    strcpy(Config.Invert_V23,str_dup(str));
                    break;
		case 13:
		     strcpy(Config.ModeNormal,str_dup(str));
		     break;
		case 14:
		     strcpy(Config.ModemReset,str_dup(str));
		     break;
		case 15:
		     Config.VideoCard=*str;
		     break;
		case 16:
		     strcpy(Config.QbbsIdent,str_dup(str));
		     break;
		case 17:
		     strcpy(Config.Device,str_dup(str));
		     strcpy(DevPort,Config.Device);
		     debug(DevPort);	
		     break;
		          
				    
				    
               }  
       }
       fclose(fp);
       if (oops) {
          sprintf(buf, "Le fichier de Configuration \"%s/%s\"", DEFAULT_DIR,CFILE);
          error_win(1, buf, message);
       }
                                                        
       
 }
/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
/*     Initialisation du repertoire telephonique                 */
/*---------------------------------------------------------------------------*/

void ReadDialDir(void)
   {

   FILE *fp;
   void init_user(),error_win();
   int i, j,line, oops,v, ops;
   char WorkBuf[10];
   char *str_dup(), buf[200], message[80], *str_tok();
   char *findfile(), *m_path;
   
   debug("ReadDialDir()");

   
   if ((m_path = findfile(DEFAULT_DIR, DFILE)) == NULL) {
   	   sprintf(buf,"Le fichier %s/%s est absent !",DEFAULT_DIR,DFILE);
	   error_win(1,buf," ");
           }
   if (!(fp = fopen(m_path, "r"))) {
       sprintf(buf, "\"%s\" en lecture", m_path);
       error_win(1, "Impossible d'ouvrir", buf);
       }
    oops=0;
    line = 0;
    for (i=0; i<MAXNUMS; i++) {
       line++;
       if (fgets(buf, 200, fp) == NULL) {
           sprintf(message, "est tronque a la ligne %d", line);
           oops++;
           break;
       }
    v=0;
    j=0;
    Ebavure(buf);
    for ( ops=0; ops < strlen(buf); ops ++ )	{
              switch(v)	{
              		case 0:		/* non bbs	*/  
                          if (buf[ops] != ';')	
                              Config.DialDir[line-1].DialName[j++]=buf[ops];
                          else	{ 
                          	v++;
                                 Config.DialDir[line-1].DialName[j]='\0';
                          	j=0;
                          	}
                          break;       
			case 1:		/* Numero Telephone */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].DialNum[j++]=buf[ops];
                          else  {
                                v++;
                                 Config.DialDir[line-1].DialNum[j]='\0';
                                j=0;
                                }
                           break;
			case 2:		/* Term ident */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].TermIdent[j++]=buf[ops];
                          else  {
                                v++;
                                j=0;
                                }
                           break;
			case 3:		/* Baud rate */
			   if (buf[ops] != ';')
			       WorkBuf[j++]=buf[ops];
                          else  {
                                v++;
                                WorkBuf[j]='\0';
                                j=0;
                                Config.DialDir[line-1].DialBaud=atoi(WorkBuf);
                                }
                           break;
			case 4:		/* Parity */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].DialParity=buf[ops]-'0';
                          else  {
                                v++;
                                j=0;
                                }
                           break;
			case 5:		/* Bits */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].DialBits=buf[ops]-'0';
                          else  {
                                v++;
                                j=0;
                                }
                           break;
			case 6:		/* Stops */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].DialStop=buf[ops]-'0';
                          else  {
                                v++;
                                j=0;
                                }
                           break;
			case 7:		/* Mode */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].DialMode=buf[ops]-'0';
                          else  {
                                v++;
                                j=0;
                                }
                           break;
			case 8:		/* Dial Term */
			   if (buf[ops] != ';')
			       Config.DialDir[line-1].DialTerm=buf[ops]-'0';
                          else  {
                                v++;
                                j=0;
                                }
                           break;
                           
			}	/* fin du switch	*/
		}	/* fin du for oops	*/
						
	}		/* fin du for i	*/

       fclose(fp);
       if (oops) {
          sprintf(buf, "Le fichier Repertoire \"%s/%s\"", DEFAULT_DIR,DFILE);
          error_win(1, buf, message);
       }
	
}

/*---------------------------------------------------------------------------*/
/*     Initialisation des macros                                             */
/*---------------------------------------------------------------------------*/

void ReadMacro(void)
   {

   FILE *fp;
   void init_user(),error_win();
   int i, line, oops;
   char *str_dup(), buf[200], message[80], *str_tok();
   char *findfile(), *m_path;
   
   debug("ReadMacro()");

   
   if ((m_path = findfile(DEFAULT_DIR, MFILE)) == NULL) {
   	   sprintf(buf,"Le fichier %s/%s est absent !",DEFAULT_DIR,MFILE);
	   error_win(1,buf," ");
           }
   if (!(fp = fopen(m_path, "r"))) {
       sprintf(buf, "\"%s\" en lecture", m_path);
       error_win(1, "Impossible d'ouvrir", buf);
       }
    oops=0;
    line = 0;
    for (i=0; i<MAXMACRO; i++) {
       line++;
       if (fgets(buf, 200, fp) == NULL) {
           sprintf(message, "est tronque a la ligne %d", line);
           oops++;
           break;
       }
       Ebavure(buf);
       strcpy(Config.KeyMacro[line-1],buf);
    }   	
       fclose(fp);
       if (oops) {
          sprintf(buf, "Le fichier des Macros \"%s/%s\"", DEFAULT_DIR,DFILE);
          error_win(1, buf, message);
       }

   


}




/*---------------------------------------------------------------------------*/
/*    Affichage de l'ecran de configuration generale                     */
/*---------------------------------------------------------------------------*/
void masque_config(WINDOW *win)
   {
    int attrib=Normal ;

   debug("masque_config()");

   mwrite(win,10,1,"     Configuration de Emil    ", Inverse);
   mwrite(win,5,3,"Port                :",attrib);  /* Masque fixe      */
   mwrite(win,5,4,"Bauds               :",attrib);
   mwrite(win,5,5,"Parite              :",attrib);
   mwrite(win,5,6,"Bits                :",attrib);
   mwrite(win,5,7,"Stop                :",attrib);
   mwrite(win,5,8,"Terminal de Depart  :",attrib);
   mwrite(win,5,9,"Protocol            :",attrib);
   mwrite(win,5,10,"Repertoire DownLoad :",attrib);
   mwrite(win,5,11,"Repertoire UpLoad   :",attrib);
   mwrite(win,5,12,"Chaine Init. Modem  :",attrib);
   mwrite(win,5,13,"Prefixe Numerotation:",attrib);
   mwrite(win,5,14,"Liberation Ligne    :",attrib);
   mwrite(win,5,15,"Passage Modem en V23:",attrib);
   mwrite(win,5,16,"Modem en V23 inverse:",attrib);
   mwrite(win,5,17,"Modem en mode Normal:",attrib);
   mwrite(win,5,18,"Reset Modem         :",attrib);
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*    Affichage de l'ecran de saisie des macros                              */
/*---------------------------------------------------------------------------*/
void masque_macros(WINDOW *w)
   {
    int attrib=Normal ;
    
   debug("masque_macros()");

   mwrite(w,7,1,"   Definition  des Macros Clavier.  ",Inverse);
   mwrite(w,43,1,"",Inverse);
   waddch(w,ACS_UARROW);
   mwrite(w,44,1,"",Inverse);
   waddch(w,ACS_DARROW);
   mwrite(w,45,1," Changent d'option    ",Inverse);

   mwrite(w,5, 3,"ALT_1:",attrib);  /* Masque fixe      */
   mwrite(w,5, 4,"ALT_2:",attrib);
   mwrite(w,5, 5,"ALT_3:",attrib);
   mwrite(w,5, 6,"ALT_4:",attrib);
   mwrite(w,5, 7,"ALT_5:",attrib);
   mwrite(w,5, 8,"ALT_6:",attrib);
   mwrite(w,5, 9,"ALT_7:",attrib);
   mwrite(w,5,10,"ALT_8:",attrib);
   mwrite(w,5,11,"ALT_9:",attrib);
   mwrite(w,5,12,"ALT_0:",attrib);

   mwrite(w,8,15,"Le caractere '^' prefixe  un  caractere   de  controle",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,8,16,"Le caractere '~' correspond a une pause de 1 seconde",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,8,17,"  Terminez chaque saisie par ENTER pour la valider !"  ,FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,8,19,"### ESC pour terminer et sauver les textes saisis.###",FlagCouleur ? Cyan_bleu : Normal);

   }
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*    Affichage de l'ecran de saisie repertoire telephone                    */
/*---------------------------------------------------------------------------*/
void masque_dialconf(WINDOW *w)
   {
    int attrib=FlagCouleur ? Blanc_bleu : Normal ;
    
      debug("masque_dialconf()");

   mwrite(w,7,1,"     Configuration du rpertoire    ",FlagCouleur ? noir_blanc :Inverse);
   mwrite(w,45,1,"",FlagCouleur ? noir_blanc :Inverse);
   waddch(w,ACS_UARROW);
   mwrite(w,46,1,"",FlagCouleur ? noir_blanc :Inverse);
   waddch(w,ACS_DARROW);
   mwrite(w,47,1," Changent de ligne    ",FlagCouleur ? noir_blanc :Inverse);

   mwrite(w,6, 3,"     NOM          NUMERO      "
       "  Bauds   Par Bit Stop V-23  Term",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,3, 4," 1:",attrib);
   mwrite(w,3, 5," 2:",attrib);
   mwrite(w,3, 6," 3:",attrib);
   mwrite(w,3, 7," 4:",attrib);
   mwrite(w,3, 8," 5:",attrib);
   mwrite(w,3, 9," 6:",attrib);
   mwrite(w,3,10," 7:",attrib);
   mwrite(w,3,11," 8:",attrib);
   mwrite(w,3,12," 9:",attrib);
   mwrite(w,3,13,"10:",attrib);
   mwrite(w,3,14,"11:",attrib);
   mwrite(w,3,15,"12:",attrib);
   mwrite(w,3,16,"13:",attrib);
   mwrite(w,3,17,"14:",attrib);
   mwrite(w,3,18,"15:",attrib);
   mwrite(w,3,19,"16:",attrib);

   mwrite(w,3,21,"ESPACE",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,10,21,"Fait defiler les valeurs disponibles des options",attrib);
   mwrite(w,3,22,"ENTER ",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,10,22,"Valide la saisie et passe au champ suivant",attrib);
   mwrite(w,3,23," ESC  ",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(w,10,23,"Termine et ecrit le repertoire sur le disque",attrib);

   }
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*   Affichage des parametres de config courants                             */
/*---------------------------------------------------------------------------*/

void ShowConfig(WINDOW *w)
   {
   byte *Gomme="                    " /* 40 caracteres espace pour effacer */
   "                    ";
   byte TextBuf[20];
   int parite=NONE;
   int attrib=FlagCouleur ? Blanc_bleu : Normal ;


   switch( Config.Parite)	{
    	case 'N':
    	   parite=NONE;
    	   break;
	case 'O':
	   parite=ODD;
	   break;
	case 'E':
	   parite=EVEN;
	   break;
	   }    	   
   

   mwrite(w, 26,3,Config.Device ,attrib );
   sprintf(TextBuf,"%5d",Config.Baud);
   mwrite(w, 26,4,TextBuf   ,attrib    );
   mwrite(w, 26,5,ParTxt[parite],attrib);
   sprintf(TextBuf,"%1d",Config.Data);
   mwrite(w, 26,6,TextBuf   ,attrib    );
   sprintf(TextBuf,"%1d",Config.Stop);
   mwrite(w, 26,7,TextBuf     ,attrib  );
   mwrite(w, 26,8,Terms[Config.Term],attrib);
   mwrite(w, 26,9,Gomme,attrib); /* nettoie */
   mwrite(w, 26,9,ProtoTxt[Config.Modem],attrib);
   mwrite(w,26,10,Gomme,attrib); /* nettoie */
   mwrite(w,26,10,Config.DownDir,attrib);
   mwrite(w,26,11,Gomme,attrib); /* nettoie */
   mwrite(w,26,11,Config.UpDir ,attrib );
   mwrite(w,26,12,Gomme,attrib); /* nettoie */
   mwrite(w,26,12,Config.InitMdm,attrib);
   mwrite(w,26,13,Gomme,attrib); /* nettoie */
   mwrite(w,26,13,Config.DialPre,attrib);
   mwrite(w,26,14,Gomme,attrib); /* nettoie */
   mwrite(w,26,14,Config.HangStr,attrib);
   mwrite(w,26,15,Gomme,attrib); /* nettoie */
   mwrite(w,26,15,Config.Normal_V23,attrib);
   mwrite(w,26,16,Gomme,attrib); /* nettoie */
   mwrite(w,26,16,Config.Invert_V23,attrib);
   mwrite(w,26,17,Gomme,attrib); /* nettoie */
   mwrite(w,26,17,Config.ModeNormal,attrib);
   
   mwrite(w,26,18,Gomme,attrib);
   mwrite(w,26,18,Config.ModemReset,attrib); 
/*
   mwrite(w,26,19,VideoTxt[Config.VideoCard],attrib);
   mwrite(w,26,20,Gomme,attrib); 
   mwrite(w,26,20,Config.QbbsIdent,attrib);
*/   
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*   Affichage du repertoire telephonique                                    */
/*---------------------------------------------------------------------------*/

void ShowDialDir(WINDOW *w)
   {
   int i;
   debug("ShowDialDir()");

    for(i=0;i<MAXNUMS;i++) ShowDialLine(w,i,Normal);
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*   Affichage d'une ligne du repertoire telephonique                        */
/*---------------------------------------------------------------------------*/

void ShowDialLine(WINDOW *w,int line,int couleur)
   {
   byte *Gomme="                    " /* 73 caracteres espace pour effacer */
               "                    "
               "                    "
               "             ";

   byte TextBuf[20];
   int i;

   i=line;
   mwrite(w,6 ,i+4, Gomme,couleur);
   mwrite(w,6 ,i+4, Config.DialDir[i].DialName,couleur);
   mwrite(w,22,i+4,Config.DialDir[i].DialNum  ,couleur);

   sprintf(TextBuf,"%5d",Config.DialDir[i].DialBaud);
   mwrite(w,38,i+4,TextBuf                    ,couleur);

   mwrite(w,47,i+4,Parities[Config.DialDir[i].DialParity],couleur);

   sprintf(TextBuf,"%1d",Config.DialDir[i].DialBits);
   mwrite(w,51,i+4,TextBuf                   ,couleur);

   sprintf(TextBuf,"%1d",Config.DialDir[i].DialStop);
   mwrite(w,55,i+4,TextBuf                   ,couleur);

   mwrite(w,59,i+4,FluxCntr[Config.DialDir[i].DialMode],couleur);
   mwrite(w,65,i+4,Terms[Config.DialDir[i].DialTerm],couleur);
/*   mwrite(w,69,i+4,Config.DialDir[i].TermIdent,couleur);	*/
   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*   Affichage des macros clavier courantes                                  */
/*---------------------------------------------------------------------------*/

void ShowMacros(WINDOW *w)
   {
   byte *Gomme="                              " /* 60 caracteres espace*/
   "                              ";/* pour effacer        */
   int i;
   debug("ShowMacros()");

   for(i=0;i<10;i++)
      {
        mwrite(w,11,i+3,Gomme,FlagCouleur ? blanc_bleu :Normal);
        mwrite(w,11,i+3,Config.KeyMacro[i],FlagCouleur ? blanc_bleu :Normal);
      }
   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*         Saisie ou modification des macros clavier                         */
/*---------------------------------------------------------------------------*/
void Modif_Macros(WINDOW *w)
   {
   int NivMin =3; /* Ligne de la premiere option    */
   int Xopt   =11;/* Colonne d'ecriture des options */
   int Niv    =0; /* Option de depart dans le menu  */
   int test;
   byte WorkBuf[61];
   debug("Modif_Macros()");

   curseur(1);

   while(1)
      {
      strcpy(WorkBuf,Config.KeyMacro[Niv]);
      test=saisie(w,Xopt,NivMin+Niv,WorkBuf,FlagCouleur ? Cyan_bleu :Inverse,60,KEEP);

      if(test==HAUT)Niv=pred(Niv);

      if(test==BAS) Niv=succ(Niv,9);

      if(test==ESC) break;

      if(test==RETOUR)
         {
         strcpy(Config.KeyMacro[Niv],WorkBuf);
         Niv=succ(Niv,9);
         }
      ShowMacros(w);
      }

   curseur(0);
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*                 La fonction Principale de saisie Config                   */
/*---------------------------------------------------------------------------*/
void Modif_Options(WINDOW *w)
   {
   byte WorkBuf[80];

   int NivMin =3; /* Ligne de la premiere option    */
   int Xopt   =26;/* Colonne d'ecriture des options */
   int Niv    =0; /* Option de depart dans le menu  */
   int fin=0;
   int test,i;
   int attrib= FlagCouleur ? Blanc_bleu : Normal ;
   int _attrib= FlagCouleur ? Bleu_blanc : Inverse ;
   static byte *SpaceMsg="<ESPACE> passe a la valeur suivante. ESC Termine.";
   static byte *SaisiMsg="<RETURN> pour valider la saisie. ESC Termine.";
   int parite=NONE;

   debug("Modif_Options()");

   switch( Config.Parite)	{
    	case 'N':
    	   parite=NONE;
    	   break;
	case 'O':
	   parite=ODD;
	   break;
	case 'E':
	   parite=EVEN;
	   break;
	   }    	   
   
   
   while(!fin)
      {
      switch(Niv)
         {
      case 0: /* Saisie du device de comm par Espace */
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.Device);
         test=saisie(w,26,3,WorkBuf,_attrib,12,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
              Ebavure(WorkBuf);
              strcpy(Config.Device,WorkBuf);
              Niv=succ(Niv,MAXOPTIONS);
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 0 */


      case 1: /* Modif de lavitesse de comm par Espace */
         curseur(1);
         ConfigMsg(w,SpaceMsg);
         for(i=0;i<MAXSPEEDS;i++)if(Speeds[i]==Config.Baud)break;
         while(1)
            {
            sprintf(WorkBuf,"%5d",Config.Baud);
            mwrite(w,Xopt,Niv+NivMin,"     ",attrib);/* efface*/
            mwrite(w,Xopt,Niv+NivMin,WorkBuf,_attrib);
            test=touche(w,FALSE);
            if(test==RETOUR || test==BAS) {
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==ESPACE)
               {
               i++;
               if(i >MAXSPEEDS)i=0;
               Config.Baud=Speeds[i];
               }
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 1 */


      case 2: /* Modif de la Parite */
         curseur(1);
         ConfigMsg(w,SpaceMsg);
         while(1)
            {
            mwrite(w,Xopt,Niv+NivMin,"       ",attrib);/* efface*/
            mwrite(w,Xopt,Niv+NivMin,ParTxt[parite],_attrib);
            test=touche(w,FALSE);
            if(test==RETOUR || test==BAS){
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==ESPACE)
               {
               parite++;
               if(parite >EVEN)
                  parite=NONE;
               Config.Parite=ParChar[parite];   
               }
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 2 */


      case 3: /* Modif du format Data */
         curseur(1);
         ConfigMsg(w,SpaceMsg);
         while(1)
            {
	    sprintf(WorkBuf,"%1d",Config.Data);
            mwrite(w,Xopt,Niv+NivMin,WorkBuf,_attrib);
            test=touche(w,FALSE);
            if(test==RETOUR || test==BAS){
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==ESPACE) /* Modif par "espace" */
               {
               Config.Data++;
               if(Config.Data >8)Config.Data=5;
               }
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 3 */



      case 4: /* Modif des bits de stop */
         curseur(1);
         ConfigMsg(w,SpaceMsg);
         while(1)
            {
            sprintf(WorkBuf,"%1d",Config.Stop);
            mwrite(w,Xopt,Niv+NivMin,WorkBuf,_attrib);
            test=touche(w,FALSE);
            if(test==RETOUR || test==BAS){
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==ESPACE) /* Modif par "espace" */
               {
               Config.Stop++;
               if(Config.Stop >2)Config.Stop=1;
               }
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 4 */



      case 5: /* Modif du terminal de depart */
         curseur(1);
         ConfigMsg(w,SpaceMsg);
         while(1)
            {
            mwrite(w,Xopt,Niv+NivMin,"        ",attrib);/* efface*/
            mwrite(w,Xopt,Niv+NivMin,Terms[Config.Term],_attrib);
            test=touche(w,FALSE);
            if(test==RETOUR || test==BAS){
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==ESPACE)
               {
               Config.Term++;
               if(Config.Term >2)
                  Config.Term=0;
               }
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 5 */



      case 6: /* Modif du type de Protocol */
         curseur(1);
         ConfigMsg(w,SpaceMsg);
         while(1)
            {
            mwrite(w,Xopt,Niv+NivMin,"                    ",attrib);/* efface*/
            mwrite(w,Xopt,Niv+NivMin,ProtoTxt[Config.Modem],_attrib);
            test=touche(w,FALSE);
            if(test==RETOUR || test==BAS){
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==ESPACE)
               {
               Config.Modem++;
               if(Config.Modem >2)
                  Config.Modem=0;
               }
            }
         curseur(0);   
         ShowConfig(w);
         break;/* du case 6 */


      case 7: /* -------saisie dir download --------------*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.DownDir);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
            filtre_path(WorkBuf);
            strcpy(Config.DownDir,WorkBuf);
            Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
         break;/* du case 7 */



      case 8: /* -------saisie dir Upload --------------*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.UpDir);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
            filtre_path(WorkBuf);
            strcpy(Config.UpDir,WorkBuf);
            Niv=succ(Niv,MAXOPTIONS);
            }
           ShowConfig(w);
           curseur(0);
         break;/* du case 8 */


      case 9: /* -------saisie chaine init du modem--------*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.InitMdm);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
            Ebavure(WorkBuf);
            strcpy(Config.InitMdm,WorkBuf);
            Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
         break;/* du case 9 */


      case 10: /* -------saisie prefixe de numerotation-*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.DialPre);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
            Ebavure(WorkBuf);
            strcpy(Config.DialPre,WorkBuf);
            Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
         break;/* du case 10 */


      case 11: /* -------saisie chaine pour raccrocher---*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.HangStr);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
            Ebavure(WorkBuf);
            strcpy(Config.HangStr,WorkBuf);
            Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
         break;/* du case 11 */


      case 12: /* -------saisie chaine pour passer V23 Normal---*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.Normal_V23);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
              Ebavure(WorkBuf);
               strcpy(Config.Normal_V23,WorkBuf);
              Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
     break;/* du case 12 */



      case 13: /* -------saisie chaine pour passer V23 Normal---*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.Invert_V23);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
              Ebavure(WorkBuf);
               strcpy(Config.Invert_V23,WorkBuf);
              Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
     break;/* du case 13 */


      case 14: /* -------saisie chaine pour passer V23 Normal---*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.ModeNormal);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
              Ebavure(WorkBuf);
               strcpy(Config.ModeNormal,WorkBuf);
              Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
      break;/* du case 14 */



      case 15: /* Chaine de Reset Modem */
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.ModemReset);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,_attrib,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
              Ebavure(WorkBuf);
               strcpy(Config.ModemReset,WorkBuf);
              Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
      break;/* du case 14 */
       
       


      case 16: /* Modif du type de carte video pas espace */
      /*
         ConfigMsg(w,SpaceMsg);
         while(1)
            {
            mwrite(Xopt,Niv+NivMin,"         ",blanc_bleu);
            mwrite(Xopt,Niv+NivMin,VideoTxt[Config.VideoCard],Inverse);
            test=touche();
            if(test==RETOUR || test==BAS){
               Niv=succ(Niv,MAXOPTIONS);
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==32)
               {
               Config.VideoCard++;
               if(Config.VideoCard >2)
                  Config.VideoCard=0;
               }
            }
         ShowConfig(w);
         */
         break;/* du case 16 */


      case 17: /* -------saisie chaine ident terminal Qbbs---*/
         ConfigMsg(w,SaisiMsg);
         curseur(1);
         strcpy(WorkBuf,Config.QbbsIdent);
         test=saisie(w,Xopt,NivMin+Niv,WorkBuf,Inverse,40,KEEP);
         if(test==HAUT)Niv=pred(Niv);

         if(test==BAS) Niv=succ(Niv,MAXOPTIONS);

         if(test==ESC) fin=1;

         if(test==RETOUR)
            {
              Ebavure(WorkBuf);
              strcpy(Config.QbbsIdent,WorkBuf);
              Niv=succ(Niv,MAXOPTIONS);
            }
         ShowConfig(w);
         curseur(0);
      break;/* du case 17 */

         }/* du Switch */
      }/* du while!fin */

   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*           Saisie et modification du repertoire telephonique               */
/*---------------------------------------------------------------------------*/

void Modif_DialDir(WINDOW *w,int ligne)
   {
   int fin=0,test,i;
   byte WorkBuf[20];
   byte Champ=0; /* On part sur le champ "nom" */
   byte Niv  = ligne; /* Et la premiere ligne       */
   int attrib =  Normal;
   int _attrib = Inverse;

   debug("Modif_DialDir()");


   while(!fin)
      {
      switch(Champ)
         {
      case 0:  /*  Saisie du Nom du serveur */
         curseur(1);
         strcpy(WorkBuf,Config.DialDir[Niv].DialName);
         Ebavure(WorkBuf);
         test=saisie(w,6,Niv+4,WorkBuf,_attrib,15,KEEP);

         if(test==HAUT){
            Niv=pred(Niv);
            Champ=0;
            } /* On revient sur le champ des noms */

         if(test==BAS){
            Niv=succ(Niv,MAXNUMS-1);
            Champ=0;
            }

         if(test==ESC) fin=1;

         if(test==RETOUR){
            Ebavure(WorkBuf);
            strcpy(Config.DialDir[Niv].DialName,WorkBuf);
            Champ=succ(Champ,MAXCHAMPS);
            }

         ShowDialDir(w);
         curseur(0);
         break; /* du Case 0 */




      case 1:  /*  Saisie du Numero de telephone */
         curseur(1);
         strcpy(WorkBuf,Config.DialDir[Niv].DialNum);
	 Ebavure(WorkBuf);
         test=saisie(w,22,Niv+4,WorkBuf,_attrib,15,KEEP);

         if(test==HAUT){
            Niv=pred(Niv);
            Champ=0;
            } /* On revient sur le champ des noms */

         if(test==BAS){
            Niv=succ(Niv,MAXNUMS-1);
            Champ=0;
            }

         if(test==ESC) fin=1;

         if(test==RETOUR){
            Ebavure(WorkBuf);
            strcpy(Config.DialDir[Niv].DialNum,WorkBuf);
            Champ=succ(Champ,MAXCHAMPS);
            }

         ShowDialDir(w);
         curseur(0);
         break; /* du Case 0 */

      case 2: /* Modif de lavitesse de comm par Espace */
         for(i=0;i<MAXSPEEDS;i++)
            if(Speeds[i]==Config.DialDir[Niv].DialBaud)break;
         while(1)
            {
            sprintf(WorkBuf,"%5d",Config.DialDir[Niv].DialBaud);
            mwrite(w,38,Niv+4,"     ",attrib);/* efface*/
            mwrite(w,38,Niv+4,WorkBuf,_attrib);
            test=touche(w,FALSE);

            if(test==BAS){
               Niv=succ(Niv,MAXNUMS-1);
               Champ=0;
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               Champ=0;
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==RETOUR){
               Champ=succ(Champ,MAXCHAMPS);
               break;
               }

            if(test==32)
               {
               i++;
               if(i >MAXSPEEDS)i=0;
               Config.DialDir[Niv].DialBaud=Speeds[i];
               }
            }
         ShowDialDir(w);
         break;/* du case 2 */


      case 3: /* Modif de la parite par Espace */
         while(1)
            {
            mwrite(w,47,Niv+4,
            Parities[Config.DialDir[Niv].DialParity],_attrib);
            test=touche(w,FALSE);

            if(test==BAS){
               Niv=succ(Niv,MAXNUMS-1);
               Champ=0;
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               Champ=0;
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==RETOUR){
               Champ=succ(Champ,MAXCHAMPS);
               break;
               }

            if(test==32)
               {
               Config.DialDir[Niv].DialParity++;
               if(Config.DialDir[Niv].DialParity >EVEN)
                  Config.DialDir[Niv].DialParity=NONE;
               }
            }
         ShowDialDir(w);
         break;/* du case 3 */


      case 4: /* Modif du nombre de bits par Espace */
         while(1)
            {
            sprintf(WorkBuf,"%1d",Config.DialDir[Niv].DialBits);
            mwrite(w,51,Niv+4,WorkBuf,_attrib);
            test=touche(w,FALSE);

            if(test==BAS){
               Niv=succ(Niv,MAXNUMS-1);
               Champ=0;
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               Champ=0;
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==RETOUR){
               Champ=succ(Champ,MAXCHAMPS);
               break;
               }

            if(test==32)
               {
               Config.DialDir[Niv].DialBits++;
               if(Config.DialDir[Niv].DialBits >8)
                  Config.DialDir[Niv].DialBits=5;
               }
            }
         ShowDialDir(w);
         break;/* du case 4 */


      case 5: /* Modif du nombre de bits de Stop par Espace */
         while(1)
            {
            sprintf(WorkBuf,"%1d",Config.DialDir[Niv].DialStop);
            mwrite(w,55,Niv+4,WorkBuf,_attrib);
            test=touche(w,FALSE);

            if(test==BAS){
               Niv=succ(Niv,MAXNUMS-1);
               Champ=0;
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               Champ=0;
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==RETOUR){
               Champ=succ(Champ,MAXCHAMPS);
               break;
               }

            if(test==32)
               {
               Config.DialDir[Niv].DialStop++;
               if(Config.DialDir[Niv].DialStop >2)
                  Config.DialDir[Niv].DialStop=1;
               }
            }
         ShowDialDir(w);
         break;/* du case 5 */


      case 6: /* Modif du flag V23 on/off par Espace */
         while(1)
            {
            mwrite(w,59,Niv+4,FluxCntr[Config.DialDir[Niv].DialMode],_attrib);
            test=touche(w,FALSE);

            if(test==BAS){
               Niv=succ(Niv,MAXNUMS-1);
               Champ=0;
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               Champ=0;
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==RETOUR){
               Champ=succ(Champ,MAXCHAMPS);
               break;
               }

            if(test==32)
               {
               Config.DialDir[Niv].DialMode++;
               if(Config.DialDir[Niv].DialMode >1)
                  Config.DialDir[Niv].DialMode=0;
               }
            }
         ShowDialDir(w);
         break;/* du case 6 */


      case 7: /* Modif du type de terminal */
         while(1)
            {
            mwrite(w,65,Niv+4,Terms[Config.DialDir[Niv].DialTerm],_attrib);
            test=touche(w,FALSE);

            if(test==BAS){
               Niv=succ(Niv,MAXNUMS-1);
               Champ=0;
               break;
               }

            if(test==HAUT){
               Niv=pred(Niv);
               Champ=0;
               break;
               }

            if(test==ESC){
               fin=1;
               break;
               }

            if(test==RETOUR){
               Champ=succ(Champ,MAXCHAMPS);
               break;
               }

            if(test==32)
               {
               Config.DialDir[Niv].DialTerm++;
               if(Config.DialDir[Niv].DialTerm >2)
                  Config.DialDir[Niv].DialTerm=0;
               }
            }
         ShowDialDir(w);
         break;/* du case7 */

        /*  Saisie de l'identification terminal */

/*      case 8:
         curseur(1);
         strcpy(WorkBuf,Config.DialDir[Niv].TermIdent);
         test=saisie(w,69,Niv+4,WorkBuf,_attrib,10,KEEP);

         if(test==HAUT){
            Niv=pred(Niv);
            Champ=0;
            }

         if(test==BAS){
            Niv=succ(Niv,MAXNUMS-1);
            Champ=0;
            }

         if(test==ESC) fin=1;

         if(test==RETOUR){
            strcpy(Config.DialDir[Niv].TermIdent,WorkBuf);
            Champ=succ(Champ,MAXCHAMPS);
            break;
            }

         ShowDialDir(w);
         curseur(0);
         break;	*/
          /* du Case 8 */

         }/* du swhitch */
      }/* du while */
   }/* de la fonction */


/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*           ECRITURE DE LA CONFIGURATION DANS LE FICHIER de conf            */
/*---------------------------------------------------------------------------*/

int WriteConfig(void)
   {

   FILE *fp;
   char buf[80];
   void error_win();
   char file[256];
   static char *Proto[]={"AUCUN","XON/XOFF","CTS/RTS"};


   debug("WriteConfig()");
      

   sprintf(file,"%s/%s",DEFAULT_DIR,CFILE);
   if (!(fp = fopen(file, "w"))) {
      sprintf(buf, "\"%s\"", file);
      error_win(0, "Erreur de permission sur le fichier de configuration", buf);
      return(1);
   }
   fprintf(fp, "BAUD=%d\n", Config.Baud);
   fprintf(fp, "PARITE=%c\n", Config.Parite);
   fprintf(fp, "DATA=%1d\n", Config.Data);
   fprintf(fp, "STOP=%1d\n", Config.Stop);
   fprintf(fp, "TERM=%s\n", Terms[Config.Term]);
   fprintf(fp,"PROTO=%s\n",Proto[Config.Modem]);
   fprintf(fp,"DOWNDIR=%s\n",Config.DownDir);
   fprintf(fp,"UPDIR=%s\n",Config.UpDir);
   fprintf(fp,"INITMDM=%s\n",Config.InitMdm);
   fprintf(fp,"DIALPRE=%s\n",Config.DialPre);
   fprintf(fp,"HANGSTR=%s\n",Config.HangStr);
   fprintf(fp,"NORMAL_V23=%s\n",Config.Normal_V23);
   fprintf(fp,"INVERT_V23=%s\n",Config.Invert_V23);
   fprintf(fp,"MODENORMAL=%s\n",Config.ModeNormal);
   fprintf(fp,"MODEMRESET=%s\n",Config.ModemReset);
   fprintf(fp,"VIDEOCARD=%c\n",Config.VideoCard);
   fprintf(fp,"QBBSIDENT=%s\n",Config.QbbsIdent);
   fprintf(fp,"DEVICE=%s\n",Config.Device);
   
                                                                                                                                 
   fclose(fp);
   return(0);
   }
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*           ECRITURE DU REPERTOIRE DANS Un FICHIER de conf            */
/*---------------------------------------------------------------------------*/

int WriteDialDir(void)
   {

   FILE *fp;
   char buf[256];
   void error_win();
   char file[256];
   int i;


   debug("WriteDialDir()");
      

   sprintf(file,"%s/%s",DEFAULT_DIR,DFILE);
   if (!(fp = fopen(file, "w"))) {
      sprintf(buf, "\"%s\"", file);
      error_win(0, "Erreur de permission sur le fichier repertoire", buf);
      return(1);
   }

   for ( i=0; i < MAXNUMS ; i++ )	{
	sprintf(buf,"%-15s;%-18s;%2s;%5d;%1d;%1d;%1d;%1d;%1d;",
	                          Config.DialDir[i].DialName,
                                  Config.DialDir[i].DialNum,
	                          Config.DialDir[i].TermIdent,
                                  Config.DialDir[i].DialBaud,
	                          Config.DialDir[i].DialParity,
	                          Config.DialDir[i].DialBits,
	                          Config.DialDir[i].DialStop,
	                          Config.DialDir[i].DialMode,	                                                                                                                                                                                    
	                          Config.DialDir[i].DialTerm );
	                          
   debug(buf);	                          
   fprintf(fp,"%s\n",buf);

   }                                                                                                                              
   fclose(fp);
   return(0);
   }
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*           ECRITURE DES MACROS  DANS Un FICHIER de conf            */
/*---------------------------------------------------------------------------*/

int WriteMacro(void)
   {

   FILE *fp;
   char buf[256];
   void error_win();
   char file[256];
   int i;

   debug("WriteMacro()");
   
   
   sprintf(file,"%s%s",DEFAULT_DIR,MFILE);
   if (!(fp = fopen(file, "w"))) {
      sprintf(buf, "\"%s\"", file);
      error_win(0, "Erreur de permission sur le fichier des macros", buf);
      return(1);
   }

   for ( i=0; i < MAXMACRO ; i++ )
         fprintf(fp,"%s",Config.KeyMacro[i]);

   fclose(fp);
   return(0);
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Elimine espaces a gauche et met un \ s'il le faut,et upcase, etc...       */
/*---------------------------------------------------------------------------*/

void Ebavure(char *Buff)
{
   char *ptr=Buff;
                                                   /* vire spaces a gauche*/
   while(*Buff==' ') memmove(Buff,Buff+1,strlen(Buff));
   
   while(*ptr)ptr++;                            /* va au bout de la chaine */
   ptr--;                                       /* recule sous le zero     */
   while(*ptr==' ')                              /* vire espaces a droite   */
      {
        *ptr='\0';
        ptr--;
      }
}
                           /*-------------------------*/

void filtre_path(byte *Buff)
{
   static byte Antislash[2]={ '/',0 };
   byte *ptr=Buff;

   Ebavure(Buff);
   if(!*Buff)return;

   while(*ptr)ptr++;
   ptr--;            /* bout de chaine */

   if( ((int)*ptr !=':')&&(*ptr !='/'))
      strcat(Buff,Antislash);
/*   strupr(Buff);	*/
 }
/*---------------------------------------------------------------------------*/

/*---------------- fonctions utilitaires pour simplifier -----------------*/

int succ(int valeur,int maximum)
   {
   valeur++;
   if(valeur > maximum)
      valeur=0;
   return(valeur);
   }


int pred(int valeur)
   {
   if(valeur==0)return(0);
   valeur--;
   return(valeur);
   }


void ConfigMsg(WINDOW *wcm,byte *texte)
{
   mwrite(wcm,10,23,"                          "
                "                          ",Normal);/* efface */
   mwrite(wcm,10,23,texte,Inverse);
}


