/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
                    MODULE: CONFIG.H                                   
*/

#ifndef _CONFIG_H_
#define _CONFIG_H_



struct DialLine                   /* Ligne de repertoire telephone */
                      {                   /* 15 caracteres pour le nom et  */
                       byte DialName[16]; /* Numero,10 pour l'init modem   */
                       byte DialNum [16];
                       byte TermIdent[11];
                       int  DialBaud;
                       byte DialParity;
                       byte DialBits;
                       byte DialStop;
                       byte DialMode;     /* V23 ou Normal     */
                       byte DialTerm;     /* Terminal          */
                      };
                      
#define MAXNUMS  16     /* Nombre de lignes dans le repertoire */
#define MAXCHAMPS 7     /* Nombre d'options -1 du repertoire   */

#define MAXMACRO 10	/* nombre de macros	*/
#define MAXPORT 4        /* Nombre de ports de comm geres         */

#define MAXSPEEDS	7  /* nombre de vitesses configurables	*/


/*
   Les chaines de caracteres dans la config modem sont limitees
   a 40 caracteres, dans les macros clavier a 60 carcteres.
*/

struct ConfigType
                        {
                         byte RepereZone[40];
                         long Offset;
                         byte Port;
                         int  Baud;
                         byte Parite;
                         byte Data;
                         byte Stop;
                         byte Term;
     			 byte Modem;
                         byte DownDir[41];
                         byte UpDir[41];
                         byte InitMdm[41];
                         byte DialPre[41];
                         byte HangStr[41];
                         byte Normal_V23[41];
                         byte Invert_V23[41];
                         byte ModeNormal[41];
                         byte ModemReset[41];
                         byte ScreenLines;
                         byte VideoCard;
                         byte QbbsIdent[41];
                         byte Device[15];
                         byte KeyMacro[MAXMACRO][61];           /* 10 Keys  macros */
                         struct DialLine DialDir[MAXNUMS];/* Rpertoire phone*/
                         byte Default_Dir[64];	/* repertoire par defaut de la config	*/
                         byte Conf_File[64];	/* fichier de configuration par defaut	*/
                         byte Dial_File[64];	/* fichier repertoire telephonqiue	*/
                         byte Macro_File[64];	/* fichier des macros			*/
                        };

#define MAXOPTIONS 15   /* Nombre de parametres dans ci-dessus    */
                        /* pour le premier menu de config only    */

#define KEEP        1   /* pour saisie de chaines */
#define NEW         0




#define INPUTSIZE  2048  /* Taille des buffers pour le port srie */
#define OUTPUTSIZE 2048

#define MAXLOGBUF  100 /* Taille du Buffer du fichier Log       */

/*---------------------------------------------------------------------------*/

/*                        Declarations des fonctions                         */

  void Configuration(void );
  void ConfigMacros(void );
  void ConfigDial(int ligne );
  void ConfigPorts(void );
  void ReadPorts(void );
  void ReadConfig(void );
  void ReadDialDir(void );
  void ReadMacro(void );
  void masque_config(WINDOW *w );
  void masque_macros(WINDOW *w );
  void masque_dialconf(WINDOW *w );
  void masque_ports(void );
  void ShowPorts(void );
  void ShowConfig(WINDOW *w );
  void ShowDialDir(WINDOW *w );
  void ShowDialLine(WINDOW *w,int line,int couleur);
  void ShowMacros(WINDOW *w );
  void Modif_Macros(WINDOW *w );
  void Modif_Options(WINDOW *w );
  void Modif_DialDir(WINDOW *w ,int ligne);
  int WriteConfig(void );
  int WriteDialDir(void );
  int WriteMacro(void );
  int binrech(char *chaine,char *memoire,int taille_chaine,int taille_memoire);
  void Ebavure(char *Buff);
  void filtre_path(unsigned char *Buff);
  void Modif_Ports(void );
  int succ(int valeur,int maximum);
  int pred(int valeur);
  void ConfigMsg(WINDOW *w,unsigned char *texte);
/*---------------------------------------------------------------------------*/
#endif
