/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
Module Main

EMIL    1.0   LINUX

*/
/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur la...
#endif
/*--------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <signal.h>
#include <ncurses.h>
#include <string.h>

#include "emil.h"
#include "fonction.h"
#include "couleurs.h"
#include "commpkg.h"
#include "config.h"
#include "clavecra.h"
#include "backview.h"
#include "system.h"
#include "printer.h"
#include "minitel.h"
#include "fonte.h"


/*-----------ici le seul endroit a modifier pour le numero de version -----*/
/*                                                                         */
byte *__Version__=EMIL_VERSION;
/*                                                                         */
/*-------------------------------------------------------------------------*/
/* Les initialisations par defaut ci-dessous ne  */
/* servent plus a rien puisque la config le fait */
/* mais je suis flemmard moi hein.               */

byte Program_Name[64];    /* copie de argv[0],on en aura besoin .    */
byte TermId[15]="";       /* Ident Terminal renvoye sur ENQ         */
byte tty_term      = 0,   /* Par defaut, utilisation en terminal VTX */
ansi_term     = 0,	 
videotex_term = 1;

byte logtrace      = 0;   /* 1:en cours,2:Pause */
byte fd_echo       = 0;   /* Full Duplex        */
byte CrLfTrans     = 0;   /* translation CR/LF  */

byte Parity  = EVEN,  /* Par defaut, port 1 en 1200,E,7,1 */
Data         = 7,
Stop         = 1,
ModemType    = 1,
NumPort      = 1,
Mode_V23     = 0;
int BaudRate = 1200;

char DevPort[15]="/dev/modem";        /* pour /dev/cuaxxx     */

char Rep_Par_defaut[64]=DEFAULT_DIR;

extern byte FlagCouleur;
extern char username[];
int outchar;
byte ch;
byte OnLine  = 0; /* En ligne ou non...                  */

bool fini = 0;

byte MinVtX,MinVtY,Printing;
extern struct ConfigType Config;
extern byte *BackBuff;

#ifdef DEBUG
	FILE *dbf;
#endif

extern WINDOW *initscr(void);
extern int savetty(void);
extern int raw(void);
extern int noecho(void);
extern int nl(void);
extern int clearok();



WINDOW *win_std;	/* ecran standard	*/
WINDOW *win_stat;	/* ligne status		*/
extern WINDOW *win1;
extern WINDOW *win2;
extern WINDOW *win_vtx;

char *null_ptr="";

int console=1;
char *devtty;




void parse_args(int argc,char **argv)
{
    int     c;

    while (isascii(c = getopt(argc, argv, "h?"))) {

	switch (c) {
        case '?':     	
	case 'h':		
	        fprintf(stderr,"\nEmulateur MInitel Linux %s\n",__Version__);
		exit(0);
	}
    }
}



int main (int argc,char **argv)
{
   int tempo_dcx;
   int r;

#ifdef DEBUG
   dbf=fopen("emil.debug","w");	
/*   dbf=fopen("/dev/console","w");	*/
   debug("Debut Emil");
#endif   


/*    parse_args(argc, argv);	*/
        
    fprintf(stderr,"Emil V.%s Chargement en cours ...",__Version__);   


   strcpy(Program_Name,argv[0]); 
   debug(Program_Name);
   
   devtty = ttyname(0);

   debug(devtty);
  console=0;  
  if (!strncmp(devtty, "/dev/tty", 8))
        if ( strlen(devtty)==9 )
		console=1;
  else
  	console=0;
  	
   debugic(console,"Console");
   
#ifdef LINUX 
if (console)  
   ChargeFonte();
#endif   
   
   /* initialise le terminal	*/
   test_video();
   curseur(0);
   
   /* ecran d'accueil	*/   
   Bienvenue(0,1);

   /* on crer les fenetres de l'appli	*/
   win_std=Creer_Win(24,80,0,0,FALSE,  Normal );
   scrollok(win_std,TRUE);
   win_stat=Creer_Win(1,80,console ? 24:23,0,FALSE,FlagCouleur ? Blanc_rouge: Inverse );
   win1=Creer_Win(console ?25 : 24,18,0,0,TRUE,  Normal);	
   win2=Creer_Win(console ? 25 : 24 ,21,0,59,TRUE, Normal);	
   win_vtx=Creer_Win(console ? 25: 24,41,0,18,FALSE, FlagCouleur ? noir : Normal);

   ReadConfig();      /* initialisation des parametres */
   videotex_term=1;	/* force mode videotext	*/
   masque_vtx();
   ReadDialDir();
   ReadMacro();
   curseur(1);   
 
  if(!Init_Modem())
  {
   ligne_statut();
   tempo_dcx = 0;
   while(!fini) /*--------- Boucle sur terminal --------------*/
      {
      
      if(CarrierDetect(DevPort))
         {
         tempo_dcx = 10;
         if(!OnLine)
            {
            if(videotex_term)   /* envoi de SEP 53H,changement */
               {                /* d'etat minitel...           */
               /* Mais pas tout de suite...   */
                 /*
                 delay(1);   
                 
                 Send(DevPort,0x13);
                 Send(DevPort,'S');
                 */
               }
            OnLine=1;
            }
         }
      else
         {
         /* ne nous enervons pas!! */
         if (tempo_dcx <= 0) OnLine=0;
         else
            {
              delay (1);
              tempo_dcx--;
            }
         }

      if(tty_term) Terminal_TTY();
      if(ansi_term) Terminal_TTY();
      if(videotex_term) Terminal_VTX();
      if(Printing) Impression(win_std);
      }
}

Effacer_Win(win_std,TRUE);
Effacer_Win(win_stat,TRUE);
endwin();
resetty();
resetterm();

#ifdef LINUX
if (console)
 RestoreFonte();
#endif

fflush(stdout);
    
        
signal(SIGINT, SIG_IGN);

debug("\nC'est fini !\n");
return(0);
}
/*--------------------------------------------------------------------------*/





/*--------------------------------------------------------------------------*/
/*        Dumb terminal,tout con                                            */
/*--------------------------------------------------------------------------*/
void Terminal_TTY(void)
   {
   chrono(win_std,0,70);
   	outchar=touche(win_std,TRUE);
      if (outchar ==1)
         {
           outchar=touche(win_std,FALSE);        
           Fonctions(win_std,outchar); /* touche de fonction */
           return;
         }
   	
        if (( outchar != -1) && (outchar != 0) ) {
          if(Data<8) NoAccent((byte *)&outchar);
          Send(DevPort,outchar);       
          if (fd_echo)tty(win_std,outchar);
          }
        if ( PortReady(DevPort)) {
          ch=Receive(DevPort);
          if (ch) tty(win_std,ch);
          }   
   }
/*--------------------------------------------------------------------------*/
