/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
			EMIL
                 MODULE: FONCTION.C                                   
*/

/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur la...
#endif
/*--------------------------------------------------------*/



#include <time.h>
#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <ncurses.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>

#include "emil.h"
#include "touches.h"
#include "couleurs.h"
#include "config.h"
#include "clavecra.h"
#include "system.h"
#include "commpkg.h"
#include "minitel.h"
#include "fonction.h"






extern struct ConfigType Config;
extern byte tty_term,
ansi_term,
videotex_term,
NumPort,
Parity,
Data,
Stop,
logtrace,
fd_echo,
Mode_V23,
CrLfTrans,
OnLine,
ModemType;

extern int  BaudRate;

extern bool fini;

#ifdef LINUX
extern char DevPort[];
#endif

/* a remettre extern ! */
byte MaxVtX;
byte ModePage;

extern byte CurX,CurY,MinX,MinY,MaxX,MaxY,MaxVtY,
            FlagCouleur,CurAttr;
byte  ansicount,ansigraph,AnsiInsChar;
extern byte EGA_43;
extern byte *__Version__;

extern WINDOW *Win;
extern WINDOW *win1;
extern WINDOW *win2;
extern WINDOW *win_vtx;
extern WINDOW *win_std;
extern WINDOW *win_stat;

int LogFile ;            /* fichier trace */
extern int FileUp  ;     /* Fichier telechargement */
extern byte BbtFile[64]; /* le nom de ce fichier */
extern byte TermId[];    /* chaine renvoyee par ENQ */
char LogBuf[MAXLOGBUF];  /* Tampon pour le fichier log */
int logindex;            /* Compteur...                        */


extern char ParChar[];

int  Speeds[]={75,300,1200,2400,4800,9600,19200,38400 };
char *Parits[]={"None (Aucune)","Odd (Impaire)","Even( Paire)"};
char *Proto[]={" Aucun  ","Xon/Xoff","Cts/Rts "};

extern int console;


/*---------------------------------------------------------------------------*/
/*  Gestion des diff.fonctions disponibles par la touche ALT                 */
/*---------------------------------------------------------------------------*/

void Fonctions(WINDOW *w,int valeur)
{

debugic(valeur,"Fonctions() valeur");
 switch(valeur)
      {

         case ALT_0: /* envoi les macros clavier */
         case ALT_1:
         case ALT_2:
         case ALT_3:
         case ALT_4:
         case ALT_5:
         case ALT_6:
         case ALT_7:
         case ALT_8:
         case ALT_9:
           SendCommand(Config.KeyMacro[valeur-ALT_1]);	
         break;

         case '0' :
         case '1' :
         case '2' :
         case '3' :
         case '4' :
         case '5' :
         case '6' :
         case '7' :
         case '8' :
         case '9' :
           SendCommand(Config.KeyMacro[valeur-'0']);	
         break;

	  case ALT_A:         
	  case 'a' :
	  case 'A' :    /* Terminal ansi */
               if(videotex_term)cls(w,FlagCouleur ? Blanc_bleu : Normal);
               videotex_term=0;
               ansi_term=1;
               tty_term=0;
               Config.Term=1;
               ansigraph=0; /* on nd sait jamais... */
               ansicount=0;
               AnsiInsChar=0;
        break;

	  case ALT_B:         
	case 'b' :
	case 'B' :  /* envoi d'un Break */
	
/*            mwrite(w,10,9 ,"+-------+",Jaune_rouge);
              mwrite(w,10,10,"! BREAK !",Jaune_rouge);
              mwrite(w,10,11,"+-------+",Jaune_rouge);
*/              
              SendBreak(DevPort);
              beep();
        break;
        
	case ALT_C:         
	case 'c' :
	case 'C' :  /* efface ecran sauf ligne status*/
             if(videotex_term) cls_vtx();	
             else 
	             cls_win(w,FlagCouleur ? Blanc_bleu : Normal);
             CurAttr=7;
             ansicount=0;
             ansigraph=0;
             AnsiInsChar=0;
        break;

	case ALT_D:         
	case 'd' :
	case 'D' : /* Appel d'un Numero */
             Numerotation();	
        break;


	case ALT_E:         
	case 'e' :
	case 'E' :  /* Bascule Echo Local on/off     */
	     if (fd_echo)fd_echo=0;
	     else fd_echo=1;
        break;

	case ALT_H:         
	case 'h' :
	case 'H' : /* Raccroche la ligne            */
              Raccroche();
        break;

	
	case ALT_I:         
	case 'i':
	case 'I' : /* Impression de la page minitel	*/
              ImpVtx();	
        break;


	case ALT_J:         
	case 'j' :
	case 'J' : /* Appel systeme */
              SystemCall();	
        break;

	
	case ALT_L:         
	case 'l' :
	case 'L' :  /* Fichier log */
             gerelog();		
        break;

	case ALT_M:         
	case 'm' :
	case 'M' :	/* macros	*/
           ConfigMacros();	
        break;


	case ALT_P:         
	case 'p' :
	case 'P' :	/* config parametres	*/
          setparam();
        break;

	case ALT_R:         
	case 'r' :
	case 'R' :  /* traitement CR/CRLF */
           if(CrLfTrans)CrLfTrans=0;
           else CrLfTrans=1;
        break;
        
        	
	case ALT_S:         
	case 's' :
	case 'S' : /* Configure tout le soft        */
         Configuration();	
        break;

	case ALT_T:         
	case 't' :
	case 'T' :     /* Terminal TTY   */
           if(videotex_term) {
                 cls(win1,Normal);
                 cls(win2, Normal);
                 cls(win_vtx, Normal);
                 cls(w, Normal);	
                 werase(win1);
                 werase(win2);
                 werase(win_vtx);
                 }
           videotex_term=0;
           tty_term=1;
           Config.Term=0;
           ansi_term=0;
           
        break;

	case ALT_U:         
	case 'u' :
	case 'U' :
/*            BackView();	*/
        break;

	case ALT_V:         
	case 'v' :
	case 'V' :   /* Term Videotext */
          if(!videotex_term)  masque_vtx();
           else  cls_vtx();		 
             videotex_term=1;
             ansi_term=0;
             Config.Term=2;
             tty_term=0;
        break;
	

	case ALT_X:         
        case 'x':        /* sortie du programme  */
        case 'X':        
           askexit();	
        break;
        
	case ALT_Z:         
	case 'z' :	/*	Aide	*/
	case 'Z':
            help_screen();	
        break;


    }
   reinit_win();
   if (!fini)
      ligne_statut();              /* Met le statut a jour,peut avoir change*/
}
/*---------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*              Saisie et passage d'une commande au systeme                 */
/*--------------------------------------------------------------------------*/

typedef void SIG_TYPE;

void SystemCall(void)
{
	WINDOW *sh_win, *newwin();
	SIG_TYPE (*istat)(), (*qstat)();
	int sig_status, spid, w;
	char *shell, *shellpath, *getenv(), *strrchr();
	unsigned int sleep();
	void _exit();
	debug("SystemCall()");
					/* a full window */
	sh_win = Creer_Win(LINES, COLS, 0, 0,FALSE, Normal);
	waddstr(sh_win, "Emil <=> Unix gateway, Utiliser ^D ou 'exit' pour revenir\n");
	wrefresh(sh_win);
					/* out of curses mode */
	resetterm();

	shellpath = getenv("SHELL");
	if (shellpath == NULL || *shellpath == '\0')
		shellpath = "/bin/sh";
	shell = strrchr(shellpath, '/');
	if (shell)
		shell++;
	else {
		shellpath = "/bin/sh";
		shell = "sh";
	}

	if (!(spid = fork())) {
		signal(SIGINT, SIG_DFL);
		signal(SIGQUIT, SIG_DFL);
#ifdef SETUGID
		setgid(getgid());
		setuid(getuid());
#endif /* SETUGID */
		execl(shellpath, shell, "-i", (char *) 0);
		_exit(1);
	}
	istat = signal(SIGINT, SIG_IGN);
	qstat = signal(SIGQUIT, SIG_IGN);

	while ((w = wait(&sig_status)) != spid && w != -1)
		;

	signal(SIGINT, istat);
	signal(SIGQUIT, qstat);
					/* back to curses mode */
	sleep(1);
	fixterm();

	clearok(curscr, TRUE);
	Effacer_Win(sh_win,TRUE);
	return;
}
/*--------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*    Affichage en bas de l'ecran des differents parametres en cours         */
/*---------------------------------------------------------------------------*/
/*
      Sur la derniere ligne de l'ecran, ou dans un carre en bas a droite
      si l'on est en terminal minitel.

      Il va vraiment falloir que je reecrive ca proprement, c'est du
      bricolage tout ca, plein de rustines...
*/
void ligne_statut(void)
   {
   char workbuf[30];
   extern char *Terms[];
   static char *Logs[]  ={"    |"," LOG |","Pause|" };
   int i,marge;
   int attrib=112; /* Couleur de la ligne */
   int oldx,oldy=0;

   debug("ligne_statut()");
   oldx=CurX;
   oldy=CurY;
   if(FlagCouleur)
         {
           attrib=Blanc_rouge;
           if(videotex_term)  attrib=noir_cyan;
         }
   else
       attrib=Normal;
       

   if(!videotex_term)   
   	 werase(win_stat);
   else	{
       for(i=0;i<5;i++)
           mwrite(win2,1,MaxY-6+i,"                  ",attrib);
        }   
   sprintf(workbuf,"%s%s",__Version__,EMIL_UTS_VERSION);
   marge=strlen(workbuf);

   if(videotex_term)             /* affichage Numero version*/
      mwrite(win2,6,MaxY-8,workbuf,FlagCouleur ? Jaune_bleu : Normal );   /* a droite ligne status   */
   else
      {
        mwrite(win_stat,MaxX-marge,0,workbuf,attrib);
        mwrite(win_stat,MaxX-marge-15,0,"|Aide:CTRL-AZ| ",attrib);
      }

   if(!videotex_term)
      mwrite(win_stat,MinX+1,0,DevPort,attrib);   /* Affiche le port serie */
   else
      mwrite(win2,2,MaxY-5,DevPort,attrib);

      
   sprintf(workbuf,"%5d",BaudRate);
   if(!videotex_term)
      mwrite(win_stat,MinX+11,0,workbuf,attrib);           /* Affiche vitesse       */
   else
      mwrite(win2,2,MaxY-4,workbuf,attrib);

   sprintf(workbuf,"%c",Parity);
   if(!videotex_term)
      mwrite(win_stat,MinX+17,0,workbuf,attrib);   /* Affiche parite        */
   else
      mwrite(win2,14,MaxY-4,workbuf,attrib);
      
   sprintf(workbuf,"%1d",Data);
   if(!videotex_term)
      mwrite(win_stat,MinX+19,0,workbuf,attrib);          /* Affiche format        */
   else
      mwrite(win2,16,MaxY-4,workbuf,attrib);

      
   sprintf(workbuf,"%1d",Stop);
   if(!videotex_term)
      mwrite(win_stat,MinX+21,0,workbuf,attrib);          /* Affiche bits de stop  */ 
   else
      mwrite(win2,18,MaxY-4,workbuf,attrib);

   if(!videotex_term)
    mwrite(win_stat,MinX+22,0,"|",attrib);
    
   if(!videotex_term)      {
      i=0;                             /* Type d'emulation term */
      if(ansi_term)i=1;
      mwrite(win_stat,MinX+23,0,Terms[i],attrib);
      }

   if(!videotex_term)      {
      mwrite(win_stat,MinX+27,0,"|",attrib);/* Echo local ou pas     */
      if(fd_echo)
         mwrite(win_stat,MinX+28,0,"HDX|",attrib);
      else	
         mwrite(win_stat,MinX+28,0,"FDX|",attrib);
      }
   else          {
      if (fd_echo) mwrite(win2,4,MaxY-4,"   Echo Local ",attrib);
      else   mwrite(win2,1,MaxY-3," Pas Echo Local",attrib);
      }
   if(!videotex_term)
      mwrite(win_stat,MinX+32,0,Logs[logtrace],attrib);   /* Statut fichier log    */
   else
      {
      if(logtrace==1)mwrite(win_stat,MaxVtX+4,0," Log  Ouvert ",attrib);
      if(logtrace==2)mwrite(win_stat,MaxVtX+4,0," Log en Pause",attrib);
      }

   if(videotex_term)
      {
      if(ModePage)mwrite(win2,4,MaxY-2,"  Mode Page ",attrib);
      else mwrite(win2,4,MaxY-2," Mode Rouleau",attrib);
      }


   if(!videotex_term) if(CrLfTrans)
      mwrite(win_stat,MinX+38,0,"CR-->CR+LF |",attrib);   /* Statut Translation CR */

   if(!videotex_term) if(Mode_V23)
      mwrite(win_stat,MinX+50,0,"| Mode V23",attrib);     

   if(videotex_term) if(Mode_V23)
      mwrite(win2,4,MaxY-1,"  Mode V23 ",attrib);
   CurX=oldx;
   CurY=oldy;
   reinit_win();
   	
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*    Suppression tant bien que mal des caracteres du 8 Bit                 */
/*---------------------------------------------------------------------------*/
/*
   Les accentues IBM sont remplaces par leur homologue non accentue,
   tout les autres sont remplaces elegamment par une asterisque...
   (Un mauvais jour j'aurais pu mettre le chr 7... le Beep...)

   Attention c'est une adresse,le truc lui meme est modifie !
*/
void NoAccent(byte *ch)
   {
   debug("NoAccent()");

   switch(*ch)
      {
   case 131:
   case 132:
   case 133:
   case 134:
   case 160:
      *ch='a';
   break;

   case 142:
   case 143:
      *ch='A';
   break;

   case 130:
   case 136:
   case 137:
   case 138:
      *ch='e';
   break;

   case 139:
   case 140:
   case 141:
   case 161:
      *ch='i';
   break;

   case 147:
   case 148:
   case 149:
   case 162:
      *ch='o';
   break;

   case 129:
   case 150:
   case 151:
   case 163:
      *ch='u';
   break;

   case 152:
      *ch='y';
   break;
   case 135:
      *ch='c';
   break;
   case 128:
      *ch='C';
   break;
   case 164:
      *ch='n';
   break;
   case 165:
      *ch='N';
   break;
   case 144:
      *ch='E';
   break;
   case 153:
      *ch='O';
   break;
   case 154:
      *ch='U';
   break;
   case 179:
      *ch='|';
   break;

   default:
      if(*ch >127) *ch='*';
      }
   }
/*---------------------------------------------------------------------------*/


#ifndef LINUX

/*---------------------------------------------------------------------------*/
/*      Envoi d'un fichier texte dans le port.                               */
/*---------------------------------------------------------------------------*/
/*
             On peut annuler par Escape.
             Si on est en 7 bits data, le jeu etendu IBM est translate en
             les caracteres non-accentues correspondants, on en une aste-
             risque si ils n'existent pas.
*/

void envoi_ascii(int fichier,int Lent)
{
byte tampon[512];
int test,i;
byte ch;


while(1)                                       /* boucle d'envoi */
      {

      test=read(fichier,tampon,512);
      if(!test)break; /* fin de fichier*/
      for(i=0;i<test;i++)
            {
             if(kbhit())
              {
              ch=getch();
              if(ch==ESC)
                {
                 #ifdef CURSES
                 beep();
                 #else
                 beep(1);
                 #endif
                 sauvecran();
                  mwrite(30,10," Envoi stopp par ESC ",Inverse);
                   XFlush(NumPort);
                    close(fichier);
                   delay(2); /* affiche 2 secondes */
                  rendecran();
                 return;       /* arrt par excape */
                }
               }
             if(tty_term)Terminal_TTY();       /* recup echo du serveur */
             if(ansi_term)Terminal_ANSI();
             if(videotex_term)Terminal_VTX();
             if(Data<8)NoAccent(&tampon[i]);
             if(tampon[i]==26)continue;        /* Cntrl-Z msdos          */
             if(Lent)delay(1);               /* Ralentissement 75 bauds*/
             while(XFree(NumPort)<2) /* attend un peu de place buffer... */
              {
              if(kbhit())
                  {
                   ch=getch();
                    if(ch==ESC)      /* ne pas rester coinc l...*/
                      {
                      #ifdef CURSES
                      beep();
                      #else
                       beep(1);
#endif
                       sauvecran();
                        mwrite(30,10," Envoi stopp par ESC ",Inverse);
                         XFlush(NumPort);
                          close(fichier);
                         delay(2); /* affiche 2 secondes */
                        rendecran();
                       return;        /* arrt par excape */
                       }
                   }
              }
             Send(NumPort,tampon[i]);
            }
      }
close(fichier);
}
/*---------------------------------------------------------------------------*/



#endif

/*---------------------------------------------------------------------------*/
/*    demande confirmation pour retour sous DOS, ferme le port et tout.      */
/*---------------------------------------------------------------------------*/
/*
 saisie en mode hotkey,seules prises en compte 'O' et' N',
 retourne au systeme avec errorlevel 0
*/
void askexit(void)
   {
  int x,y,ch;
  x=CurX,y=CurY;
  debug("askexit()");
  Win=Creer_Win(4,21,10,5,TRUE, FlagCouleur ? Blanc_rouge : Inverse) ;
  mwrite(Win,0,0," Sortir du programme ",Inverse);
  mwrite(Win,5,2,"O/N:",FlagCouleur ? Blanc_rouge : Inverse);
  locate(Win,9,2);
  while(!fini)
      {
      echo();
      ch=touche(Win,TRUE);
      noecho();
      if ((ch=='o') || (ch=='O') || (ch=='y') || (ch=='Y'))
         {
           SendCommand(Config.ModemReset);
           sleep(3);	/* attendre que le modem reponde pour fermer le port	*/
           CloseCom(DevPort);
           if(logtrace)
              {
	        FlushLog();    /* Ne pas oublier ca...! */
                close(LogFile);
              }
           cls(stdscr,blanc);
           mwrite(Win,0,0,"---- Bye !----",A_NORMAL);
           fini = 1;  /* exit(0); */
         }
        if((ch=='n')||(ch=='N'))
         {
	   Effacer_Win(Win,TRUE);                                    
           locate(win_std,x,y);
           return;
         }
      }
   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*    Ouverture et gestion de l'tat du fichier log de la session            */
/*---------------------------------------------------------------------------*/
void gerelog(void)
   {
   static byte filename[54];
   int ch;
   void error_win();
   WINDOW *win_log;
   
   debug("gerelog()");   	

   if(!logtrace)   /*--------------------- pas de fichier, faut l'ouvrir */
      {
        win_log=Creer_Win(4,70,10,5,TRUE,FlagCouleur ? jaune_rouge : Normal );

       mwrite(win_log,1,1," Enregistrer la session dans le fichier: ",Inverse);
       if((saisie(win_log,10,2,filename,blanc_bleu,53,NEW)==ESC)||(!*filename))
         {
         werase(win_log);
         wrefresh(win_log);
         delwin(win_log);
         return;  /* pas de nom ou saisie abandonnee */
         }
       LogFile=open(filename, O_RDWR | O_CREAT | O_APPEND,0600 );
        if(LogFile==-1)        {
          error_win(0," Impossible de d'ouvrir",filename);
          werase(win_log);
          wrefresh(win_log);
          delwin(win_log);
          return;
         }
      logindex=0;
      logtrace=1;
      werase(win_log);
      wrefresh(win_log);
      delwin(win_log);
      rendecran();
      return;
      }
   else         {
      win_log=Creer_Win(8,30,10,5,TRUE,FlagCouleur ? jaune_rouge : Normal );
      mwrite(win_log,10,0," Fichier Log: ",Inverse);
      mwrite(win_log,1,1,filename,blanc_bleu);
      mwrite(win_log,1,6,"ESC sort sans changement",blanc_bleu);
      if(logtrace==1)  {/*Fichier en cours d'utilisation */
         mwrite(win_log,8,2,"P.....: Pause",Blanc_bleu);
         mwrite(win_log,8,3,"F ou C: Ferme",Blanc_bleu);
         while(1)    {
            ch=touche(win_log,FALSE);
            switch(ch)  {
                       case 'P':
                       case 'p':
                          logtrace=2;
                          rendecran();
                          werase(win_log);
                          wrefresh(win_log);
                          delwin(win_log);
                       return;

                       case 'C':
                       case 'c':
                       case 'F':
                       case 'f':
                         FlushLog();
                         close(LogFile);
                           *filename=0;
                          logtrace=0;
                         rendecran();
                          werase(win_log);
                          wrefresh(win_log);
                          delwin(win_log);
                       return;

                       case ESC:
                        rendecran();
                          werase(win_log);
                          wrefresh(win_log);
                          delwin(win_log);
                       return;
                     }
            }
         }


      if(logtrace==2)  {/* Fichier ouvert mais pause  */
         mwrite(win_log,8,4,"A ou U: Active",Blanc_bleu);
         mwrite(win_log,8,5,"F ou C: Ferme" ,Blanc_bleu);
         while(1)  {
            ch=touche(win_log,FALSE);
            switch(ch)
                     {
                       case 'A':
                       case 'a':
                       case 'U':
                       case 'u':
                        logtrace=1;
                        rendecran();
                          werase(win_log);
                          wrefresh(win_log);
                          delwin(win_log);
                       return;

                       case 'C':
                       case 'c':
                       case 'F':
                       case 'f':
                         FlushLog();
                           close(LogFile);
                            *filename=0;
                           logtrace=0;
                         rendecran();
                          werase(win_log);
                          wrefresh(win_log);
                          delwin(win_log);
                       return;

                       case ESC:
                        rendecran();
                       return;
                     }
            }
         }
      }
   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*    Ecriture bufferisee du fichier log,peinard...                          */
/*---------------------------------------------------------------------------*/

void LogPutc(byte ch)              /* ecrit un chr dans le tampon, ecrit */
{                     
             /* le tampon s'il est plein           */
   debug("LogPutc()");          
   
   if ( (ch > 0x1f) || (ch==0x0a) )	{	/* pas les caracteres de controles	*/
	   LogBuf[logindex]=ch;
	   logindex++;
	}
   if(logindex > MAXLOGBUF-1)
      {
        write(LogFile,LogBuf,logindex);
        logindex=0;
      }
 }

void FlushLog(void)                  /* Force l'criture du contenu tampon */
{
     debug("FlushLog()");
     write(LogFile,LogBuf,logindex);
     logindex=0;
}
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*  Modification des Parametres de communications                            */
/*---------------------------------------------------------------------------*/

void setparam(void)
   {
   char workbuf[30];

   int ch,index=0;
   void error_win();

   byte *port      = DevPort;
   int vitesse    = BaudRate;
   byte format    = Data;
   byte parite    = Parity;
   byte stop_bits = Stop;
   byte proto     = ModemType;
   int attrib = FlagCouleur ? Blanc_bleu : Normal;
   int _attrib = FlagCouleur ? Cyan_bleu : Inverse;

   
   WINDOW *e_win;
   debug("setparam()");
   
   fixterm();
   e_win=Creer_Win(16,31,5,40,TRUE,FlagCouleur ? Blanc_bleu : Normal );
   while(vitesse != Speeds[index])index++;     /* cherche speed dans tablo */
   switch(Parity) {
   	case 'N' :
   		parite=0;
   		break;
	case 'O' :
		parite=1;
		break;
	case 'E' :
		parite=2;
		break;
	}

   mwrite(e_win,1,1," PARAMETRES DE COMMUNICATION ",_attrib);
   mwrite(e_win,3,3,"Port   :             (C)",attrib);
   mwrite(e_win,3,4,"Vitesse:       Bauds (V)",attrib);
   mwrite(e_win,3,5,"Format :       Bits  (F)",attrib);
   mwrite(e_win,3,6,"Parite :             (P)",attrib);
   mwrite(e_win,3,7,"Arret  :       Bit(s)(A)",attrib);
   mwrite(e_win,3,8,"Protocol:            (X)",attrib);
   mwrite(e_win,1,11,"C,V,F,P,A, modifient valeurs",attrib);
   mwrite(e_win,1,12,"<Enter> Pour valider choix; ",attrib);
   mwrite(e_win,1,13,"W ecrit la config sur disque",attrib);
   mwrite(e_win,1,14,"ESCape sort sans rien changer",attrib);
   curseur(0);
 while(1)
      {
      mwrite(e_win,11,3,port,attrib);
      
      sprintf(workbuf,"%5d",Speeds[index]);
      mwrite(e_win,11,4,"     ",attrib); /* efface */
      mwrite(e_win,11,4,workbuf,attrib);
      
      sprintf(workbuf,"%1d",format);
      mwrite(e_win,11,5,workbuf,attrib);
      
      mwrite(e_win,11,6,Parits[parite],attrib);
      
      sprintf(workbuf,"%1d",stop_bits);
      mwrite(e_win,11,7,workbuf,attrib);
      
      mwrite(e_win,12,8,Proto[proto],attrib);
      
      ch=touche(e_win,FALSE);
      switch(ch)	{
      		
	     case 'C' :
	     case 'c' :      			
		  saisie(e_win,11,3,DevPort,_attrib,12,0);
		  curseur(0);
                  break;

	     case 'V':
	     case 'v':
                  index++;
                  if(index > MAXSPEEDS) /* IL Y A 7 VITESSE PREVUES */
                  index=0;
                  vitesse=Speeds[index];
                  break;

	     case 'P' :
	     case 'p' :
                   parite++;
                   if(parite >2)parite=0;
                   break;

	     case 'F' :
	     case 'f' :
                  format++;
                  if(format > 8) format= 5;
                  break;

	     case 'A' :
	     case 'a' :
                 stop_bits++;
                 if(stop_bits >2)stop_bits=1;
		 break;
		 
	     case 'X' :
	     case 'x' :
	          proto++;
	          if (proto > 2) proto=0;
	          break;
	          
	     case 'W' :
	     case 'w' :
                  BaudRate = vitesse;
                  Config.Baud=BaudRate;
                  Data     = format;
                  
                  Config.Data=Data;
		  Parity=ParChar[parite];
		  Config.Parite=ParChar[parite];	    			                      	    
                  Stop     = stop_bits;
                  Config.Stop=Stop;
	          ModemType= proto;
	          Config.Modem=ModemType;    
                 if ( WriteConfig()) error_win(0, "Impossible de sauvegarder le configuration","");
        	   break;
	     	   	         	 
	     case RETOUR : 
                  if(PortOpen(DevPort))CloseCom(DevPort);
                  BaudRate = vitesse;
                  Data     = format;
                  ModemType=proto;
		  Parity=ParChar[parite];	    			                      	    
                  Stop     = stop_bits;
                  OpenCom(DevPort,BaudRate,Parity,Data,Stop,1,0);
                  werase(e_win);
                  wrefresh(e_win);
                  delwin(e_win);
                  curseur(1);
                  return;
		
	    case ESC :
                  werase(e_win);
                  wrefresh(e_win);
                  delwin(e_win);
                  curseur(1);
                  return;
          }

      }
   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*         Mise du modem Hors-Ligne                                          */
/*---------------------------------------------------------------------------*/
/*
        On commence par tenter de raccrocher au plus vite; si
        ca ne marche pas (config du modem); on envoie la longue
        sequence Hayes.
        Si il n'y a pas de porteuse,il est evident qu'on ne fait rien.
*/
void Raccroche(void)
{
    debug("Raccroche()");
    if(CarrierDetect(DevPort))
      {
        SetDTR(DevPort,0);
        delay(1);
      }
    if(CarrierDetect(DevPort)) SendCommand(Config.HangStr);
}
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*     Envoi d'une chaine codee au modem,(metacaracteres ~ et ^)             */
/*---------------------------------------------------------------------------*/

void SendCommand(byte *Chaine)
{
   byte *ptr=Chaine;
   
   debugsc(Chaine,"SendCommand() Chaine");

   while(*ptr)ptr++;                            /* va au bout de la chaine */
   ptr--;                                       /* recule sous le zero     */
   while(*ptr==' ')                              /* vire espaces a droite   */
        {
        *ptr='\0';
        ptr--;
        }

   ptr=Chaine;
   
   while(*ptr)
        {
         if(*ptr=='~')        /* Le Tilde correspond a une attente de 1/2 s */
           {
              delay(1);
              ptr++;
              continue;
           }

        if(*ptr=='^')         /* '^' annonce un caractere de controle        */
          {
              ptr++;
              Send(DevPort,*ptr-64);
              ptr++;
              continue;
          }
        if(Data<8)NoAccent(ptr);        /* translate accentues si 7 bits   */
        Send(DevPort,*ptr);
        ptr++;
        }
}
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*            Saisie Manuelle et appel d'un Numero de telephone              */
/*---------------------------------------------------------------------------*/

void ManualDial(void)
{
   static byte WorkBuf[41]="";  /* pas plus de 40 caracteres une commande hayes...*/
   static byte Numero[41] ="";
   static byte Rc[2]={0x0D,0x00 };
   byte *ptr=WorkBuf;
   WINDOW *win_man;
   int  attrib=FlagCouleur ? Blanc_bleu : Normal ;
   int _attrib=FlagCouleur ? noir_blanc : Inverse;
   
   debug("ManualDial()");
   
   
   win_man=Creer_Win(5,55,10,10,TRUE,attrib );
   mwrite(win_man,1,2,"Numero a Composer",attrib);
   if((saisie(win_man,20,2,Numero,_attrib,30,NEW)==ESC)||(!*Numero))
      {
       Effacer_Win(win_man,TRUE);
       return;
      }

   *TermId=0; /* Pas d'indentification terminal dans ce cas */
      strcpy(WorkBuf,Config.DialPre);          /* prefixe de numerotation */
      strcat(WorkBuf,Numero);
      strcat(WorkBuf,Rc);   /* Termine par un RC ! */
      while(*ptr)
         {
           Send(DevPort,*ptr);
           ptr++;
            }
   Effacer_Win(win_man,TRUE);
   reinit_win();
}
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*   Appel d'un numero dans le repertoire telephonique nique nique           */
/*---------------------------------------------------------------------------*/
void Numerotation(void)
   {
   int ch;
   register int i;
   int Niv=0;
   byte WorkBuf[5];
   char temp[80];
   WINDOW *win_num;
   int  attrib=Normal ;
   int  attrib1=FlagCouleur ? Cyan_bleu : Normal ;
   int _attrib=Inverse;


   debug("Numerotation()");
   curseur(0);
   win_num=Creer_Win(console? 25: 24 ,80,0,0,TRUE,attrib);
   mwrite(win_num,25 ,1," Petit rpertoire tlphonique ",_attrib);
   mwrite(win_num,12,20,"########################################################",attrib1);
   mwrite(win_num,12,21,"#                                                      #",attrib1);
   mwrite(win_num,12,22,"#                                                      #",attrib1);
   mwrite(win_num,14,21,"Appel Manuel   : Tapez M   Retour Terminal:Tapez ESC",attrib);
   mwrite(win_num,14,22,"Reconfiguration: Tapez R",attrib);
   mwrite(win_num,12,23,"########################################################",attrib1);

   mwrite(win_num,6, 3,"******NOM************NUMERO******Bauds**Par*Bit*Stop*V-23*Term*",attrib1);

   for(i=0;i<MAXNUMS;i++)
      {
       if(i<9) sprintf(WorkBuf,"%1d :",i);   /* Affiche de 1 a 9 puis de A a G */
        else   sprintf(WorkBuf,"%1c :",56+i);
       mwrite(win_num,3,i+4,WorkBuf,attrib);
      }
   ShowDialDir(win_num);

   while(1)
      {

       mwrite(win_num,1,Niv+4,"->",attrib);

      ShowDialLine(win_num,Niv,_attrib);
      ch=touche(win_num,FALSE);

      if( (ch >'0') &&(ch <'9')) /* commande directe,chiffres */
         {

          mwrite(win_num,1,Niv+4,"  ",attrib);
          ShowDialLine(win_num,Niv,attrib);
          Niv=ch-48;
          ch=RETOUR;
         }

      if( (ch >'A') &&(ch <'F')) /* commande directe,majuscules */
         {

          mwrite(win_num,1,Niv+4,"  ",attrib);
          ShowDialLine(win_num,Niv,attrib);
          Niv=ch-56;
          ch=RETOUR;
         }

      if( (ch >'a') &&(ch <'f')) /* commande directe,minuscules */
         {

          mwrite(win_num,1,Niv+4,"  ",attrib);
          ShowDialLine(win_num,Niv,attrib);
          Niv=ch-88;
          ch=RETOUR;
         }

      switch(ch)
         {
          case 'R':  /*----- R, Configuration du repertoire */
          case 'r':
            ConfigDial(Niv);	
            Effacer_Win(win_num,TRUE);
          return;

          case 'M':  /*----- M, Appel Manuel d'un numero    */
          case 'm':
            curseur(1);
            ManualDial();	
          Effacer_Win(win_num,TRUE);  
          return;

         case ESC: /*----- Sortie par Escape              */
          Effacer_Win(win_num,TRUE);  
           curseur(1);
         return;

         case BAS:

           mwrite(win_num,1,Niv+4,"  ",attrib);
           ShowDialLine(win_num,Niv,attrib);
           Niv=succ(Niv,MAXNUMS-1);
         break;

         case HAUT:
 
           mwrite(win_num,1,Niv+4,"  ",attrib);
           ShowDialLine(win_num,Niv,attrib);
            Niv=pred(Niv);
         break;



      case RETOUR:
 
         mwrite(win_num,1,Niv+4,"->",attrib);
         ShowDialLine(win_num,Niv,_attrib);
         sprintf(temp,"Patientez, appel de %s en cours ...",Config.DialDir[Niv].DialName);
         mwrite(win_num,(80-strlen(temp))/2,20,temp,_attrib);
		
         /* Reinitialisation du port de comm */
         debugsc(DevPort,"Numerotation() DevPort");
         if(PortOpen(DevPort))CloseCom(DevPort);

         BaudRate=Config.DialDir[Niv].DialBaud;
         debugic(BaudRate,"Numerotation() BaudRate");
         Parity  =ParChar[Config.DialDir[Niv].DialParity];
         debugcc(Parity,"Numerotation() Parity");
         Data    =Config.DialDir[Niv].DialBits;
         debugic(Data,"Numerotation() Data");
         Stop    =Config.DialDir[Niv].DialStop;
         debugic(Stop,"Numerotation() Stop");
         Mode_V23=Config.DialDir[Niv].DialMode;

/*         if((Config.Modem==2)&&(Mode_V23)) BaudRate=75;	*/
         /* Evitons les erreurs stupides rha la la. */
         OpenCom (DevPort,BaudRate,Parity,Data,Stop,1, 0);
         /*  Coupure du modem, au cas ou... */
         delay(2);
         SetDTR(DevPort,0);
         delay(1);
         SetDTR(DevPort,1);
         delay(1);

         
         /* Mise en place du terminal ad hoc */
         debugic(Config.DialDir[Niv].DialTerm,"Numerotation() Term");

/*         if(Config.DialDir[Niv].DialTerm==0) Fonctions(stdscr,ALT_T);
         if(Config.DialDir[Niv].DialTerm==1) Fonctions(stdscr,ALT_A);
         if(Config.DialDir[Niv].DialTerm==2) Fonctions(stdscr,ALT_V);
*/ 
         curseur(1);

         
         strcpy(TermId,Config.DialDir[Niv].TermIdent);

         if(Mode_V23)    /* S'il faut passer en V23 on y va*/
                    SendCommand(Config.Normal_V23);
                    
              else                        /* Sinon on se met en mode normal */
                    SendCommand(Config.ModeNormal);
           delay(1);

           SendCommand(&Config.DialPre[0]);             /* Prefixe Num */
           delay(1);
           SendCommand(&Config.DialDir[Niv].DialNum[0]);/* Numero      */
           Send(DevPort,13);                            /* Le RC !!!   */
           delay(1);
           Effacer_Win(win_num,TRUE);  
           return;
            }
         }
      }


/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*        Initialisation du modem                                            */
/*---------------------------------------------------------------------------*/

bool Init_Modem(void)
   {
   debug("Init_Modem()");
   OpenCom(DevPort,BaudRate,Parity,Data,Stop,1,0);  
   SendCommand(Config.InitMdm);	
   sleep(1);
   return 0;
   }
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*           Ecran d'aide appele par ALT-Z                                   */
/*---------------------------------------------------------------------------*/
void help_screen(void)
{
   int ch;
   int oldx=CurX;
   int oldy=CurY;
   WINDOW *e_win;
   debug("help_screen()");
   e_win=Creer_Win(console ? 25 : 24,80,0,0,TRUE,Normal );   
   mwrite(e_win,3,0,"Emil Version ",Inverse);
   mwrite(e_win,16,0,__Version__,Inverse);
   mwrite(e_win,40,0,"* Linux * Linux *",Inverse);
   mwrite(e_win,20, 1," Fonctions disponibles par les touches ""CTRL-A"" ",Inverse);
   mwrite(e_win,20,2," ############################################# ",Normal);

   mwrite(e_win,5,4,"###########################",Normal);
   mwrite(e_win,15,4,"TERMINAL",Inverse);
/*   mwrite(e_win, 5, 6,"CTRL-A A: Terminal ANSI-bbs" ,Normal  );*/
   mwrite(e_win, 5, 7,"CTRL-A T: Terminal TTY"      ,Normal  );
   mwrite(e_win, 5, 8,"CTRL-A V: Terminal Videotex" ,Normal  );
   mwrite(e_win, 5, 9,"CTRL-A E: Echo Local (bascule)",Normal);
   mwrite(e_win, 5,10,"CTRL-A C: Efface l'ecran"      ,Normal);
   mwrite(e_win, 5,11,"CTRL-A R: Translation CR->CRLF",Normal);

   mwrite(e_win,35, 4,"###########################",Normal);
   mwrite(e_win,42, 4,"COMMUNICATION",Inverse);
/*   mwrite(e_win,35, 6,"CTRL-A B: Envoie un Break"  ,Normal  );	*/
   mwrite(e_win,35, 7,"CTRL-A D: Appel d'un Numero",Normal  );
   mwrite(e_win,35, 8,"CTRL-A H: Raccroche la ligne",Normal );
   mwrite(e_win,35, 9,"CTRL-A P: Parametres de Comm.",Normal);
/*   mwrite(e_win,35,10,"PgUp : Upload "            ,Normal );*/
/*   mwrite(e_win,35,11,"PgDn : Download"           ,Normal );*/

   mwrite(e_win, 5,14,"###########################",Normal);
   mwrite(e_win,16,14,"DIVERS",Inverse);
   mwrite(e_win, 5,15,"CTRL-A I: Impression page",Normal  );
   mwrite(e_win, 5,16,"CTRL-A J: Commande systeme"  ,Normal  );
   mwrite(e_win, 5,17,"CTRL-A L: Fichier Log"       ,Normal  );
   mwrite(e_win, 5,18,"CTRL-A S: Configuration Emil ",Normal  );
/*   mwrite(e_win, 5,19,"CTRL-A W: EGA: 43/25 lignes" ,Normal  );*/
   mwrite(e_win, 5,20,"CTRL-A X: Fin-Retour Systeme",Normal  );
   mwrite(e_win, 5,21,"CTRL-A Z: Cet ecran d'aide..." ,Normal);


   mwrite(e_win,35,14,"###########################",Normal);
   mwrite(e_win,35,15,"CTRL-A M: Definition Macros",Normal);
   mwrite(e_win,35,16,"CTRL-1  10 touches d'envoi",Normal);
   mwrite(e_win,35,17,"CTRL-x    des  macros"    ,Normal );
   mwrite(e_win,35,18,"CTRL-0    predefinies"    ,Normal );
   mwrite(e_win,35,19,"CTRL-A U:Revoir ecrans preced.",Normal);

   mwrite(e_win,35,21,"- Appuyez sur une touche -" ,Inverse);

   ch=touche(e_win,FALSE);
   Effacer_Win(e_win,TRUE);
   CurX=oldx;
   CurY=oldy;	
         
}
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*               Bienvenue: ECRAN D'ACCUEIL a l'ENTREE DU PROGRAMME          */
/*---------------------------------------------------------------------------*/

void Bienvenue(byte Mont,byte Parnasse)
{
   WINDOW *win_pre;
   char temp[50];
   int ch;
   debug("Bienvenue()");
   curseur(0);
   win_pre=Creer_SubWin(21,40,Parnasse,Mont,TRUE,Normal,stdscr);
   mwrite(win_pre,Mont+5,Parnasse+ 1,"#######  ##  ##  ### ###",FlagCouleur ? Jaune_bleu : Normal);
   mwrite(win_pre,Mont+5,Parnasse+ 2," #       ##  ##   #   #",FlagCouleur ? Jaune_bleu : Normal);
   mwrite(win_pre,Mont+5,Parnasse+ 3," ####    # ## #   #   #",FlagCouleur ? Jaune_bleu : Normal);
   mwrite(win_pre,Mont+5,Parnasse+ 4," #       #    #   #   #",FlagCouleur ? Jaune_bleu : Normal);
   mwrite(win_pre,Mont+5,Parnasse+ 5,"####### ###  ### ### ###### ",FlagCouleur ? Jaune_bleu : Normal);
   mwrite(win_pre,Mont+1,Parnasse+ 7,"(c)1995 Eldin Henry-Pascal V ",FlagCouleur ? Jaune_bleu : Normal);
   sprintf(temp,"par %s@%s",EMIL_COMPILE_BY,EMIL_COMPILE_HOST);
   mwrite(win_pre,Mont+1,Parnasse+8, temp,FlagCouleur ? blanc_bleu : Normal);
   sprintf(temp,"%s",EMIL_COMPILE_DATE);
   mwrite(win_pre,Mont+1,Parnasse+9, temp,FlagCouleur ? blanc_bleu : Normal);
   mwrite(win_pre,Mont+1,Parnasse+11,"Linux * Linux * Linux * Linux * Linux",FlagCouleur ? blanc_bleu : Normal);
   mwrite(win_pre,Mont+1,Parnasse+12,"   Emulateur Minitel simple",FlagCouleur ? Cyan_bleu : Normal);
   mwrite(win_pre,Mont+1,Parnasse+14,"Bugs eldin@privas.gatelink.fr.net",FlagCouleur ? blanc_bleu : Normal);
   mwrite(win_pre,Mont+1,Parnasse+16,"      Ecran d'aide :tapez CTRL A Z",FlagCouleur ? Jaune_bleu : Normal);
   mwrite(win_pre,Mont+1,Parnasse+17,"      Configuration:tapez CTRL A S",FlagCouleur ? Jaune_bleu : Normal);
   sprintf(temp,"%s%s",__Version__,EMIL_UTS_VERSION);
   mwrite(win_pre,Mont+29,Parnasse+7,temp,FlagCouleur ? Cyan_bleu : Normal);
   mwrite(win_pre,Mont+5,Parnasse+18,"- Appuyez sur une touche -" ,FlagCouleur ? Blanc : Normal);

   ch=touche(win_pre,FALSE);
          
   delwin(win_pre);
	
}
/*---------------------------------------------------------------------------*/



char *findfile(char *extra, char *name)
{
	int i;
	char *Emil, *getenv(), *path, pbuf[200], *getcwd(), *str_dup();
	char temp[200];
	
	debugss(extra,name,"findfile()");
        path= NULL;
	Emil = getenv("EMIL");
	if (Emil == NULL || *Emil == '\0')
		Emil = NULL;
	else {
					/* zap the trailing separator */
		if (Emil[strlen(Emil)-1] == '/')
			Emil[strlen(Emil)-1] = '\0';
	}
	for (i=0; i<4; i++) {
					/* directory search order */
		switch (i) {
			case 0:		/* extra directory from command line */
				path = extra;
				break;
			case 1:		/* Emil environmental variable */
				path = Emil;
				break;
			case 2:		/* current working directory */
				path = getcwd(pbuf, 200);
				break;
			case 3:		/* Emil default directory */
				path = DEFAULT_DIR;
				break;
		}
		if (path == NULL)
			continue;

		sprintf(temp, "%s/%s", path, name);
		debug(temp);		

   		/* read permission checked */
		if (!access(temp, 4))
			return(str_dup(temp));
	}
	return(NULL);
}


char *str_dup(char *str)
{
	extern char *null_ptr;
	char *ret, *malloc(), *strcpy();

  	/*debugsc(str,"str_dup()");	*/
	if (str == NULL)
		return(NULL);
					/* if pointer to null */
	if (*str == '\0')
		return(null_ptr);

	if (!(ret = malloc((unsigned int) strlen(str)+1)))
		fprintf(stderr,"Out of memory !");

	strcpy(ret, str);
	return(ret);
}
/*
 * This routine is similar to strtok(3).  But this version handles missing
 * tokens by returning a pointer to null.  Also it takes a single separator
 * character as an argument.  Returns a NULL on end of string or error.
 */

char *str_tok(char *str,char c)
{
	char *strchr();
	static char *ptr, *sep;
	
	/*debugis(c,str,"str_tok()");*/		/* start at beginning */
	if (str != NULL)
		ptr = str;
	else
		ptr = sep;
					/* at the end? */
	if (*ptr == '\0')
		return(NULL);
					/* no separator? */
	if (!(sep = strchr(ptr, c)))
		return(NULL);
					/* zap the sep, move past it */
	*sep = '\0';
	sep++;

	return(ptr);
}


void chrono(WINDOW *w,int y,int x)
{
long now; 
struct tm *tm;
char temp[20];

/* pour l'affichage du temps de connexion	*/ 
static int cnx_h;
static int cnx_mn;
static int cnx_s;
static int ocnx_s;

 
time(&now);
tm = localtime(&now);
if (OnLine)	{
	if (tm->tm_sec != ocnx_s) {cnx_s++;ocnx_s=tm->tm_sec; }
	if (cnx_s > 59 )	{
		cnx_s=0;
		cnx_mn++;
		if ( cnx_mn > 59 )	{
			cnx_mn=0;
			cnx_h++;
			}
		}
	}
sprintf(temp,"%02d:%02d:%02d",tm->tm_hour,tm->tm_min,tm->tm_sec);
wmove(w,y,x);
wattrset(w, FlagCouleur ? COLOR_PAIR(blanc_bleu) :Normal );
waddstr(w,temp);
wattroff(w,FlagCouleur ? COLOR_PAIR(blanc_bleu) : Normal );	
touchwin(w); 
wrefresh(w);
if (OnLine)	{
	if (videotex_term) {	
		w=win2;
		wmove(w,1,1);
		}
	else
		wmove(w,y,x-9);
	sprintf(temp,"%02d:%02d:%02d",cnx_h,cnx_mn,cnx_s);
	wattrset(w,FlagCouleur ? COLOR_PAIR(blanc_bleu) : Normal );
	waddstr(w,temp);
	wattroff(w,FlagCouleur ? COLOR_PAIR(blanc_bleu): Normal );
        touchwin(w);	
	wrefresh(w);
	}
}                                                  
            
                                                  
void reinit_win()
{
   debug("reinit_win()");	
   debug2ic(CurY,CurX,"CurY CurX");
   if (videotex_term)	{
	touchwin(win_vtx);	
        touchwin(win2);
        touchwin(win1);
        wmove(win_vtx,CurY,CurX);
	}
     else	{
	touchwin(win_std);
	touchwin(win_stat);
	wmove(win_std,CurY,CurX);
	}	      		
	

}
                                                  