
/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
			EMIL
                 MODULE: FONTE.C                                   
*/

/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur la...
#endif
/*--------------------------------------------------------*/


#include <stdio.h>
#include <memory.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/kd.h>
#ifdef TEST_FONTE
#include <ncurses.h>
#endif

#include "debug.h"


static void saveoldfont(int fd, char *ofil);
static void loadfont(int fd,  char *ifil);
extern char *malloc();

/* 
   fonte minitel     type 8x16
   comprenant le jeu G0 et G1
   et les accentus.	
*/

#include "fonte.minitel"





char oldfonte[8192];		/* pour sauver l'ancienne fonte	*/


#ifdef TEST_FONTE



int main(int argc, char *argv[])
{
	int fd ;
	int i,j,k,l;
	char temp[10];

	if ((fd = open("/dev/console", 0)) < 0)
	  fd = 0;
	
	initscr();
	
	  saveoldfont(fd,oldfonte);
          loadfont(fd,fonte_minitel);
          l=0;
	mvaddstr(l+1,4,"0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F");	
	for(i=0;i < 256 ;  )	{
	    sprintf(temp,"%1X",l);
	    mvaddstr(l+2,0,temp);	
	 	k=4;
		for( j=0; j <16 ; j++)	{
		    mvaddch(l+2,k,i++);
		    k+=4;
		    }
		l++;
		if (l == 8 )
			attron(A_ALTCHARSET);


		refresh();
	}
	attroff(A_ALTCHARSET);	
	getch();
	endwin();
	loadfont(fd,oldfonte);
	return 0;
}

#endif


void ChargeFonte()
{
	int fd ;
	debug("ChargeFonte()");
	if ((fd = open("/dev/console", 0)) < 0)
	  fd = 0;
        saveoldfont(fd,oldfonte);
        loadfont(fd,fonte_minitel);

}

void RestoreFonte()
{
	int fd ;
	debug("RestoreFonte()");
	if ((fd = open("/dev/console", 0)) < 0)
	  fd = 0;
        loadfont(fd,oldfonte);

}


void loadfont(int fd, char *fpi)
{
#ifdef TEST_FONTE

	int i,j;
	int unit=16;
	FILE *fpo, *fpc;
	union binaire {
		unsigned char c;
		struct {
		 unsigned int b0:1;
		 unsigned int b1:1;
		 unsigned int b2:1;
		 unsigned int b3:1;
		 unsigned int b4:1;
		 unsigned int b5:1;
		 unsigned int b6:1;
		 unsigned int b7:1;
		  } bit;
	}bin ;	  
	
        fpo=fopen("fonte.out","w");
        fpc=fopen("fonte.c.out","w");
        fprintf(fpo,"Load Font Unit %d\n",unit);
               
#endif


	if (ioctl(fd,PIO_FONT,fpi)) {
	    perror("Erreur ioctl PIO_FONT");
	    exit(1);
	}

#ifdef TEST_FONTE	
	for (i=0; i < 256 ; i++ )	{
		fprintf(fpo,"\n   %2x   %c\n",i,i);
		fprintf(fpc,"\n");
		for( j=0; j < unit ; j++ ) {
    			bin.c=fpi[(32*i)+j];
    			fprintf(fpo,"%1d %1d %1d %1d %1d %1d %1d %1d   %2x\n",
    			bin.bit.b7,bin.bit.b6,bin.bit.b5,bin.bit.b4,
			bin.bit.b3,bin.bit.b2,bin.bit.b1,bin.bit.b0,bin.c);
    		fprintf(fpc,"0x%x,",bin.c);
    			    			
    			}
    		fprintf(fpc," /* %2x */",i);	
    		}	
	fclose(fpo);
	fclose(fpc);
#endif	
}



static void saveoldfont(int fd, char *ofil)
{
    int i;

    i = ioctl(fd,GIO_FONT,ofil);
    if (i) {
	perror("Erreur ioctl GIO_FONT");
	exit(1);
    }

}

