

/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


/*
			EMIL
                                                                           
                    MODULE: MINITEL.C                                      
                    -----------------                                      
                                                                           
    Simulation d'un petit terminal videotex 40 colonnes, clavier et ecran, 
    en mode texte.                                                         
    Cette emulation est totalement approximative, ne gere pas la couleur,  
    ni certaines sequences.                                                
    Elle est uniquement destinee a realiser une connexion a un serveur     
    via Teletel.                                                           
                                                                           
*/
/*--------------------------------------------------------*/
#ifndef LINUX
#error Mefiance ! je ne connais pas ce compilateur la...
#endif
/*--------------------------------------------------------*/



#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <fcntl.h>
#include <ncurses.h>





#include "emil.h"
#include "touches.h"
#include "couleurs.h"
#include "config.h"
#include "clavecra.h"
#include "minitel.h"
#include "fonction.h"
#include "commpkg.h"

#define OFFSET(a,b) ( a + (b*40)) * 2



byte VtxPos[30];               /* Stockage sequence position      */
byte VtxCount = 0;             /* index pour ci-dessus            */
byte CountVtx;                 /* compteur                        */
byte VtxSaveX, VtxSaveY;       /* sauvegarde curseur pour ligne 0 */
byte OldHauteur, OldLargeur;
byte OldFond, OldForme;
byte OldAttrib, OldInverse;
byte VtxSeq = VTXNULL;         /* Flag si dans une sequence vtx   */
byte Blink = 0;                /* Flag si clignotement.           */
int val1, val2;                /* Valeurs de la seq.position      */
byte oldchar = 0;              /* Le denier caractere affiche     */

byte Double_H = 0;             /* Flag double hauteur             */
byte Double_L = 0;             /* Flag double largeur             */
byte Mosaique = 0;             /* Flag caracteres graphiques G1     */
byte Mosaique1 = 0;             /* Flag caracteres graphiques G2     */
byte ModePage = 1;             /* Scroll ou pas scroll...         */
byte Inversion = 0;            /* Couleurs pas inverses          */
int  LigneZero = 0;            /* Flag si on est en ligne zero    */

byte MaxVtX = 58;              /* definition d'un ecran de 40x25  */
byte MaxVtY = 24;              /* au centre de l'ecran IBM        */
byte MinVtX = 19;
byte MinVtY = 0;

byte VtxForme = 7,		/* couleur du caractere	*/
VtxFond = 0,                   /* Couleurs du fond      */
FondLatent = 255,
FondText = 7,
FondMosaique = 7;


extern char DevPort[];

WINDOW *win1;
WINDOW *win2;
WINDOW *win_vtx;

extern WINDOW *win_std;
extern WINDOW *win_stat;
/*  Table des couleurs des differents attributs videotex*/

/*     Couleurs de forme:    */
   byte VtxTable[] = {
   0x00,     /*  Noir                     */
   0x04,     /*  Rouge                    */
   0x02,     /*  Vert                     */
   0x06,     /*  Jaune                    */
   0x01,     /*  Bleu                     */
   0x05,     /*  Magenta                  */
   0x03,     /*  Cyan                     */
   0x07,     /*  Blanc                    */
   /*     Couleurs de fond      */
   0x00,     /*  Noir          @          */
   0x40,     /*  Rouge         A          */
   0x20,     /*  Vert          B          */
   0x60,     /*  Jaune         C          */
   0x10,     /*  Bleu          D          */
   0x50,     /*  Magenta       E          */
   0x30,     /*  Cyan          F          */
   0x70                              }; /*  Blanc         G          */

   byte TableVtx[] = {   /*  Inverse de la table precedente!  */
   0x00,
   0x04,
   0x02,
   0x06,
   0x01,
   0x05,
   0x03,
   0x07                              };

extern byte CurX, CurY, MaxX, MaxY, MinX, MinY, CurAttr, FlagCouleur;
extern int outchar;
extern byte ch, fd_echo, NumPort, QbbsConnect, logtrace, OnLine;

extern struct ConfigType Config;



  char tgraf[] = "  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * ";
/*                 |               |                   |               |               |               |               |               |             |
                   20              28                  30              38              60              68              70              78            5F 
*/



/*
 reponse du minitel au serveur	
 configuration idem Mnitel 12
*/ 
char Chaine_Ident_Term[]="\001Cz6\004";
char Chaine_Statut_Term[]="\e:qF";
char Chaine_Statut_Teleph[]="\e:[D";
char Chaine_Statut_Fonct[]="\e:s@";
char Chaine_Statut_Vitesse[]="\e:wC";


unsigned char Ecran_Minitel[2000];



/*--------------------------------------------------------------------------*/
/*          en cours de developpement                                       */
/*--------------------------------------------------------------------------*/

void Terminal_VTX (void)
   {
   /* sauve les coordonnes */
   int oldx=CurX;
   int oldy=CurY;
   /* Affichage du petit voyant de porteuse en haut a droite   */
   curseur(0);
   mwrite(win_vtx,MaxVtX -1,MinVtY,OnLine ? "C": "F",Inverse);
   chrono(win1,1,1);
   curseur(1);    
   /* recup des coordonnes	*/
   CurX=oldx;
   CurY=oldy;    
   locate(win_vtx,CurX,CurY);    
   /* regarde le clavier	*/      
   outchar=touche(win_vtx,TRUE);    
   if (outchar!= -1)      {	/* il y a une touche a traiter	*/
      if (VtxFct (win_vtx,outchar))
         return; /* Touche fonction minitel traitee, ok */
      if (outchar ==1)        {
           outchar=touche(win_vtx,FALSE);
           Fonctions (win_vtx,outchar);
           return;
         }
      else if (outchar < 128) {
         Send (DevPort, outchar);
         if (fd_echo && outchar >= 32)
               vtx(win_vtx,outchar); /* half duplex */
         }
      }
   /* on a recu quelque chose ??? */
   if (PortReady (DevPort))     {
      ch = (Receive (DevPort));
      if (logtrace == 1)
         LogPutc (ch); /* Fichier log actif */
      if (ch < 5 )
         return; /* Nulls et autres a eliminer en minitel */
         
         
      if (! VtxSeq)
         vtx (win_vtx,ch);
      else  {         /* on est dans une sequence videotex:*/
         switch (VtxSeq)            {
         case VTXPOSITION:
            VtxLocate (ch);
            break;
         case VTXACCENT:
            VtxAccentue (ch);
            break;
         case VTXATTRIB:
            VtxAttribut (ch);
            break;
         case VTXREPET:
            VtxRepete (ch);
            break;
         case VTXSTATUS:
            VtxStatus (ch);
            break;
         case VTXFILTRE:
            VtxFiltre ();
            break;
         case VTXPRO1:
            VtxPRO1 (ch);
            break;
         case VTXPRO2:
            VtxPRO2 (ch);
            break;
         case VTXPRO3:
            VtxPRO3 (ch);
            break;
            }
            
         }
         
      }
 
   }
/*---------------------------------------------------------------------------*/
 
 
 
/*---------------------------------------------------------------------------*/
/*                    Gestion du clavier minitel                             */
/*---------------------------------------------------------------------------*/
/*
       Sont traitees dans cette fonction les touches speciales du
       minitel, ainsi que certains carateres accentues.
       (pas tous, on va pas s'emmerder a se faire chier...)
*/
 
int VtxFct (WINDOW *w,int valeur)
   {

   debugic(valeur,"VtxFct() valeur");
   switch (valeur)
      {
   case RETOUR:   /* Touche Envoi simulee */
      Send (DevPort, 0x13);
      Send (DevPort, 0x41);
      return (1);
 
   case LF:       /* Touche Enter */
      Send (DevPort, CR);
      return (1);
 
   case HAUT:     /* Touche Retour Simulee */
      Send (DevPort, 0x13);
      Send (DevPort, 0x42);
      return (1);
 
   case BAS:     /* Touche Suite           */
      Send (DevPort, 0x13);
      Send (DevPort, 0x48);
      return (1);
 
   case HOME:    /* Touche Sommaire        */
      Send (DevPort, 0x13);
      Send (DevPort, 0x46);
      return (1);
 
   case GAUCHE:
   case BACK_SPACE:    /* Touche Correction      */
      Send (DevPort, 0x13);
      Send (DevPort, 0x47);
      return (1);
 
   case DELETE:  /* Touche Annulation      */
      Send (DevPort, 0x13);
      Send (DevPort, 0x45);
      return (1);
 
 
   case F1:      /* Touche Guide           */
      Send (DevPort, 0x13);
      Send (DevPort, 0x44);
      return (1);
 
   case F2:      /* Touche Repetition       */
      Send (DevPort, 0x13);
      Send (DevPort, 0x43);
      return (1);
 
   case F3:      /* Bascule mode page/rouleau*/
      if (ModePage)
         ModePage = 0;
      else
         ModePage = 1;
      ligne_statut ();
      return (1);
 
   case F10:     /* Touche Connexion/FIN   */
      Send (DevPort, 0x13);
      Send (DevPort, 0x49);
      return (1);
 
   case 133:     /* A accent grave   */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x41);
      Send (DevPort, 97);
      return (1);
 
   case 131:     /* A accent circonflexe   */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x43);
      Send (DevPort, 97);
      return (1);
 
   case 132:     /* A Trema    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x48);
      Send (DevPort, 97);
      return (1);
 
   case 130:     /* E accent aigu    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x42);
      Send (DevPort, 101);
      return (1);
 
   case 138:     /* E accent grave    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x41);
      Send (DevPort, 101);
      return (1);
 
   case 136:     /* E accent circonflexe    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x43);
      Send (DevPort, 101);
      return (1);
 
   case 137:     /* E trema    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x48);
      Send (DevPort, 101);
      return (1);
 
   case 140:     /* I accent circonflexe    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x43);
      Send (DevPort, 105);
      return (1);
 
   case 139:     /* I trema    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x48);
      Send (DevPort, 105);
      return (1);
 
   case 147:     /* O accent circonflexe    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x43);
      Send (DevPort, 111);
      return (1);
 
   case 148:     /* O trema    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x48);
      Send (DevPort, 111);
      return (1);
 
   case 150:     /* U Accent circonflexe    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x43);
      Send (DevPort, 117);
      return (1);
 
   case 151:     /* U Accent grave    */
      if (fd_echo)
         mvputc(w,valeur); /* half duplex */
      Send (DevPort, 0x19);
      Send (DevPort, 0x41);
      Send (DevPort, 117);
      return (1);
 
      }
 
   return (0); /* C'est pas une touche de fonction minitel, ca. Et non. */
   }
/*---------------------------------------------------------------------------*/
 
/*--------------------------------------------------------------------------*/
/*            Simulation d'un ecran de terminal Videotex simple...          */
/*--------------------------------------------------------------------------*/
 
 
void vtx (WINDOW *w,byte ch)
   {
   register int i;
   
   switch (ch)      {
 
	   case 0x07:	/* le bip 	*/
	      debug("vtx() beep");
	      beep() ;
	      break;
 
	   case 0x08:      /* curseur gauche */
	        debug("vtx() gauche");
		        
	        if (CurX > MinVtX)  {	/* si pas au bord gauche	*/
	            CurX--;
	            locate(win_vtx,CurX, CurY);
        	    }
	       else  {
        	    if (CurY > MinVtY + 1) /* si pas en ligne 1 ou 0 */ 
		               CurY--;
	            else if (!LigneZero) {
                    if (!ModePage) {
                          Scroll_down (win_vtx,1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
  			  CurY = MinVtY + 1; 
	                  }
                    else
                          CurY = MaxVtY;
                    }
                    CurX = MaxVtX;
                    locate (win_vtx,CurX, CurY);
             }
             break;
 
	   case 0x09: /* curseur droit*/
		debug("vtx() droit");
	        CurX++;
	       if (LigneZero && (CurX > MaxVtX))
	           CurX = MaxVtX;
	       else if (CurX > MaxVtX)    {
	         CurX = MinVtX;
	         CurY++;
	         if (CurY > MaxVtY)
	            if (!ModePage)  {
	               Scroll_up (win_vtx,1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
	               CurY = MaxVtY;
	               }
	            else   {
	               CurX = MinVtX;
	               CurY = MinVtY;
	               }
	         }
	     locate (win_vtx,CurX, CurY);
             break;  
      case 0x0A: /* Line-feed curseur bas*/
          debug("vtx() bas");
          if (LigneZero) {   /* cas particulier la...*/
            Double_H = OldHauteur;
            Double_L = OldLargeur;
            VtxFond = OldFond;
            VtxForme = OldForme;
            Inversion = OldInverse;
            CurAttr = OldAttrib;
            locate (win_vtx,VtxSaveX, VtxSaveY);
            LigneZero = 0;
            return;
            }              /* sinon cas normal     */
         CurY++;
         if (CurY > MaxVtY) {
            if (!ModePage)  {
               Scroll_up (win_vtx,1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
               CurY = MaxVtY;
               }
            else   {
               CurX = MinVtX;
               CurY = MinVtY+1; /* ligne 1! */
               }
            }
         locate (win_vtx,CurX, CurY);
      break;
 
 
   case 0x0B: /* Vtab vers le haut curseur Haut*/
       debug("vtx() haut");
      if (!LigneZero)
         {
         if (CurY > MinVtY + 1)
            CurY--;
         else
            {
            if (!ModePage)
               {
               Scroll_down (win_vtx,1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
               CurY = MinVtY + 1;
               }
            else
               CurY = MaxVtY; /* ligne 24! */
            }
         locate(win_vtx,CurX, CurY);
         }
      break;
 
	case 0x0C: /* effacement ecran */
	      debug("vtx() cls");
	      cls_vtx();
	      LigneZero = 0;
	      break;
 
	case 0x0D: /* Retour CHariot */
	      debug("vtx() rc");
              CurX = MinVtX;
              locate (win_vtx,CurX, CurY);
	      break;
 
 
   case 0x0E:    /* passage alphamosaique on  Jeu G1*/
      debug("vtx() Jeu G1");
      Mosaique = 1;
      Mosaique1 =0;
      Double_H = 0;
      Double_L = 0;
      Inversion = 0;
      SetVtxColor (VtxForme, VtxFond);		
      break;
 
   case 0x0F:    /* passage alphamosaique off  Retour Jeu G0*/
      debug("vtx() Jeu G0");
      Mosaique = 0;
      Mosaique1=0;
      Double_H = 0;
      Double_L = 0;
      Inversion = 0;
      SetVtxColor (VtxForme, VtxFond);
      break;
 
   case 0x11: /* Demasquage curseur */
      debug("vtx() Curseur on");
      curseur (1);
      return;
 
   case 0x12:	/* repetition de caracteres	*/
      debug("vtx() repet");
      VtxSeq = VTXREPET;
      VtxCount = 0;
      return;
 
   case 0x13:	/* commande et fonctions	*/
       debug("vtx() sep");
       return;
 
   case 0x14: /* Masquage curseur */
       debug("vtx() curseur off");
       curseur (0);
       return;
 
   case 0x16:    /* idem dessous, pareil            */
   case 0x19:    /* Sequence d'accentuation minitel Jeu G2*/
      debug("vtx() jeu G2");
      VtxSeq = VTXACCENT;
      VtxCount = 0;
      return;
 
   case 0x18:    /* Remplit de spaces jusqu'a EoL   */
       debug("vtx() Eol");
       for (i = CurX; i < MaxVtX + 1; i++){	
           locate(win_vtx,i,CurY);
           mvputc(win_vtx,' ');
           }
       if (Double_H && (CurY > MinVtY + 1))
           for (i = CurX; i < MaxVtX + 1; i++)	{
              locate(win_vtx,i,CurY-1);
              mvputc(win_vtx,' ');
              }
        return;
 
   case 0x1B:    /* Sequence Escape d'attributs minitel */
        debug("vtx() Esc");
        VtxSeq = VTXATTRIB;
        VtxCount = 0;
        return;
 
   case 0x1E: /* retour ligne 1 colonne 0 */
        debug("vtx() Home");
        locate (win_vtx,MinVtX, MinVtY+1);
        CurAttr = Normal;
        VtxForme = 7;
        Inversion = 0;
        Double_H = 0;
        Double_L = 0;
        Mosaique = 0;
        Mosaique1 = 0;
        LigneZero = 0;
        VtxFond = 0;
        SetVtxColor (VtxForme, VtxFond);
        return;
 
   case 0x1F:    /* Positionnement curseur videotex */
        debug("vtx() Position");
        Mosaique = 0;
        CurAttr = Normal;
        VtxForme = 7;
        Inversion = 0;
        VtxFond = 0;
        VtxSeq = VTXPOSITION;
        VtxCount = 0;
        return;
 
   case 0x10:
   case 0x15:
   case 0x17:
   case 0x1A:
   case 0x1C:
   case 0x1D:
        debug("vtx() non traite");
        return;

   default:
      if (Mosaique) 
          ch=VtxMosaique(ch);
         
      debugxc(ch,"vtx() ch");
      mvputc (win_vtx,ch);
      }
 
   }
/*---------------------------------------------------------------------------*/
 
/*---------------------------------------------------------------------------*/
/*         effacement ecran videotex                                         */
/*---------------------------------------------------------------------------*/
void cls_vtx (void)
   {
   debug("cls_vtx()");
   wmove(win_vtx,1,0);	
   wclrtobot(win_vtx);
   wmove(win_vtx,1,0);
   wrefresh(win_vtx);
   memset(Ecran_Minitel,0,sizeof(Ecran_Minitel));
   CurAttr = CurAttr;
   VtxForme = 7;
   VtxFond = 0;
   FondLatent = 0;
   FondText = 0;
   FondMosaique = 0;
   Double_H = 0;
   Double_L = 0;
   Mosaique = 0;
   Inversion = 0;
   CurX=0;
   CurY=1;
   }
/*---------------------------------------------------------------------------*/
 
 
/*--------------------------------------------------------------------------*/
/*     Positionne un chr en memoire video sur l'ecran minitel ( != mputc)   */
/*--------------------------------------------------------------------------*/
/*
     Ecrit un caractere en memoire video a la position courante et 
     avec l'attribut courant.
     
     Les attributs de taille sont traites comme suit:
       Double largeur: le caratere est re ecrit a droite
       Double Hauteur: le caratere est re ecrit audessus

     Incremente la position courante d'une unit, scrolle l'ecran en
     haut a partir de la derniere ligne si ModePage = 0, sinon retour en
     0, 0.
 
     Remise des attributs caractere par defaut  chaque changement de
     ligne.
*/
void mvputc (WINDOW *w,int ch)
   {
    int Attr=CurAttr;   

   debug3ic(CurY,CurX,CurAttr,"mvputc() en y,x CurAttr");   
 
   /* defini l'attribut par defaut	*/
   if (FlagCouleur)	{
	if (Attr < 100 ) {	
	        if ( ch > 0x7f )	
		   	wattrset(w,COLOR_PAIR(Attr) | A_ALTCHARSET);
		else
			wattrset(w,COLOR_PAIR(Attr));
		}		
	else	{
		Attr -=100;
	        if ( ch > 0x7f )	
		   	wattrset(w,COLOR_PAIR(Attr) | A_BOLD | A_ALTCHARSET);
		else
			wattrset(w,COLOR_PAIR(Attr) | A_BOLD);
		}							
                wrefresh(w);
                touchwin(w);
	}			

   /* sauve le caractere	*/
   oldchar = ch; 
   
   /* cas particuliers	*/   
   switch(ch)	{   
      case 0x60:
      case 0x7e:
         mvwaddch(w,CurY,CurX,ACS_HLINE);
          break;
      case 0x7f :
         mvwaddch(w,CurY,CurX,ACS_BLOCK);
          break;
      case 0x5e :
         mvwaddch(w,CurY,CurX,ACS_UARROW);
          break;
      case 0x7b:
      case 0x7c:
      case 0x7d:    
         mvwaddch(w,CurY,CurX,ACS_VLINE);
          break;
     default :
        mvwaddch(w,CurY,CurX,ch);
        break;
   }
   Ecran_Minitel[(CurX+CurY*40)*2]=ch;
   debug2ic((CurX+CurY*40)*2,ch,"OFFSET");
   Ecran_Minitel[(CurX+CurY*40)*2 + 1]=CurAttr;
   
   wrefresh(w);
   touchwin(w);

   /* si double Hauteur et Ligne > 1	*/
   if ((Double_H) && (CurY > MinVtY + 1))	{
      debug2ic(CurY-1,CurX,"mvputc() Dble Hauteur y,x");   
      /* on reaffiche le caractere	une ligne au dessus */
#ifdef DOUBLE_HAUTEUR
      mvwaddch(w,CurY-1,CurX, ch);
      Ecran_Minitel[(CurX+(CurY-1)*40)*2]=ch;
      debug2ic((CurX+(CurY-1)*40)*2,ch,"OFFSET DH");
      Ecran_Minitel[(CurX+(CurY-1)*40)*2 +1]=CurAttr;
#else      
      mvwaddch(w,CurY-1,CurX, ' ');
      Ecran_Minitel[(CurX+(CurY-1)*40)*2]=' ';
      debug2ic((CurX+(CurY-1)*40)*2,ch,"OFFSET DH");
      Ecran_Minitel[(CurX+(CurY-1)*40)*2 +1]=CurAttr;
#endif      
      wrefresh(w);
      touchwin(w);
      }
 
   /* Gestion de Double Larguer si place au dessus  */
   /* si double largeur et colonne < Max	*/
   if ((Double_L) && (CurX < MaxVtX))      {
      /* gestion double largeur si on n'est pas en fin de ligne */
      debug2ic(CurY,CurX+1,"mvputc() Dble Largeur x,y");   
      /* on reaffiche le caractere a droite   */
#ifdef DOUBLE_LARGEUR
      mvwaddch(w,CurY,CurX+1,ch);  
      Ecran_Minitel[((CurX+1)+CurY*40)*2]=ch;
      debug2ic(((CurX+1)+CurY*40)*2,ch,"OFFSET DL");
      Ecran_Minitel[((CurX+1)+CurY*40)*2+1]=CurAttr;
#else      
      mvwaddch(w,CurY,CurX+1,' ');  
      Ecran_Minitel[((CurX+1)+CurY*40)*2]=' ';
      debug2ic(((CurX+1)+CurY*40)*2,ch,"OFFSET DL");
      Ecran_Minitel[((CurX+1)+CurY*40)*2+1]=CurAttr;
#endif      
      wrefresh(w);
      touchwin(w);
      /* cas de la double hauteur et largueur	*/      
      if ((Double_H) && (CurY > MinVtY + 1))	{
         debug2ic(CurY-1,CurX+1,"mvputc() Dbl Haut Dbl Larg x,y");   
         /* on reaffiche le caractere decaler de une ligne, un caractere vers 
            le haut
         */    
#ifdef DOUBLE_HAUTEUR
         mvwaddch(w,CurY-1,CurX+1,ch);
         Ecran_Minitel[((CurX+1)+(CurY-1)*40)*2]=ch;
         debug2ic(((CurX+1)+(CurY-1)*40)*2,ch,"OFFSET DH DL");
         Ecran_Minitel[((CurX+1)+(CurY-1)*40)*2+1]=CurAttr;
#else         
         mvwaddch(w,CurY-1,CurX+1,' ');
         Ecran_Minitel[((CurX+1)+(CurY-1)*40)*2]=' ';
         debug2ic(((CurX+1)+(CurY-1)*40)*2,ch,"OFFSET DH DL");
         Ecran_Minitel[((CurX+1)+(CurY-1)*40)*2+1]=CurAttr;
#endif         
         wrefresh(w);
         touchwin(w);
         }
      CurX++;    /* gestion double taille si place dessus*/
      }
   CurX++;
   
   if (LigneZero && (CurX > MaxVtX))	{
      debug("mvputc() fin Ligne Zero");
      CurX = MaxVtX;
      }
   else if (CurX > ( MaxVtX +1) )      {
      CurX = MinVtX;
      CurY++;
      debug2ic(CurY,CurX,"mvputc() Changement de Ligne y,x");
      if (Double_H)	{
         CurY++; /* encore un coup */
         debug2ic(CurY,CurX,"mvputc() Changement de Ligne DBL h y,x");
         }
      if (CurY >= MaxVtY)
         {
         if (!ModePage)          {
            Scroll_up (win_vtx,CurY - MaxVtY, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
            CurY = MaxVtY;
            debug2ic(CurY,CurX,"mvputc() Changement de Ligne Scroll y,x");

            }
         else           {
            CurX = MinVtX;
            CurY = MinVtY + (CurY - MaxVtY);
	    debug2ic(CurY,CurX,"mvputc() Changement de Ligne No Scroll y,x");
            }
         }
      }
      
   /*  supprime l'attribut	*/
   Attr=CurAttr;   
   if (FlagCouleur)	{
	if (Attr < 100 )	{
	        if ( ch > 0x7f )	
		   	wattroff(w,COLOR_PAIR(Attr) | A_ALTCHARSET);
		else
			wattroff(w,COLOR_PAIR(Attr));
		}			
	else	{
		Attr -=100;
	        if ( ch > 0x7f )	
		   	wattroff(w,COLOR_PAIR(Attr) | A_BOLD | A_ALTCHARSET);
		else
			wattroff(w,COLOR_PAIR(Attr) | A_BOLD);
		}							
                wrefresh(w);
                touchwin(w);
	}
      
   touchwin(w);       
   locate(w,CurX, CurY);
   }
/*--------------------------------------------------------------------------*/
 
 
/*--------------------------------------------------------------------------*/
/*      gestion de la sequence de position curseur videotex                 */
/*--------------------------------------------------------------------------*/
 
void VtxLocate (byte ch)
   {
   
   debugxc(ch,"VtxLocate()");
   if (!VtxCount)   {
      val1 = ch;
      VtxCount++;
      return;
      }
 
   val2 = ch;
   VtxCount = 0;
   VtxSeq = 0;
   if (! LigneZero)      {
      VtxSaveX = CurX;    /* au cas ou ligne zero appelee...*/
      VtxSaveY = CurY;    /* on sauve le contexte           */
      OldHauteur = Double_H;
      OldLargeur = Double_L;
      OldAttrib = CurAttr;
      OldFond = VtxFond;
      OldForme = VtxForme;
      OldInverse = Inversion;
      }
 
   switch (val1)      {
   case 48:
   case 49:
   case 50: /* Debut de colonne des  lignes 0-24 dans ce cas */
      debug2ic( MinVtY + ((val2 - 48) + ((val1 - 48) * 10)),MinVtX,"VtxLocate() 1");
      locate (win_vtx,MinVtX, MinVtY + ((val2 - 48) + ((val1 - 48) * 10)));
      break;
   default:      /* Cas general sinon */
      debug2ic( MinVtY +val1-0x40,MinVtX+val2-0x40,"VtxLocate() 2");
      locate (win_vtx,MinVtX+val2-0x40, MinVtY+val1-0x40);
      }
   if (CurY == MinVtY)
      LigneZero = 1;
   else
       LigneZero = 0;
   /* perte de tous les attributs sauf le fond, excepte en colonne 0!!!  */
   VtxForme = 7;
   if (CurX == MinVtX)      {
      CurAttr = VtxForme;
      VtxFond = 0;
      }
   else
          {
      /* On reprend l'attribut de fond de la colonne PRECEDENTE */
/*      VtxFond = *(Ecran + (((CurY * 2 * (MaxX + 1)) + (CurX * 2)) - 1));*/
      CurAttr = Normal; /*(VtxFond & 0x70) | VtxForme;	*/
      VtxFond = 0;
      }
   Mosaique = 0;
   Inversion = 0;
   Double_H = 0;
   Double_L = 0;
   }
/*--------------------------------------------------------------------------*/
 
 
/*--------------------------------------------------------------------------*/
/* Affichage des caracteres speciaux du minitel (19 Code dans G2         )  */
/*--------------------------------------------------------------------------*/
void VtxSpecial (byte ch)
   {
      debugxc(ch,"VtxSpecial()");	
      switch (ch)
         {
      case 0x23:
         mvputc (win_vtx,0x9c);
         return; /* livre */
      case 0x24:
         mvputc (win_vtx,0x24);
         return; /* dollars */
      case 0x26:
         mvputc (win_vtx,'#');
         return; /* diese */
      case 0x27:
         mvputc (win_vtx,167); /* ???	*/
         return; /* crochet  */
      case 0x2c:
         mvputc (win_vtx,(int) ACS_LARROW);
         return; /* fleche gauche */
      case 0x2d:
         mvputc (win_vtx,(int) ACS_UARROW);
         return; /* fleche haute */
      case 0x2e:
         mvputc (win_vtx,(int) ACS_RARROW);
         return; /* fleche droite */
      case 0x2f:
         mvputc (win_vtx,(int) ACS_DARROW);
         return; /* fleche basse */
      case 0x30:
         mvputc (win_vtx,(int) ACS_DEGREE);
         return; /* degre */
      case 0x31:
         mvputc (win_vtx,(int) ACS_PLMINUS);
         return; /* plus moins */
      case 0x38:
         mvputc (win_vtx,0xf6);
         return; /* divisions */
      case 0x3c:
         mvputc (win_vtx,0xac);
         return; /* un quart */
      case 0x3d:
         mvputc (win_vtx,0xab);
         return; /* un demi */
      case 0x3e:
         mvputc (win_vtx,186);		/* a faire ! 	*/
         return; /* trois quart */
      case 0x4b:
         mvputc (win_vtx,0x87);
         return; /* c cedille */
      case 0x6a:
         mvputc (win_vtx,0xec);
         return; /* o et e minuscule */
      case 0x7a:
         mvputc (win_vtx,230);		/*  a faire	*/
         return; /* o et e majuscule */
      case 0x7b:
         mvputc (win_vtx,0xe1);
         return; /* beta */
        default :
         mvputc (win_vtx,'?');
         return; /* inconnu */
        } 

   }
/*--------------------------------------------------------------------------*/
 
 
 
/*--------------------------------------------------------------------------*/
/* Affichage des caracteres accentues videotex. (19 Code_accent Caractere)  */
/*--------------------------------------------------------------------------*/
/*
     Si le caractere n'existe pas dans le jeu IBM ou si il n'est pas
     traite par paresse, il est affiche non-accentue.
*/
 
void VtxAccentue (byte ch)
   {
   if (!VtxCount)
      {
      val1 = ch;
      if ((val1 < 0x41)|| (val1 > 0x48)) /* Pas un accentue mais un special */
         {
         VtxSeq = 0;
         VtxSpecial (val1);
         return;
         }
      VtxCount++;  /* Code accent, on attend encore le caractere */
      return;
      }
   val2 = ch;  /* Et voila le caractere, on se lance...      */
   VtxCount = 0;
   VtxSeq = 0;
   debug2ic(val1,val2,"VtxAccentue()"); 
   if (val1 == 0x41) /* Accent aigu */
      {
      switch (val2)
         {
      case 97:
         mvputc (win_vtx,0x85);
         return; /*  */
      case 101:
         mvputc (win_vtx,0x8a);
         return; /*  */
      case 105:
         mvputc (win_vtx,'i');	/* a voir	*/
         return; /* i */
      case 111:
         mvputc (win_vtx,'o');  /* a voir	*/
         return; /* o */
      case 117:
         mvputc (win_vtx,'u');  /* avoir	*/
         return; /* u */
      default:
         UnReceive (DevPort, val2);
         return;
         }
      }


   if (val1 == 0x42) /* Accent grave */
      {
      switch (val2)
         {
      case 97:
         mvputc (win_vtx,'a');	/* a voir	*/
         return; /* a */
      case 101:
         mvputc (win_vtx,0x82);
         return; /*  */
      case 105:
         mvputc (win_vtx,'i');  /* a voir       */
         return; /* i */
      case 111:
         mvputc (win_vtx,'o');  /* a voir       */
         return; /* o */
      case 117:
         mvputc (win_vtx,'u');  /* a voir       */
         return; /* u */
      default:
         UnReceive (DevPort, val2);
         return;
         }
      }
 
   if (val1 == 0x43) /* Accent circonflexe */
      {
      switch (val2)
         {
      case 97:
         mvputc (win_vtx,0x83);
         return; /*  */
      case 101:
         mvputc (win_vtx,0x88);
         return; /*  */
      case 105:
         mvputc (win_vtx,0x8c);
         return; /*  */
      case 111:
         mvputc (win_vtx,0x93);
         return; /*  */
      case 117:
         mvputc (win_vtx,0x96);
         return; /*  */
      default:
         UnReceive (DevPort, val2);
         return;
         }
      }
 
   if (val1 == 0x48) /* Trema */
      {
      switch (val2)
         {
      case 97:
         mvputc (win_vtx,'a');	/* a voir	*/
         return; /* a */
      case 101:
         mvputc (win_vtx,'e'); /* a voir */
         return; /* e */
      case 105:
         mvputc (win_vtx,0x8b);
         return; /*  */
      case 111:
         mvputc (win_vtx,'o');  /* a voir       */
         return; /* o */
      case 117:
         mvputc (win_vtx,'u');  /* a voir       */
         return; /* u */
      default:
         UnReceive (DevPort, val2);
         return;
         }
      }
   }
/*--------------------------------------------------------------------------*/
 
 
 
/*--------------------------------------------------------------------------*/
/* Gestion des sequences ESCAPE (attribut caractere)                        */
/*--------------------------------------------------------------------------*/
void VtxAttribut (byte ch)
   {
   val1 = ch;
   VtxCount = 0;

   debugxc(ch,"VtxAttribut() ch");
   switch (val1)
      {
   case 0x20:
      CountVtx = 2;
      VtxSeq = VTXFILTRE;
      return;
 
   case 0x22:
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;
 
   case 0x23:	
      CountVtx = 2;
      VtxSeq = VTXFILTRE;
      return;

   case 0x25:	/* Mode transparent ecran	*/
   	VtxSeq=VTXFILTRE;
   	return;

   case 0x2f:
      Fonctions (win_vtx,ALT_V);
      ModePage = 1;
      ligne_statut ();
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;

 /*Commande d'un peripherique	*/
   case 0x35:	/* Mise en route	*/
   case 0x36:	/* Arret 	*/
   case 0x37:	/* Attente	*/
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;

   case 0x39:	/* PRO1	*/
      CountVtx=1;
      VtxSeq = VTXPRO1;
      return;

   case 0x3A:	/* PRO2	*/
      CountVtx=2;
      VtxSeq = VTXPRO2;
      return;

   case 0x3B: 	/* PRO3	*/
      CountVtx = 3;
      VtxSeq = VTXPRO3;
      return;

   case 0x5B:
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;
      
   case  0x61:	/*Demande position du curseur	*/
   	VtxSeq=VTXFILTRE;
   	return;
      }



   VtxSeq = VTXNULL;

   if ((val1 > 0x4F) && (val1 < 0x58))     /* c'est une couleur de fonds  */
      {
      VtxFond = val1 - 0x50;
      SetVtxColor (VtxForme, VtxFond);
      return;
      }
   if ((val1 > 0x3F) && (val1 < 0x48 ))       /* c'est une couleur caractere  */
      {
      VtxForme = val1-0x40;
      SetVtxColor (VtxForme, VtxFond);
      return;
      }

   switch (val1)
      {

   case 0x48:  /* Clignotement        */
      debug("VtxAttribut() Clignotement on");
      if (Blink)
         return;
      OldAttrib=CurAttr;   
      CurAttr = CurAttr | A_BLINK;
      Blink = 1;
      return;

   case 0x49:  /* Fin Clignotement      */
      debug("VtxAttribut() Clignotement off");
      if (!Blink)
         return;
      CurAttr = OldAttrib;
      Blink = 0;
      return;
   case 0x4a:	/* fin incrustation	*/
      debug("VtxAttribut() fin incrustation");
       return;	

   case 0x4b:	/* debut incrustation	*/
      debug("VtxAttribut() debut incrustation");
       return;	


   case 0x4c:    /* esc L; texte normal */
      debug("VtxAttribut() taille normal");
      Double_H = 0;
      Double_L = 0;
      return;

   case 0x4d:    /* esc M;Double hauteur */
      debug("VtxAttribut() taille double");
      if (!LigneZero)
         Double_H = 1;
      return;

   case 0x4e:    /* esc N;Double largeur */
      debug("VtxAttribut() double largeur");
      Double_L = 1;
      return;

   case 0x4f:    /* esc O;Double taille */
      debug("VtxAttribut() double taille");
      Double_L = 1;
      if (!LigneZero)
         Double_H = 1;
      return;
      
   case 0x58:	/* debut masque ligne	*/
      debug("VtxAttribut() debut masque ligne");
       return;	


   case 0x59:	/* fin soulignement			*/
      debug("VtxAttribut() Soulignement off");
	CurAttr=OldAttrib;
        return;	 

   case 0x5a:	/* debut soulignement			*/
      debug("VtxAttribut() Soulignement on");
      OldAttrib=CurAttr;
      CurAttr = CurAttr | A_UNDERLINE;
        return;	

   case 0x5c:    /* Inverse off         */
      debug("VtxAttribut() Inverse off");
      Inversion = 0;
      SetVtxColor (VtxForme, VtxFond);
      return;

   case 0x5d:    /* Inverse on          */
      debug("VtxAttribut() Inverse on");
      Inversion = 1;
      SetVtxColor (VtxForme, VtxFond);
      return;
      
                  
      
   case 0x5e:	/* transparence	*/
      debug("VtxAttribut() transparence on");
       return;	

   case 0x5f :
      debug("VtxAttribut() Fin Masquage");
      mvputc(win_vtx,oldchar);
      return;


      
      }


   }
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*        Gestion de la sequence REPetition caractere (0x12)                */
/*--------------------------------------------------------------------------*/
void VtxRepete (byte ch)
   {
   int i;
   
   val1 = ch - 0x40 ;
   debugicc(val1 ,oldchar,"VtxRepete() fois  ");
   VtxCount = 0;
   VtxSeq = VTXNULL;
   for (i = 0; i < val1; i++)
        mvputc (win_vtx,oldchar);
   }
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*        Gestion de la sequence Statut terminal (ESC 3A 6A/69 X             */
/*--------------------------------------------------------------------------*/
void VtxStatus (byte ch)
   {
   byte Switch;
   
   
   if (!VtxCount)
      {
      VtxCount++;
      val1 = ch;
      return;
      }
 
   val2 = ch;
   VtxSeq = VTXNULL;
   VtxCount = 0;
   debug2ic(val1,val2,"VtxStatus()");

   if (val1 == 0x6A)
      Switch = 1;                    /* Switch "OFF" des machins */
   else
      if (val1 == 0x69)
         Switch = 0;                    /* Switch "ON"  des machins */
      else
         if ((val1 == 0x32)|| (val1 == 0x31) )       /* passage mode 80 col, ici */
            {                                        /* mal traite car provisoire*/
              debug("passage videotext en 80 colonnes");
/*            Fonctions (win_vtx,ALT_A);    */           /* donc je mets juste ANSI..*/
            return;
            }

   else return;                    /* probablement une erreur de codage...*/

   if (val2 == 0x43)
      ModePage = Switch;
   ligne_statut ();                 /* Et on previent les gens...          */
   /* Le reste c'est pas pour nous:45h minuscules, 46h et 47h la loupe...*/
   /* On devrait renvoyer une sequence au serveur mais j'ai pas la doc, */
   /* alors... On fera sans.*/
   }
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*        Sequence videotex vide pour filter ce que je ne comprends pas!    */
/*--------------------------------------------------------------------------*/
void VtxFiltre (void)    /* C'est du delire ca... Enfin ca filtre ce qu'il  */
   {                     /* faut en fonction de la valeur de CountVtx...    */
   debugxc(ch,"VtxFiltre() ch");

   VtxCount++;
   if (VtxCount >= CountVtx)
      {
        VtxCount = 0;
        VtxSeq = VTXNULL;
      }
   }
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*        Sequence de protocole Videotex                                    */
/*--------------------------------------------------------------------------*/
void VtxPRO1 (char ch)
{

debugxc(ch,"VtxPRO1() ch");


   VtxSeq = VTXNULL;
   switch(ch)
   	{
	case 0x50 :	/* bis	*/
		break;
	case 0x53 :	/* decrochage	*/
		break;
	case 0x54 :	/* Commutation donnees phonie	*/
		break;
	case 0x57 :	/* raccrochage	*/
		break;
	case 0x58 :	/* Coupure calibre	*/
		break;
	case 0x59 :	/* remise zero	*/
		break;
	case 0x5a :	/* demande status telephonique	*/
		SendCommand(Chaine_Statut_Teleph);
		break;
	case 0x67 :	/* deconnexion	*/
		break;
	case 0x68 :	/* connexion	*/
		break;
	case 0x6c :	/* retournement modem	*/
		break;
	case 0x6d :	/* retournement inverse	*/
		break;
	case 0x6e :	/* acquitement retournement */
		break;
	case 0x6f :	/* mode maitre retournement */
		break;
	case 0x70 :	/* demande status terminal reponse idem minitel 12 */
		SendCommand(Chaine_Statut_Term);
		break;
	case 0x72 :	/* demande status fonctionnement */
		SendCommand(Chaine_Statut_Fonct);
		break;
	case 0x74 :	/* demande status vitesse */
		SendCommand(Chaine_Statut_Vitesse);
		break;
	case 0x76 :	/* demande status protocol */
		break;
	case 0x78 :	/* telechargement RAM1 */
		break;
	case 0x79 :	/* telechargement RAM2 */
		break;
	case 0x7A :	/* Identification RAM1 */
		break;
	case 0x7B :	/* Identification Terminal reponse idem Minitel 12 */
	        SendCommand(Chaine_Ident_Term);
		break;
	case 0x7f :	/* reset videotexte */
		break;
			      	
   	
   	}




   }
/*--------------------------------------------------------------------------*/
/*        Sequence de protocole Videotex                                    */
/*--------------------------------------------------------------------------*/
void VtxPRO2 (char ch)
{

debugxc(ch,"VtxPRO2() ch");


  switch (ch)
  	{
  	case 0x31:
  	case 0x32:
	case 0x55:
	     val1=ch;
	     return;
	     break;  		
  	}

  switch (val1)
  	{
  	case 0x31 :
  		if ( ch == 0x7d ) {/* Passage mode teleinformatique */
  			sleep(1);
  			VtxSeq=VTXNULL;
  			}
		break;  			
	case 0x32:  		
	   switch(ch)
		{
		case 0x7d:	/* Passage vidotexte  mixte 	*/
		case 0x7e:	/* Passage mixte  vidotexte	*/
		 sleep(1);
		 VtxSeq=VTXNULL;
		   break;
	   	}
	   break;
	case 0x55:
		if ( ch == 0x4e )	/* Commutation donnes phonie	*/
	 		VtxSeq=VTXNULL;
		break;	 		    
   }
   
}
 
/*--------------------------------------------------------------------------*/
/*        Sequence de protocole Videotex                                    */
/*--------------------------------------------------------------------------*/
void VtxPRO3 (char ch)
{

debugxc(ch,"VtxPRO3() ch");


   VtxSeq = VTXNULL;
   
   switch(ch)
   	{
   	
   	
   	}
   
   
   }
 
 
 
/*--------------------------------------------------------------------------*/
/*        Affichage de l'ecran terminal videotex                            */
/*--------------------------------------------------------------------------*/
 
void masque_vtx (void)
   {
    int attrib1=FlagCouleur ? Blanc_bleu : Normal ;
    int attrib2=FlagCouleur ? Jaune_bleu : Normal ;
    int attrib3=FlagCouleur ? Cyan_bleu : Normal ;

    debug("masque_vtx()");



/*   cls(win_std,Normal);
   cls(win_stat,Normal);	*/
   cls(win1, Normal);
   cls(win2,Normal);
   cls(win_vtx,FlagCouleur ? noir : Normal);
   box(win1,0,0);
   box(win2,0,0);
   
   MaxVtX=39;    
   MaxVtY = 25;            
   MinVtY=MinVtX=0;
	
   memset(Ecran_Minitel,0,sizeof(Ecran_Minitel));
   
   mwrite (win1,1,2, "ENVOI     :Enter",attrib1);
   mwrite (win1,1,3, "GUIDE     :F1" ,attrib1 );
   mwrite (win1,1,4, "CONNEXION :F10",attrib1 );
   mwrite (win1,1,5, "SOMMAIRE  :Home",attrib1);
   mwrite (win1,1,6, "CORRECTION:",attrib1);
   mwrite (win1,13,6,"<-",attrib1);/* fleche */
   mwrite (win1,1,7, "ANNULATION:Del",attrib1 );
   mwrite (win1,1,8, "REPETITION:F2" ,attrib1 );
   mwrite (win1,1,9, "RETOUR    :",attrib1);
   mwrite (win1,13,9, "",attrib1);/* fleche */
   waddch(win1,ACS_UARROW);
   mwrite (win1,1,10, "SUITE     :" ,attrib1 );
   mwrite (win1,13,10, "",attrib1);/*fleche */
   waddch(win1,ACS_DARROW);
   mwrite (win1,1,15, "Mode Page/Scroll",attrib2);
   mwrite (win1,1,16, "Bascule:      F3",attrib2);
   mwrite (win1,1,20, "Aide....CTRL-A Z",attrib2);
   mwrite (win2, 2,2, "Terminal MINITEL",attrib2);
   mwrite (win2, 2,3, "en   mode  texte",attrib2);

   mwrite (win2, 2,5, "   -----------" ,Normal);
   mwrite (win2, 2,7,  "Ce mode  terminal",attrib3);
   mwrite (win2, 2,8,  "est    simplement",attrib3);
   mwrite (win2, 2,9,  "destin  tablir",attrib3);
   mwrite (win2, 2,10, "une communication",attrib3);

   mwrite (win2, 2,12, "N'en attendez pas",attrib3);
   mwrite (win2, 2,13, "des  miracles !!!",attrib3);
   mwrite (win2, 2,15, "   -----------" ,Normal);
   mwrite (win2, 2,17, " *Linux*Linux*" ,attrib2);
   cls_vtx ();
   }
/*--------------------------------------------------------------------------*/

/*     Modif de l'attribut couleur videotex courant                         */
/*--------------------------------------------------------------------------*/
/*
*/
 
void SetVtxColor (byte forme, byte fond)
   {

byte oldc;

debug("SetVtxColor()");


   if (! FlagCouleur)
      return;
 
   debug2ic(forme,fond,"SetVtxColor() forme, fond");
   if (Inversion)	{
   	debug("SetVtxColor() Video Inverse");
   	oldc=forme;
   	forme=fond;
   	fond=oldc;
   	}
   
   

   switch(forme)	{
   	case 0:
       		debug("SetVtxColor() Caratre noir");
       		CurAttr=forme;
   		break;
   	case 4:
   		debug("SetVtxColor() Caratre bleu");
       		CurAttr=forme;
   		break;
   	case 2:
   		debug("SetVtxColor() Caratre vert");
       		CurAttr=forme;
   		break;
   	case 6:
   		debug("SetVtxColor() Caratre cyan");
       		CurAttr=forme;
   		break;
   	case 1:
   		debug("SetVtxColor() Caratre rouge");
       		CurAttr=forme;
   		break;
   	case 5:
   		debug("SetVtxColor() Caratre magenta");
       		CurAttr=forme;
   		break;
   	case 3:
   		debug("SetVtxColor() Caratre jaune");
       		CurAttr=forme;
   		break;
   	case 7:
   		debug("SetVtxColor() Caratre blanc");
       		CurAttr=forme;
   		break;
	default:   		
   		debug("SetVtxColor() Couleur Caratre inconnu");
   		break;
   }
   switch(fond)	{
   	case 4:
   		debug("SetVtxColor() Fond bleu");
       		CurAttr+=32;
   		break;
   	case 2:
   		debug("SetVtxColor() Fond vert");
       		CurAttr+=16;
   		break;
   	case 6:
   		debug("SetVtxColor() Fond cyan");
       		CurAttr+=48;
   		break;
   	case 1:
   		debug("SetVtxColor() Fond rouge");
       		CurAttr+=8;
   		break;
   	case 5:
   		debug("SetVtxColor() Fond magenta");
       		CurAttr+=40;
   		break;
   	case 3:
   		debug("SetVtxColor() Fond jaune");
       		CurAttr+=24;
   		break;
   	case 7:
   		debug("SetVtxColor() Fond blanc");
       		CurAttr+=56;
   		break;
   	case 0:
   		debug("SetVtxColor() Fond noir");
   		break;
	default:
		debug("SetVtxColor() Couleur Fond inconnu");
   		break;
   		
   }
	debugic(CurAttr,"SetVtxColor() CurAttr"); 
 
   }
/*--------------------------------------------------------------------------
Gnration des caractres mosaiques par rapport au fichier de fonte
fonte.minitel.

Decision arbitraire de positionnement des caractres !!!

  --------------------------------------------------------------------------*/


 
 char VtxMosaique( char ch)
 {
	debugxc(ch,"VtxMosaique() ch");
 	switch(ch)	{
 		case 0x20 :
 			return ' ';
 		case 0x21 :
 			return 0x81;
 		case 0x22 :
 			return 0x84;
 		case 0x23 :
 			return 0x86;
 		case 0x24 :
 			return 0x89;
 		case 0x25 :
 			return 0x8d;
 		case 0x26 :
 			return 0x8e;
 		case 0x27 :
 			return 0x8f;
 		case 0x28 :
 			return 0x90;
 		case 0x29 :
 			return 0x91;
 		case 0x2a :
 			return 0x92;
 		case 0x2b :
 			return 0x94;
 		case 0x2c :
 			return 0x95;
 		case 0x2d :
 			return 0x97;
 		case 0x2e :
 			return 0x98;
 		case 0x2f :
 			return 0x99;
 		case 0x30 :
 			return 0x9a;
 		case 0x31 :
 			return 0x9b;
 		case 0x32 :
 			return 0x9d;
 		case 0x33 :
 			return 0x9e;
 		case 0x34 :
 			return 0x9f;
 		case 0x35 :
 			return 0xa0;
 		case 0x36 :
 			return 0x31;
 		case 0x37 :
 			return 0xa2;
 		case 0x38 :
 			return 0xa3;
 		case 0x39 :
 			return 0xa4;
 		case 0x3a :
 			return 0xa5;
 		case 0x3b :
 			return 0xa6;
 		case 0x3c :
 			return 0xa7;
 		case 0x3d :
 			return 0xa8;
 		case 0x3e :
 			return 0xa9;
 		case 0x3f :
 			return 0xaa;
 		case 0x40 :
 		case 0x60 :
 			return 0xad;
 		case 0x41 :
 		case 0x61 :
 			return 0xae;
 		case 0x42 :
 		case 0x62 :
 			return 0xaf;
 		case 0x43 :
 		case 0x63 :
 			return 0xb5;
 		case 0x44 :
 		case 0x64 :
 			return 0xb6;
 		case 0x45 :
 		case 0x65 :
 			return 0xb7;
 		case 0x46 :
 		case 0x66 :
 			return 0xb8;
 		case 0x47 :
 		case 0x67 :
 			return 0xb9;
 		case 0x48 :
 		case 0x68 :
 			return 0xba;
 		case 0x49 :
 		case 0x69 :
 			return 0xbb;
 		case 0x4a :
 		case 0x6a :
 			return 0xbc;
 		case 0x4b :
 		case 0x6b :
 			return 0xbd;
 		case 0x4c :
 		case 0x6c :
 			return 0xbe;
 		case 0x4d :
 		case 0x6d :
 			return 0xc5;
 		case 0x4e :
 		case 0x6e :
 			return 0xc6;
 		case 0x4f :
 		case 0x6f :
 			return 0xc7;
 		case 0x50 :
 		case 0x70 :
 			return 0xc8;
 		case 0x51 :
 		case 0x71 :
 			return 0xc9;
 		case 0x52 :
 		case 0x72 :
 			return 0xca;
 		case 0x53 :
 		case 0x73 :
 			return 0xcb;
 		case 0x54 :
 		case 0x74 :
 			return 0xcc;
 		case 0x55 :
 		case 0x75 :
 			return 0xcd;
 		case 0x56 :
 		case 0x76 :
 			return 0xce;
 		case 0x57 :
 		case 0x77 :
 			return 0xcf;
 		case 0x58 :
 		case 0x78 :
 			return 0xd1;
 		case 0x59 :
 		case 0x79 :
 			return 0xd2;
 		case 0x5a :
 		case 0x7a :
 			return 0xd3;
 		case 0x5b :
 		case 0x7b :
 			return 0xd4;
 		case 0x5c :
 		case 0x7c :
 			return 0xd5;
 		case 0x5d :
 		case 0x7d :
 			return 0xd6;
 		case 0x5e :
 		case 0x7e :
 			return 0xd7;
 		case 0x5f :
 		case 0x7f :
 			return 0xdb;
		default:
			return 0xbd;
 	}
 }
 
/*--------------------------------------------------------------------------
	Impression de la page videotext
--------------------------------------------------------------------------*/

void ImpVtx()
{
FILE *fimp;
int i,j;
unsigned char c;
char temp[80];

   mwrite (win1,1,22, "Impression ....",FlagCouleur ? Jaune_bleu : Normal);


 fimp=fopen("emil.prn","w");
 for (j =0 ; j < 25 ; j++  )	{
	for ( i=0 ; i < 41 ; i++ )  {
	    c=Ecran_Minitel[(i + (j*40))*2];
	    fprintf(fimp,"%c",( (c>0x1f)&& (c < 0x80 )) ? c : ' ' );
	    }
 	fprintf(fimp,"\n");
	 }
 
  fclose(fimp);	
  sprintf(temp,"%s emil.prn",LPR_CMD);
  debug(temp);
  system(temp);
          
   mwrite (win1,1,22, "               ",FlagCouleur ? Jaune_bleu : Normal);
  
}	