/*	
 *   emil - Emulateur MInitel sous Linux
 *
 *   Copyright (C) 1995		Eldin Henry-Pascal
 *
 *	eldin@privas.gatelink.fr.net
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
                                                                      
                 MODULE: TOUCHES.H                                    
                 -----------------                                    
 Definitions des valeurs retournees par la fonction touche() dans     
  clavecra.c                                                          */

#ifndef _TOUCHES_H_
#define _TOUCHES_H_

#ifndef CURSES
#define F1        1059                    /* touches de fonction normales */
#define F2        1060
#define F3        1061
#define F4        1062
#define F5        1063
#define F6        1064
#define F7        1065
#define F8        1066
#define F9        1067
#define F10       1068
#else
#define F1        KEY_F(1)
#define F2        KEY_F(2)
#define F3        KEY_F(3)
#define F4        KEY_F(4)
#define F5        KEY_F(5)
#define F6        KEY_F(6)
#define F7        KEY_F(7)
#define F8        KEY_F(8)
#define F9        KEY_F(9)
#define F10       KEY_F(10)
#endif

#define SHIFT_F1  1084                    /* touches de fonctions + shift */
#define SHIFT_F2  1085
#define SHIFT_F3  1086
#define SHIFT_F4  1087
#define SHIFT_F5  1088
#define SHIFT_F6  1089
#define SHIFT_F7  1090
#define SHIFT_F8  1091
#define SHIFT_F9  1092
#define SHIFT_F10 1093

#define CNTRL_F1  1094                   /* touches de fonctions + CONTROL*/
#define CNTRL_F2  1095
#define CNTRL_F3  1096
#define CNTRL_F4  1097
#define CNTRL_F5  1098
#define CNTRL_F6  1099
#define CNTRL_F7  1100
#define CNTRL_F8  1101
#define CNTRL_F9  1102
#define CNTRL_F10 1103

#define ALT_F1    1104                   /* touches de fonctions + ALT    */
#define ALT_F2    1105
#define ALT_F3    1106
#define ALT_F4    1107
#define ALT_F5    1108
#define ALT_F6    1109
#define ALT_F7    1110
#define ALT_F8    1111
#define ALT_F9    1112
#define ALT_F10   1113



#define ALT_Q     1016                   /* touches normales     + ALT    */
#define ALT_W     1017
#define ALT_E     1018
#define ALT_R     1019
#define ALT_T     1020
#define ALT_Y     1021
#define ALT_U     1022
#define ALT_I     1023
#define ALT_O     1024
#define ALT_P     1025
#define ALT_A     1030
#define ALT_S     1031
#define ALT_D     1032
#define ALT_F     1033
#define ALT_G     1034
#define ALT_H     1035
#define ALT_J     1036
#define ALT_K     1037
#define ALT_L     1038
#define ALT_Z     1044
#define ALT_X     1045
#define ALT_C     1046
#define ALT_V     1047
#define ALT_B     1048
#define ALT_N     1049
#define ALT_M     1050

#define ALT_1     1120
#define ALT_2     1121
#define ALT_3     1122
#define ALT_4     1123
#define ALT_5     1124
#define ALT_6     1125
#define ALT_7     1126
#define ALT_8     1127
#define ALT_9     1128
#define ALT_0     1129


#define CNTRL_A   1                     /* Caractres de contrle          */
#define CNTRL_B   2
#define CNTRL_C   3
#define CNTRL_D   4
#define CNTRL_E   5
#define CNTRL_F   6
#define CNTRL_G   7
#define CNTRL_H   8
#define CNTRL_I   9
#define CNTRL_J   10
#define CNTRL_K   11
#define CNTRL_L   12
#define CNTRL_M   13
#define CNTRL_N   14
#define CNTRL_O   15
#define CNTRL_P   16
#define CNTRL_Q   17
#define CNTRL_R   18
#define CNTRL_S   19
#define CNTRL_T   20
#define CNTRL_U   21
#define CNTRL_V   22
#define CNTRL_W   23
#define CNTRL_X   24
#define CNTRL_Y   25
#define CNTRL_Z   26

#ifndef CURSES
#define GAUCHE          1075            /* pave numerique normal           */
#define DROITE          1077
#define HAUT            1072
#define BAS             1080
#define HOME            1071
#define END             1079
#define PGUP            1073
#define PGDN            1081
#define INSERT          1082
#define DELETE          1083
#else
#define GAUCHE          KEY_LEFT         
#define DROITE          KEY_RIGHT
#define HAUT            KEY_UP
#define BAS             KEY_DOWN
#define HOME            KEY_HOME
#define END             KEY_LL
#define PGUP            KEY_PPAGE
#define PGDN            KEY_NPAGE
#define INSERT          KEY_IC
#define DELETE          0x04
#endif

#define SHIFT_GAUCHE      52            /* Pav numrique + shift          */
#define SHIFT_DROITE      54
#define SHIFT_HAUT        56
#define SHIFT_BAS         50
#define SHIFT_HOME        55
#define SHIFT_END         49
#define SHIFT_PGUP        57
#define SHIFT_PGDN        51
#define SHIFT_INSERT      48
#define SHIFT_DELETE      46

#define CNTRL_GAUCHE    1115            /* Pav numrique + Control       */
#define CNTRL_DROITE    1116
#define CNTRL_HAUT      1160
#define CNTRL_BAS       1164
#define CNTRL_HOME      1119
#define CNTRL_END       1117
#define CNTRL_PGUP      1132
#define CNTRL_PGDN      1118
#define CNTRL_INSERT    1165
#define CNTRL_DELETE    1166





/* diverses touches utilisees  */

#define ESCAPE         27
#define ESC            27

#define ESPACE         32
#define SPACE          32

#define RETOUR         13
#define RC             13
#define CR             13
#define LF             10

#ifndef CURSES
#define TAB            9
#define SHIFT_TAB      1015
#define BACK           8
#define BACK_SPACE     8
#else
#define TAB            KEY_STAB
#define SHIFT_TAB      KEY_CTAB
#define BACK           0x08
#define BACK_SPACE     0x08
#endif

#endif
/*------------------------- FIN DE CLAVIER. H -------------------------------*/